Package: PWMEnrich
Type: Package
Title: PWM enrichment analysis
Version: 4.48.0
Date: 2015-09-25
Author: Robert Stojnic, Diego Diez
Maintainer: Diego Diez <diego10ruiz@gmail.com>
LazyLoad: yes
Description: A toolkit of high-level functions for DNA motif scanning
        and enrichment analysis built upon Biostrings. The main
        functionality is PWM enrichment analysis of already known PWMs
        (e.g. from databases such as MotifDb), but the package also
        implements high-level functions for PWM scanning and
        visualisation. The package does not perform "de novo" motif
        discovery, but is instead focused on using motifs that are
        either experimentally derived or computationally constructed by
        other tools.
License: LGPL (>= 2)
Depends: R (>= 3.5.0), methods, BiocGenerics, Biostrings
Imports: grid, seqLogo, gdata, evd, S4Vectors
Suggests: MotifDb, BSgenome, BSgenome.Dmelanogaster.UCSC.dm3,
        PWMEnrich.Dmelanogaster.background, testthat, gtools, parallel,
        PWMEnrich.Hsapiens.background, PWMEnrich.Mmusculus.background,
        BiocStyle, knitr
biocViews: MotifAnnotation, SequenceMatching, Software
VignetteBuilder: knitr
RoxygenNote: 7.1.1
Encoding: UTF-8
git_url: https://git.bioconductor.org/packages/PWMEnrich
git_branch: RELEASE_3_23
git_last_commit: a817fa3
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 00:01:34 UTC; biocbuild

# Calculate the clover score

#' Calculate the Clover score using the recursive formula from Frith et al
#'
#' @param scores a matrix of average odds scores, where columns are motifs, and rows sequences
#' @param lr3 if to return a matrix of LR3 scores, where columns correpond to motifs, and rows to subset sizes
#' @param verbose if to produce verbose output of progress
#' @return the LR4 score, which is the mean of LR3 scores over subset sizes
cloverScore = function(scores, lr3=FALSE, verbose=FALSE){
	if(is.vector(scores))
		return(scores)

	# LR3 scores
	clover = matrix(0, nrow=nrow(scores), ncol=ncol(scores))
	colnames(clover) = colnames(scores)
	rownames(clover) = rownames(scores)
	
	# iterate over motifs
	for(m.inx in 1:ncol(scores)){
		if(verbose)
			message(paste("Calculating Clover score for motif", m.inx, "/", ncol(scores)))
		s = scores[,m.inx]
		
		N = length(s)
		A = matrix(NA, ncol=N+1, nrow=N+1)
		
		# load initial values
		A[1,] = 1
		for(i in 2:ncol(A)){
			A[i,i-1] = 0
		}
		
		# calculate the A matrix from the paper (Frith et al, NAR, 2004)
		for(i in 2:(N+1)){
			for(j in 2:(N+1)){
				if(j >= i){
					# i,j in their formula
					di = i-1
					dj = j-1
					# i,j is still used to subscript A
					A[i,j] = ( di * s[dj] * A[i-1,j-1] + (dj - di) * A[i,j-1] ) / dj	
				}
			}
		}
		clover[,m.inx] = A[2:(N+1),N+1]
		 
	}
	
	# final score (LR4) is the mean of LR3 scores
	if(lr3)
		clover
	else
		colMeans(clover)
}

#' Calculate the Clover P-value as described in the Clover paper
#'
#' This function only take one background sequence as input, it also just calculates the P-value
#' so it is more efficient. 
#'
#' @param scores the affinity scores for individual sequences
#' @param seq.len lengths of sequences
#' @param pwm.len lengths of PWMs
#' @param bg.fwd the raw score of forward strand
#' @param bg.rev the raw scores of reverse strand
#' @param B the number of random replicates
#' @param verbose if to give verbose progress reports
#' @param clover the clover scores if already calculated
#' @return P-value
cloverPvalue1seq = function(scores, seq.len, pwm.len, bg.fwd, bg.rev, B=1000, verbose=TRUE, clover=NULL){

	if(is.vector(scores))
		scores = matrix(scores, nrow=1, dimnames=list(NULL, names(scores)))

	# length of sequences
	bg.len = nrow(bg.fwd)
	
	if(max(seq.len) > bg.len){
		stop("The maximal string length in 'sequences' is greater than the background length")
	}
	
	# original scores for the set of sequences
	if(is.null(clover))
		original.clover = cloverScore(scores)
	else
		original.clover = clover
	
	# the empricial p-value
	clover.p = rep(0, ncol(scores))
	names(clover.p) = colnames(scores)
	
	# do average over strands
	bg.res = (bg.fwd + bg.rev) / 2
		
	for(i in 1:B){
		if(verbose)
			message("Random sample ", i, " / ", B)
		
		# sample background sequences with the same length distribution
		new.scores = matrix(0, nrow=nrow(scores), ncol=ncol(scores))
		colnames(new.scores) = colnames(scores)
		
		for(j in 1:nrow(scores)){
			# choose a subsequence with matching length
			start.range = 1:(bg.len - seq.len[j])
			start = sample(start.range, 1)
			
			# fetch the scores
			new.scores[j,] = colMeans(bg.res[start:(start+seq.len[j]-1),], na.rm=TRUE)
			
		}

		# calculate scores and clover
		new.clover = cloverScore(new.scores)
		
		clover.p = clover.p + ((new.clover > original.clover) + 0)
		
	}
	
	return(clover.p / B)
}

library(PWMEnrich)
library(testthat)
library(gtools)

# test cloverScore
scores = cbind(c(1, 5, 10, 2), c(5, 4, 3, 1))
colnames(scores) = c("m1", "m2")

clover = PWMEnrich:::cloverScore(scores, lr3=TRUE)

clover.mean = colMeans(clover)

# calculate manually using all subset combinations
s = scores[,1]
lr3 = rep(0, 4)
for(i in 1:4){
	comb = combinations(4, i)
	
	lr3[i] = mean(apply(comb, 1, function(x) prod(s[x])))
}

# clover scores should match
test_that("Clover score", {
	expect_equal(lr3, clover[,1])
})

# managing parallel execution of code

# this global variable records options, e.g. for parallel execution etc
.PWMEnrich.Options = new.env(parent=emptyenv())

#' Register than PWMEnrich can use parallel CPU cores
#'
#' Certain functions (like motif scanning) can be parallelized in PWMEnrich. This function
#' registers a number of parallel cores (via core package parallel) to be used in
#' code that can be parallelized. After this function is called, all further PWMEnrich
#' function calls will run in parallel if possible. 
#'
#' By default parallel execution is turned off. To turn it off after using it, call this
#' function by passing NULL. 
#'
#' @param numCores number of cores to use (default to take all cores), or NULL if no parallel execution is to be used
#' @export
#' @examples
#' \dontrun{
#' registerCoresPWMEnrich(4) # use 4 CPU cores in PWMEnrich
#' registerCoresPWMEnrich() # use maximal number of CPUs
#' registerCoresPWMEnrich(NULL) # do not use parallel execution
#' }
registerCoresPWMEnrich = function(numCores=NA){
	if (!requireNamespace("parallel"))
	    stop("Parallel execution requires package parallel")
	
	if(!is.null(numCores) && is.na(numCores))
		numCores = parallel::detectCores()
	
	assign("numCores", numCores, pos=.PWMEnrich.Options)
}

#' If to use a faster implementation of motif scanning that requires abount 5 to 10 times more memory
#'
#' @param useBigMemory a boolean value denoting if to use big memory implementation
#'
#' @export
#' @examples
#' \dontrun{
#' useBigMemoryPWMEnrich(TRUE) # switch to big memory implementation globally
#' useBigMemoryPWMEnrich(FALSE) # switch back to default implementation
#' }
useBigMemoryPWMEnrich = function(useBigMemory=FALSE){
	assign("useBigMemory", useBigMemory, pos=.PWMEnrich.Options)
}

## functions to calculate motif similarity metrics

#' Returned the aligned motif parts
#'
#' This function takes the offset of first motif relative to second and 
#' chops off the end of both motifs that are not aligned. It returns a list
#' containing only the columns that align. 
#'
#' @param m1 frequency matrix of first motif
#' @param m2 frequency matrix of second motif
#' @param offset a number of nucleotides by which the first motif is offsetted compared to the second
#' @return a list of column-trimmed motifs m1, m2
maxAligned = function(m1, m2, offset){
	if(offset > 0){
		# need to cut off beginning of m2
		m2 = m2[,(offset+1):ncol(m2)]
	} else if(offset < 0){
		# net to cut off beginning of m1
		m1 = m1[,(abs(offset)+1):ncol(m1)]
	}
	
	# make sure we keep matrix 
	if(is.vector(m1))
		m1 = matrix(m1, ncol=1)
	if(is.vector(m2))
		m2 = matrix(m2, ncol=1)
	
	# maximal number of columns that align
	max.col = min(ncol(m1),ncol(m2))
	
	m1 = m1[,1:max.col]
	m2 = m2[,1:max.col]
	
	# make sure we keep it in matrix
	if(is.vector(m1))
		m1 = matrix(m1, ncol=1)
	if(is.vector(m2))
		m2 = matrix(m2, ncol=1)
	
	list(m1, m2)
}

#' Try all motif alignments and return max score
#'
#' This function tries all offsets of motif1 compared to motif2 and returns
#' the maximal (unnormalized) correlation score. 
#'
#' The correlation score is essentially the sum of correlations of individual aligned
#' columns as described in Pietrokovski (1996).
#'
#' @param m1 frequency matrix of motif 1
#' @param m2 frequency matrix of motif 2
#' @param min.align minimal number of basepairs that need to align
#' @param exclude.zero if to exclude offset=0, useful for calculating self-similarity
#' @references Pietrokovski S. Searching databases of conserved sequence regions by aligning protein multiple-alignments. Nucleic Acids Res 1996;24:3836-3845.
#' @return single maximal score
tryAllMotifAlignments = function(m1, m2, min.align=2, exclude.zero=FALSE){
	offset = (-ncol(m1)+min.align):(ncol(m2)-min.align)
	
	if(exclude.zero)
		offset = setdiff(offset, 0)
	
	scores = rep(0, length(offset))
	for(i in 1:length(offset)){
		# get aligned matrices
		aligned = maxAligned(m1, m2, offset[i])
		# convert to probabilities
		aligned.norm = lapply(aligned, function(x) divideRows(x, colSums(x)))
		# scores for first alignment (sum of column-wise correlations)
		scores[i] = sum(sapply(1:ncol(aligned.norm[[1]]), function(i) cor(aligned.norm[[1]][,i], aligned.norm[[2]][,i])))
		
	}
	
	max(scores)
}

#' Check the frequency matrix input parameter for motifSimilarity
#'
#' @param m either a PWM object or a matrix
#' @return corresponding PFM
.inputPFMfromMatrixOrPWM = function(m){
	if(inherits(m, "PWM"))
		return(m@pfm)
	else if(is.matrix(m))
		return(m)
	else
		stop("Input motif needs to be either of class PWM, or a frequency matrix")
}

#' Calculates similarity between two PFMs. 
#'
#' This function calculates the normalized motif correlation as a measure of motif
#' frequency matrix similarity. 
#'
#' This score is essentially a normalized version of the sum of column correlations
#' as proposed by Pietrokovski (1996). The sum is normalized by the average motif
#' length of m1 and m2, i.e. (ncol(m1)+ncol(m2))/2. Thus, for two idential motifs
#' this score is going to be 1. For unrelated motifs the score is going to be typically 
#' around 0. 
#'
#' Motifs need to aligned for this score to be calculated. The current implementation
#' tries all possible ungapped alignment with a minimal of two basepair matching, and 
#' the maximal score over all alignments is returned.
#'
#' Motif 1 is aligned both to Motif 2 and its reverse complement. Thus, the motif
#' similarities are the same if the reverse complement of any of the two motifs
#' is given.  
#'
#' @param m1 matrix with four rows representing the frequency matrix of first motif
#' @param m2 matrix with four rows representing the frequency matrix of second motif
#' @param trim bases with information content smaller than this value will be trimmed off both motif ends
#' @param self.sim if to calculate self similarity (i.e. without including offset=0 in alignment)
#' @references Pietrokovski S. Searching databases of conserved sequence regions by aligning protein multiple-alignments. Nucleic Acids Res 1996;24:3836-3845.
#' @export
#' @examples
#' 
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    # calculate the similarity of tin and vnd motifs (which are almost identical)
#'    motifSimilarity(MotifDb.Dmel.PFM[["tin"]], MotifDb.Dmel.PFM[["vnd"]])
#'
#'    # similarity of two unrelated motifs
#'    motifSimilarity(MotifDb.Dmel.PFM[["tin"]], MotifDb.Dmel.PFM[["ttk"]])
#' }
motifSimilarity = function(m1, m2, trim=0.4, self.sim=FALSE){
	# check input types
	m1 = .inputPFMfromMatrixOrPWM(m1)
	m2 = .inputPFMfromMatrixOrPWM(m2)

	# remove any zero-variance columns
	colSd1 = apply(m1, 2, sd)
	colSd2 = apply(m2, 2, sd)
	
	if(any(colSd1 == 0))
		m1 = m1[,colSd1!=0]

	if(any(colSd2 == 0))
		m2 = m2[,colSd2!=0]
		
	# trim bases with small motif content
	ic1 = motifIC(m1, bycol=TRUE)
	ic2 = motifIC(m2, bycol=TRUE)
	
	# find which columns to keep
	r1 = range(which(ic1 >= trim))
	r2 = range(which(ic2 >= trim))
	
	m1 = m1[,r1[1]:r1[2]]
	m2 = m2[,r2[1]:r2[2]]

	# get max score
	if(self.sim){
		# we don't want offset=0 because then the score would always be 1
		score = tryAllMotifAlignments(m1, m2, exclude.zero=TRUE)
	} else {
		score = max(tryAllMotifAlignments(m1,m2), 
			tryAllMotifAlignments(m1,reverseComplement(m2)))
	}
	
	# normalize the max score by mean motif size
	return(score / mean(c(ncol(m1), ncol(m2))))
	
}

library(PWMEnrich)
library(testthat)

# test function for motif similarity
motifs = readMotifs(system.file(package="PWMEnrich", dir="extdata", file="jaspar-insecta.jaspar"), remove.acc=TRUE)

# check if two things are numerically equal, e.g. to precision of 1e-8
numEqual = function(x, y, prec=1e-8){
	all(abs(x-y) < prec)
}

test_that("motifSimilarity", {
	expect_equal(motifSimilarity(motifs$tin, motifs$tin), 1)
	expect_true(numEqual(motifSimilarity(motifs$tin, motifs$vnd), 0.8785692, 1e-6))
})

setClassUnion("NumericOrMatrix", c("numeric", "matrix"))

#' A class that represents a Position Weight Matrix (PWM)
#'
#' @aliases PWM-class
#' @section Slots: 
#'  \describe{
#'    \item{\code{id}:}{a systematic ID given to this PWM, could include the source, version, etc}
#'    \item{\code{name}:}{the name of the transcription factor (TF) to which the PWM corresponds to}
#'    \item{\code{pfm}:}{Position Frequency Matrix (PFM) from which the PWM is derived}
#'    \item{\code{prior.params}:}{Defines prior frequencies of the four bases (A,C,G,T), a named vector. These will be added to individual values for the PFM and at the same time used as background probabilities}
#'    \item{\code{pwm}:}{Final Position Weight Matrix (PWM) constructed using prior.params with logarithm base 2}
#'  }
#' @export
setClass("PWM", 
	representation = representation(
		id = "character",
		name = "character",
		pfm = "matrix",
		prior.params = "vector",
		pwm = "matrix"
	)
)

#' Lognormal background distribution for a set of PWMs
#'
#' @aliases PWMLognBackground-class
#' @section Slots: 
#'  \describe{
#'    \item{\code{bg.source}:}{textual description of where the background distribution is derived from}
#'    \item{\code{bg.len}:}{the length to which the background is normalized to. This is a vector of values, can have a different value for each motif.}
#'    \item{\code{bg.mean}:}{the mean value of the lognormal distribution at bg.len}
#'    \item{\code{bg.sd}:}{the standard deviation of the lognormal distribution at bg.len}
#'    \item{\code{pwms}:}{the pwms for which the background has been compiled}
#'  }
#' @export
setClass("PWMLognBackground",
	representation = representation(
		bg.source = "character",
		bg.len = "NumericOrMatrix",
		bg.mean = "NumericOrMatrix",
		bg.sd = "NumericOrMatrix",
		pwms = "list"				
	)	
)

#' Hit count background distribution for a set of PWMs
#'
#' @aliases PWMCutoffBackground-class
#' @section Slots: 
#'  \describe{
#'    \item{\code{bg.source}:}{textual description of where the background distribution is derived from}
#'    \item{\code{bg.cutoff}:}{the cutoff score used to find significant motif hits (in log2 odds), either a single value or a vector of values}
#'    \item{\code{bg.P}:}{the density of significant motif hits per nucleotide in background}
#'    \item{\code{pwms}:}{the pwms for which the background has been compiled}
#'  }
#' @export
setClass("PWMCutoffBackground",
	representation = representation(
		bg.source = "character",
		bg.cutoff = "numeric",
		bg.P = "numeric",
		pwms = "list"
	)
) 

#' Background for calculating empirical P-values
#'
#' This object contains raw scores for one very long sequence, thus it can be very large. 
#'
#' @aliases PWMEmpiricalBackground-class
#' @section Slots: 
#'  \describe{
#'    \item{\code{bg.source}:}{textual description of where the background distribution is derived from}
#'    \item{\code{bg.fwd}:}{affinity scores (odds) for the forward strand. PWMs as columns}
#'    \item{\code{bg.rev}:}{affinity scores (odds) for the reverse strand. PWMs as columns}
#'    \item{\code{pwms}:}{the pwms for which the background has been compiled}
#'  }
#' @export
setClass("PWMEmpiricalBackground",
	representation = representation(
		bg.source = "character",
		bg.fwd = "matrix",
		bg.rev = "matrix",
		pwms = "list"
	)
) 

#' Generalized Extreme Values (GEV) background for P-values
#'
#' The three parameters of the GEV distribution are fitted by doing linear regression
#' on log of sequence length. 
#'
#' @aliases PWMGEVBackground-class
#' @section Slots: 
#'  \describe{
#'    \item{\code{bg.source}:}{textual description of where the background distribution is derived from}
#'    \item{\code{bg.loc}:}{linear regression model for estimating the location parameter based on log(L), list of lm objects of PWMs}
#'    \item{\code{bg.scale}:}{linear regression model for estimating the scale parameter based on log(L), list of lm objects of PWMs}
#'    \item{\code{bg.shape}:}{linear regression model for estimating the shape parameter based on log(L), list of lm objects of PWMs}
#'    \item{\code{pwms}:}{the pwms for which the background has been compiled}
#'  }
#' @export
setClass("PWMGEVBackground",
	representation = representation(
		bg.source = "character",
		bg.loc = "list",
		bg.scale = "list",
		bg.shape = "list",
		pwms = "list"				
	)	
)

#' A wrapper class for results of motifEnrichment() that should make it easier to access the results. 
#'
#' Note that this is only a wrapper around a list which is the return value in PWMEnrich 1.3 and as such it
#' provides the same interface as a list (for backward compatibility), with some additional methods. 
#'
#' @aliases MotifEnrichmentResults-class
#' @section Slots: 
#'  \describe{
#'    \item{\code{res}:}{a list of old results with elements such as: sequence.bg, sequence.nobg, group.bg, group.nobg}
#'  }
#' @export
setClass("MotifEnrichmentResults",
	representation = representation(
		res = "list"
	)
)

#' A report class with formatted results of motif enrichment
#'
#' The columns stored in this object will depend on the type of the report (either for group of sequences, or individual sequences).
#'
#' @aliases MotifEnrichmentReport-class
#' @section Slots: 
#'  \describe{
#'    \item{\code{d}:}{a DataFrame object that contains the main tabular report data}
#'    \item{\code{pwms}:}{a list of \code{PWM} objects corresponding to rows of \code{d}}
#'  }
#' @export
setClass("MotifEnrichmentReport",
	representation = representation(
		d = "data.frame",
		pwms = "list"
	)
)

## ----include=FALSE------------------------------------------------------------
library(knitr)
opts_chunk$set(
echo=TRUE,eval=TRUE,cache=FALSE,tidy=FALSE
)

## ----include=FALSE------------------------------------------------------------
library(knitr)
opts_chunk$set(
tidy=FALSE,dev='pdf',
message=FALSE, warning=FALSE
)

## ----style-knitr, eval=TRUE, echo=FALSE, results="asis"--------------------
BiocStyle::latex()

## ----simple,echo=TRUE------------------------------------------------------
library(PWMEnrich)
library(PWMEnrich.Dmelanogaster.background)

# load the pre-compiled lognormal background
data(PWMLogn.dm3.MotifDb.Dmel)

# load the stripe2 sequences from a FASTA file for motif enrichment
sequence = readDNAStringSet(system.file(package="PWMEnrich", 
  dir="extdata", file="stripe2.fa"))
sequence  

# perform motif enrichment!
res = motifEnrichment(sequence, PWMLogn.dm3.MotifDb.Dmel)

report = sequenceReport(res, 1)
report

# plot the motif with P-value < 0.05
plot(report[report$p.value < 0.05], fontsize=7, id.fontsize=6)

## ----stripe2visual,echo=TRUE,fig.width=4,fig.height=4,fig.align='center'----

# extract the 3 PWMs for the TFs we are interested in
ids = c("bcd_FlyReg_FBgn0000166", 
        "gt_FlyReg_FBgn0001150", 
        "Kr")
sel.pwms = PWMLogn.dm3.MotifDb.Dmel$pwms[ids]
names(sel.pwms) = c("bcd", "gt", "Kr")

# scan and get the raw scores
scores = motifScores(sequence, sel.pwms, raw.scores=TRUE)

# raw scores for the first (and only) input sequence
dim(scores[[1]])
head(scores[[1]])

# score starting at position 1 of forward strand
scores[[1]][1, "bcd"]
# score for the reverse complement of the motif, starting at the same position
scores[[1]][485, "bcd"]

# plot
plotMotifScores(scores, cols=c("green", "red", "blue"))

## ----motifEcdf,echo=TRUE,fig.width=4,fig.height=4,fig.align='center'-------
library(BSgenome.Dmelanogaster.UCSC.dm3)

# empirical distribution for the bcd motif
bcd.ecdf = motifEcdf(sel.pwms$bcd, Dmelanogaster, quick=TRUE)[[1]]

# find the score that is equivalent to the P-value of 1e-3
threshold.1e3 = log2(quantile(bcd.ecdf, 1 - 1e-3))
threshold.1e3 

# replot only the bcd motif hits with the P-value cutoff of 1e-3 (0.001)
plotMotifScores(scores, cols="green", sel.motifs="bcd", cutoff=threshold.1e3)

# Convert scores into P-values
pvals = 1 - bcd.ecdf(scores[[1]][,"bcd"])
head(pvals)

## ----tinman,echo=TRUE------------------------------------------------------
library(PWMEnrich.Dmelanogaster.background)

# load the pre-compiled lognormal background
data(PWMLogn.dm3.MotifDb.Dmel)

sequences = readDNAStringSet(system.file(package="PWMEnrich", 
  dir="extdata", file="tinman-early-top20.fa"))
 
res = motifEnrichment(sequences, PWMLogn.dm3.MotifDb.Dmel)

report = groupReport(res)
report

plot(report[1:10], fontsize=7, id.fontsize=5)

## ----tinman-alt,echo=TRUE--------------------------------------------------
report.top = groupReport(res, by.top.motifs=TRUE)

report.top

## ----tinman2,echo=TRUE-----------------------------------------------------
res

# raw scores
res$sequence.nobg[1:5, 1:2]

# P-values
res$sequence.bg[1:5, 1:2]

## ----parallel,echo=TRUE----------------------------------------------------
registerCoresPWMEnrich(4)

## ----parallel-stop,echo=TRUE-----------------------------------------------
registerCoresPWMEnrich(NULL)

## ----bigmem,echo=TRUE------------------------------------------------------
useBigMemoryPWMEnrich(TRUE)

## ----bigmemoff,echo=TRUE---------------------------------------------------
useBigMemoryPWMEnrich(FALSE)

## ----readmotifs,echo=TRUE--------------------------------------------------
library(PWMEnrich.Dmelanogaster.background)

motifs.denovo = readMotifs(system.file(package="PWMEnrich", 
  dir="extdata", file="example.transfac"), remove.acc=TRUE)
  
motifs.denovo  

# convert count matrices into PWMs
genomic.acgt = getBackgroundFrequencies("dm3")
pwms.denovo = toPWM(motifs.denovo, prior=genomic.acgt)

bg.denovo = makeBackground(pwms.denovo, organism="dm3", type="logn", quick=TRUE)

# use new motifs for motif enrichment
res.denovo = motifEnrichment(sequences[1:5], bg.denovo)
groupReport(res.denovo)

## ----bg-investigate,echo=TRUE----------------------------------------------
bg.denovo
bg.denovo$bg.mean

## ----custombg,echo=TRUE----------------------------------------------------
library(PWMEnrich.Dmelanogaster.background)
data(dm3.upstream2000)

# make a lognormal background for the two motifs using only first 20 promoters
bg.seq = dm3.upstream2000[1:20]

# the sequences are split into 100bp chunks and fitted
bg.custom = makeBackground(pwms.denovo, bg.seq=bg.seq, type="logn", bg.len=100,
	bg.source="20 promoters split into 100bp chunks")

bg.custom

## ----sessionInfo,echo=FALSE,results='asis'---------------------------------
toLatex(sessionInfo())

#' Calculate medians of columns
#' @param x a matrix
colMedians = function(x){
	apply(x, 2, median, na.rm=T)
}

#' Calculate standard deviations of columns
#' @param x a matrix
colSds = function(x){
	apply(x, 2, sd, na.rm=T)
}

#' Divide each row of a matrix with a vector
#'
#' @param m matrix to be divided
#' @param v the vector to use for division
divideRows = function(m, v){
	t(apply(m, 1, function(x) x/v))
}


#' Convert DNAStringSet to list of DNAString objects
#'
#' as.list doesn't seem to always work for DNAStringSets, so
#' implementing this ourselves. 
#'
#' @param x an object of class DNAStringSet
DNAStringSetToList = function(x){
	res = list()
	for(i in 1:length(x)){
		res[[i]] = x[[i]]
	}
	
	return(res)
}

#' Concatenata DNA sequences into a single character object
#'
#' @param sequences either a list of DNAString objects, or a DNAStringSet
#' @return a single character string
concatenateSequences = function(sequences){
	if(is.list(sequences)){
		paste(unlist(sapply(sequences, toString)), collapse="")
	} else{
		paste(sequences, collapse="")
	}
}

#' Name of different pieces of information associated with PWM
#'
#' @title Names of variables
#' @name names,PWM
#' @aliases names,PWM-method
#' @param x the PWM object
#' @return the names of the variables
#' @rdname operators-PWM
setMethod("names", signature=signature(x="PWM"), function(x) slotNames(x))

#' Access a property by name
#'
#' @aliases $,PWM-method
#' @param x the PWM object
#' @param name the variable name
#' @rdname operators-PWM
setMethod("$", signature=signature(x="PWM"), function(x, name){
	slot(x, name)
})

#' Length of the motif
#'
#' Returns the motif length, i.e. the number of columns in the PWM.
#'
#' @param x the PWM object
#' @aliases length,PWM-method
#' @rdname operators-PWM
setMethod("length", signature=signature(x="PWM"), function(x){
	ncol(x@pwm)
})

#' Reverse complement for the PWM object
#'
#' Finds the reverse complement of the PWM
#'
#' @aliases reverseComplement,PWM-method
#' @param x an object of type PWM
#' @param ... unused
#' @return an object of type PWM that is reverse complement of x
#' @export
#' @examples
#'
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    reverseComplement(MotifDb.Dmel.PFM[["ttk"]]) # reverse complement of the ttk PWM
#' }
#' 
setMethod("reverseComplement", signature=signature(x="PWM"), function (x, ...) {
	pfm = reverseComplement(x@pfm)
	pwm = reverseComplement(x@pwm)
	
	new("PWM", id=paste(x@id, "-- reverse complement"), name=x@name, pfm=pfm, prior.params=x@prior.params, pwm=pwm)
})

#' show method for PWM
#' @param object the PWM object
setMethod("show", signature=signature(object="PWM"), function(object){
	cat("An object of class 'PWM'\n")
	cat("ID:", object$id, "\n")
	cat("Target name:", object$name, "\n")
	cat("Frequency matrix:\n")
	cat("$pfm\n")
	print(object$pfm)
	cat("Position weight matrix (PWM):\n")
	cat("$pwm\n")
	print(object$pwm)
	cat("With background nucleotide frequencies which also serve as pseudo-count:\n")
	cat("$prior.params\n")
	print(object$prior.params)
})

### Almost all of the functions from seqLogo which are not exported but we need to override seqLogo() function



## get information content profile from PWM
pwm2ic<-function(pwm) {
    npos<-ncol(pwm)
    ic<-numeric(length=npos)
    for (i in 1:npos) {
        ic[i]<-2 + sum(sapply(pwm[, i], function(x) { 
            if (x > 0) { x*log2(x) } else { 0 }
        }))
    }    
    ic
}

## get consensus sequence from PWM
pwm2cons<-function(pwm) {
    if (!is.matrix(pwm)) {warning("pwm argument must be of class matrix")}
    letters <- c("A", "C", "G", "T")
    paste(apply(pwm, 2, function(x){letters[rev(order(x))[1]]}), collapse="")
}

letterA <- function(x.pos,y.pos,ht,wt,id=NULL){
  
  x <- c(0,4,6,10,8,6.8,3.2,2,0,3.6,5,6.4,3.6)
  y <- c(0,10,10,0,0,3,3,0,0,4,7.5,4,4)
  x <- 0.1*x
  y <- 0.1*y

  x <- x.pos + wt*x
  y <- y.pos + ht*y

  if (is.null(id)){
    id <- c(rep(1,9),rep(2,4))
  }else{
    id <- c(rep(id,9),rep(id+1,4))
  }
    
  fill <- c("green","white")
    
  list(x=x,y=y,id=id,fill=fill)
}

## T
letterT <- function(x.pos,y.pos,ht,wt,id=NULL){
  
  x <- c(0,10,10,6,6,4,4,0)
  y <- c(10,10,9,9,0,0,9,9)
  x <- 0.1*x
  y <- 0.1*y

  x <- x.pos + wt*x
  y <- y.pos + ht*y

  if (is.null(id)){
    id <- rep(1,8)
  }else{
    id <- rep(id,8)
  }
  
  fill <- "red"
    
  list(x=x,y=y,id=id,fill=fill)
}

## C
letterC <- function(x.pos,y.pos,ht,wt,id=NULL){
  angle1 <- seq(0.3+pi/2,pi,length=100)
  angle2 <- seq(pi,1.5*pi,length=100)
  x.l1 <- 0.5 + 0.5*sin(angle1)
  y.l1 <- 0.5 + 0.5*cos(angle1)
  x.l2 <- 0.5 + 0.5*sin(angle2)
  y.l2 <- 0.5 + 0.5*cos(angle2)
  
  x.l <- c(x.l1,x.l2)
  y.l <- c(y.l1,y.l2)
  
  x <- c(x.l,rev(x.l))
  y <- c(y.l,1-rev(y.l))
  
  x.i1 <- 0.5 +0.35*sin(angle1)
  y.i1 <- 0.5 +0.35*cos(angle1)
  x.i1 <- x.i1[y.i1<=max(y.l1)]
  y.i1 <- y.i1[y.i1<=max(y.l1)]
  y.i1[1] <- max(y.l1)
  
  x.i2 <- 0.5 +0.35*sin(angle2)
  y.i2 <- 0.5 +0.35*cos(angle2)
  
  x.i <- c(x.i1,x.i2)
  y.i <- c(y.i1,y.i2)
  
  x1 <- c(x.i,rev(x.i))
  y1 <- c(y.i,1-rev(y.i))
  
  x <- c(x,rev(x1))
  y <- c(y,rev(y1))
  
  x <- x.pos + wt*x
  y <- y.pos + ht*y

  if (is.null(id)){
    id <- rep(1,length(x))
  }else{
    id <- rep(id,length(x))
  }
  
  fill <- "blue"
    
  list(x=x,y=y,id=id,fill=fill)
}


## G
letterG <- function(x.pos,y.pos,ht,wt,id=NULL){
  angle1 <- seq(0.3+pi/2,pi,length=100)
  angle2 <- seq(pi,1.5*pi,length=100)
  x.l1 <- 0.5 + 0.5*sin(angle1)
  y.l1 <- 0.5 + 0.5*cos(angle1)
  x.l2 <- 0.5 + 0.5*sin(angle2)
  y.l2 <- 0.5 + 0.5*cos(angle2)
  
  x.l <- c(x.l1,x.l2)
  y.l <- c(y.l1,y.l2)
  
  x <- c(x.l,rev(x.l))
  y <- c(y.l,1-rev(y.l))
  
  x.i1 <- 0.5 +0.35*sin(angle1)
  y.i1 <- 0.5 +0.35*cos(angle1)
  x.i1 <- x.i1[y.i1<=max(y.l1)]
  y.i1 <- y.i1[y.i1<=max(y.l1)]
  y.i1[1] <- max(y.l1)
  
  x.i2 <- 0.5 +0.35*sin(angle2)
  y.i2 <- 0.5 +0.35*cos(angle2)
  
  x.i <- c(x.i1,x.i2)
  y.i <- c(y.i1,y.i2)
  
  x1 <- c(x.i,rev(x.i))
  y1 <- c(y.i,1-rev(y.i))
  
  x <- c(x,rev(x1))
  y <- c(y,rev(y1))
  
  h1 <- max(y.l1)
  r1 <- max(x.l1)
  
  h1 <- 0.4
  x.add <- c(r1,0.5,0.5,r1-0.2,r1-0.2,r1,r1)
  y.add <- c(h1,h1,h1-0.1,h1-0.1,0,0,h1)

  

  if (is.null(id)){
    id <- c(rep(1,length(x)),rep(2,length(x.add)))
  }else{
    id <- c(rep(id,length(x)),rep(id+1,length(x.add)))
  }

  x <- c(rev(x),x.add)
  y <- c(rev(y),y.add)
    
  x <- x.pos + wt*x
  y <- y.pos + ht*y
  
  
  fill <- c("orange","orange")
    
  list(x=x,y=y,id=id,fill=fill)

}



addLetter <- function(letters,which,x.pos,y.pos,ht,wt){
  
  if (which == "A"){
    letter <- letterA(x.pos,y.pos,ht,wt)
  }else if (which == "C"){
    letter <- letterC(x.pos,y.pos,ht,wt)    
  }else if (which == "G"){
    letter <- letterG(x.pos,y.pos,ht,wt)    
  }else if (which == "T"){
    letter <- letterT(x.pos,y.pos,ht,wt)    
  }else{
    stop("which must be one of A,C,G,T")
  }

  letters$x <- c(letters$x,letter$x)
  letters$y <- c(letters$y,letter$y)

  lastID <- ifelse(is.null(letters$id),0,max(letters$id))
  letters$id <- c(letters$id,lastID+letter$id)
  letters$fill <- c(letters$fill,letter$fill)
  letters
}

# methods to extract data from, and subset MotifEnrichmentReport

#' Columns stored in the motif enrichment report
#'
#' @title Names of variables
#' @name names,MotifEnrichmentReport
#' @aliases names,MotifEnrichmentReport-method
#' @param x the MotifEnrichmentReport object
#' @return the names of the variables
#' @rdname operators-MotifEnrichmentReport
setMethod("names", signature=signature(x="MotifEnrichmentReport"), function(x){
	c(names(x@d), "pwms")
})

#' Access a column by name
#'
#' @aliases $,MotifEnrichmentReport-method
#' @param x the MotifEnrichmentReport object
#' @param name the variable name
#' @rdname operators-MotifEnrichmentReport
setMethod("$", signature=signature(x="MotifEnrichmentReport"), function(x, name){
	if(name == "pwms")
		return(x@pwms)
	else
		return(x@d[[name]])
})

#' Subset the report
#'
#' @aliases [,MotifEnrichmentReport-method
#' @param x the MotifEnrichmentReport object
#' @param i the row selector
#' @param j unused
#' @param ... unused
#' @param drop unused (always FALSE)
#' @rdname operators-MotifEnrichmentReport
setMethod("[", signature=signature(x="MotifEnrichmentReport"), function (x, i, j, ..., drop=TRUE){
	d = x@d[i, , drop=FALSE]
	pwms = x@pwms[i]
	
	new("MotifEnrichmentReport", d=d, pwms=pwms)
})

#' show method for MotifEnrichmentReport
#' @param object the MotifEnrichmentReport object
setMethod("show", signature=signature(object="MotifEnrichmentReport"), function(object){
	d = object@d
	pwms = object@pwms

	cat("An object of class 'MotifEnrichmentReport':\n")	
	if(nrow(d) > 20){
		# show only the first 10 and the last one
		dd = rbind(d[1:10, ], "..."=rep("...", ncol(d)), d[nrow(d),])
		print(dd)
	} else {
		print(d)
	}
})

#' Convert a MotifEnrichmentReport into a data.frame object
#'
#' @name as.data.frame,MotifEnrichmentReport-method
#' @aliases as.data.frame
#' @param x the MotifEnrichmentReport object
#' @param row.names unused
#' @param optional unused
#' @param ... unused
#' @export
setMethod("as.data.frame", signature=signature(x="MotifEnrichmentReport"), function (x, row.names = NULL, optional = FALSE, ...){
	x@d
})

### Functions for differential enrichment

#' Test for differential enrichment between two groups of sequences
#'
#' This function calls \code{motifEnrichment} on two groups of sequences and calculates
#' the difference statistics when possible. 
#'
#' @title Differential motif enrichment
#' @param sequences1 First set of sequences. Can be either a single sequence 
#'        (an object of class DNAString), or a list of DNAString objects, or a DNAStringSet object.
#' @param sequences2 Second set of sequences. Can be either a single sequence 
#'        (an object of class DNAString), or a list of DNAString objects, or a DNAStringSet object.
#' @param pwms this parameter can take multiple values depending on the scoring scheme and background correction used.
#'             When the \code{method} parameter is set to "autodetect", the following default algorithms
#'             are going to be used: 
#'        \itemize{
#'           \item if \code{pwms} is a list containing either frequency matrices or a list of PWM objects then
#'                 the "affinity" algorithm is selected. If frequency matrices are given, they are converted 
#'                 to PWMs using uniform background. For best performance, convert frequency matrices to PWMs
#'                 before calling this function using realistic genomic background. 
#'           \item Otherwise, appropriate scoring scheme and background correction are selected based on the
#'                 class of the object (see below). 
#'        }
#' @param score this parameter determines which scoring scheme to use. Following scheme as available:
#'        \itemize{
#'           \item "autodetect" - default value. Scoring method is determined based
#'                 on the type of \code{pwms} parameter. 
#'           \item "affinity" - use threshold-free affinity scores without a background. The \code{pwms}
#'                 parameter can either be a list of frequency matrices, \code{PWM} objects, or a 
#'                 \code{PWMLognBackground} object. 
#'           \item "cutoff" - use number of motif hits above a score cutoff as a measure of enrichment. 
#'                 No background correction is performed. The \code{pwms}
#'                 parameter can either be a list of frequency matrices, \code{PWM} objects, or a 
#'                 \code{PWMCutoffBackground} object.
#'         }
#'            
#' @param bg this parameter determines which background correction to use, if any. 
#'        \itemize{
#'           \item "autodetect" - default value. Background correction is determined based on the type
#'                  of the \code{pwms} parameter. 
#'           \item "logn" - use a lognormal distribution background pre-computed for a set of PWMs.
#'                 This requires \code{pwms} to be of class \code{PWMLognBackground}.
#'           \item "z" - use a z-score for the number of significant motif hits compared to background number of hits.
#'                 This requires \code{pwms} to be of class \code{PWMCutoffBackground}.
#'           \item "none" - no background correction
#'         }
#' @param cutoff the score cutoff for a significant motif hit if scoring scheme "cutoff" is selected. 
#' @param res1 the output of \code{motifEnrichment} if already calculated for \code{sequences1}
#' @param res2 the output of \code{motifEnrichment} if already calculated for \code{sequences2}
#' @param verbose if to produce verbose output
#' @export
#' @examples
#'
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'   # load the background file for drosophila and lognormal correction
#'   data(PWMLogn.dm3.MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")
#'
#'   # get the differential enrichment
#'   diff = motifDiffEnrichment(DNAString("TGCATCAAGTGTGTAGTGTGAGATTAGT"), 
#'     DNAString("TGAACGAGTAGGACGATGAGAGATTGATG"), PWMLogn.dm3.MotifDb.Dmel, verbose=FALSE)
#'
#'   # motifs differentially enriched in the first sequence (with lognormal background correction)
#'   head(sort(diff$group.bg, decreasing=TRUE))
#'
#'   # motifs differentially enriched in the second sequence (with lognormal background correction)
#'   head(sort(diff$group.bg))
#' }
motifDiffEnrichment = function(sequences1, sequences2, pwms, score="autodetect", bg="autodetect", cutoff=log2(exp(4)), verbose=TRUE,
	res1=NULL, res2=NULL){
	# check the input param constrains
	if(!inherits(pwms, c("NULL", "list", "PWMLognBackground", "PWMCutoffBackground"))) {
		stop("pwms needs to be either a list of frequency matrices, list of PWM objects, or an object of class PWMLognBackground or PWMCutoffBackground.")
	}
	
	if(!(score %in% c("autodetect", "affinity", "cutoff"))){
		stop("score needs to be one of: autodetect, affinity, cutoff")
	}
	
	if(!(bg %in% c("autodetect", "logn", "z", "none"))){
		stop("score needs to be one of: autodetect, logn, z, none")
	}

	# results for both groups
	if(is.null(res1))
		res1 = motifEnrichment(sequences1, pwms, score=score, bg=bg, cutoff=cutoff, verbose=verbose)
	if(is.null(res2))
		res2 = motifEnrichment(sequences2, pwms, score=score, bg=bg, cutoff=cutoff, verbose=verbose)
		
	if((res1$score != res2$score) | (res1$bg != res2$bg))
		stop("Supplied motif enrichments for sequences1 and sequences2 use different scoring schemes and/or background corrections")
	
	# we use the same rules to decided on score and bg.. 
	if(score == "autodetect")
		score = res1$score
	if(bg == "autodetect")
		bg = res1$bg

	# calculated differential enrichment
	res = list()
	res$group.nobg = res1$group.nobg - res2$group.nobg	
	
	if(bg == "none")
		res$group.bg = NULL
	else if(bg == "logn")
		res$group.bg = res1$group.norm - res2$group.norm
	else
		res$group.bg = res1$group.bg - res2$group.bg
	
	return(res)
}

# Methods for the different PWMBackground objects

#' show method for PWMLognBackground
#' @param object the PWMLognBackground object
setMethod("show", signature=signature(object="PWMLognBackground"), function(object){
	cat("An object of class '", class(object), "'\n", sep="")
	cat("Background source:", object$bg.source, "\n")
	cat("Fitted on a mean sequence length of", round(mean(object$bg.len)), 
		"for a set of", length(object$pwms), "PWMs\n")
	cat("Lognormal parameters: $bg.mean, $bg.sd\n")
	cat("PWMS: $pwms\n")
})

#' show method for PWMCutoffBackground
#' @param object the PWMCutoffBackground object
setMethod("show", signature=signature(object="PWMCutoffBackground"), function(object){
	cat("An object of class '", class(object), "'\n", sep="")
	cat("Background source:", object$bg.source, "\n")
	cat("Fitted for a set of", length(object$pwms), "PWMs\n")
	cat("Z-score parameters (cutoff is in log2): $bg.cutoff, $bg.P\n")
	cat("PWMS: $pwms\n")
})

#' show method for PWMEmpiricalBackground
#' @param object the PWMEmpiricalBackground object
setMethod("show", signature=signature(object="PWMEmpiricalBackground"), function(object){
	cat("An object of class '", class(object), "'\n", sep="")
	cat("Background source:", object$bg.source, "\n")
	cat("Raw scores for a ", nrow(object$bg.fwd), " bp sequence for ", length(object$pwms), " PWMs\n", sep="")
	cat("Raw scores (odds, not log-odds): $bg.fwd, $bg.rev\n")
	cat("PWMS: $pwms\n")
})

#' show method for PWMGEVBackground
#' @param object the PWMGEVBackground object
setMethod("show", signature=signature(object="PWMGEVBackground"), function(object){
	cat("An object of class '", class(object), "'\n", sep="")
	cat("Background source:", object$bg.source, "\n")
	cat("Generalized extreme value (GEV) distribution fitted for", length(object$pwms), "PWMs\n")
	cat("GEV parameters fitted with linear regressions: $bg.loc, $bg.scale, $bg.shape\n")
	cat("PWMS: $pwms\n")
})


#' Name of different pieces of information associated with PWMLognBackground
#'
#' @title Names of variables
#' @name names,PWMLognBackground
#' @aliases names,PWMLognBackground-method
#' @param x the PWMLognBackground object
#' @return the names of the variables
#' @rdname operators-PWMLognBackground
setMethod("names", signature=signature(x="PWMLognBackground"), function(x) slotNames(x))

#' Access a property by name
#'
#' @aliases $,PWMLognBackground-method
#' @param x the PWMLognBackground object
#' @param name the variable name
#' @rdname operators-PWMLognBackground
setMethod("$", signature=signature(x="PWMLognBackground"), function(x, name){
	slot(x, name)
})

#' Name of different pieces of information associated with PWMCutoffBackground
#'
#' @title Names of variables
#' @name names,PWMCutoffBackground
#' @aliases names,PWMCutoffBackground-method
#' @param x the PWMCutoffBackground object
#' @return the names of the variables
#' @rdname operators-PWMCutoffBackground
setMethod("names", signature=signature(x="PWMCutoffBackground"), function(x) slotNames(x))

#' Access a property by name
#'
#' @aliases $,PWMCutoffBackground-method
#' @param x the PWMCutoffBackground object
#' @param name the variable name
#' @rdname operators-PWMCutoffBackground
setMethod("$", signature=signature(x="PWMCutoffBackground"), function(x, name){
	slot(x, name)
})

#' Name of different pieces of information associated with PWMEmpiricalBackground
#'
#' @title Names of variables
#' @name names,PWMEmpiricalBackground
#' @aliases names,PWMEmpiricalBackground-method
#' @param x the PWMEmpiricalBackground object
#' @return the names of the variables
#' @rdname operators-PWMEmpiricalBackground
setMethod("names", signature=signature(x="PWMEmpiricalBackground"), function(x) slotNames(x))

#' Access a property by name
#'
#' @aliases $,PWMEmpiricalBackground-method
#' @param x the PWMEmpiricalBackground object
#' @param name the variable name
#' @rdname operators-PWMEmpiricalBackground
setMethod("$", signature=signature(x="PWMEmpiricalBackground"), function(x, name){
	slot(x, name)
})

#' Name of different pieces of information associated with PWMGEVBackground
#'
#' @title Names of variables
#' @name names,PWMGEVBackground
#' @aliases names,PWMGEVBackground-method
#' @param x the PWMGEVBackground object
#' @return the names of the variables
#' @rdname operators-PWMGEVBackground
setMethod("names", signature=signature(x="PWMGEVBackground"), function(x) slotNames(x))

#' Access a property by name
#'
#' @aliases $,PWMGEVBackground-method
#' @param x the PWMGEVBackground object
#' @param name the variable name
#' @rdname operators-PWMGEVBackground
setMethod("$", signature=signature(x="PWMGEVBackground"), function(x, name){
	slot(x, name)
})

#' Get the background for a subset of PWMs
#'
#' @aliases [,PWMLognBackground-method
#' @name [,PWMLognBackground-method
#' @param x the PWMLognBackground object
#' @param i the indicies of PWMs
#' @param j unused
#' @param ... unused
#' @param drop unused
#' @rdname subsetting-PWMLognBackground
setMethod("[", "PWMLognBackground", 
function(x, i, j, ..., drop = TRUE){
	if(is.matrix(x@bg.mean)){
		new("PWMLognBackground",
			pwms=x@pwms[i],
			bg.mean=x@bg.mean[,i,drop=FALSE],
			bg.len=x@bg.len[,i,drop=FALSE],
			bg.sd=x@bg.sd[,i,drop=FALSE],
			bg.source=paste(x@bg.source, "--subset")
		)
	} else {		
		new("PWMLognBackground",
			pwms=x@pwms[i],
			bg.mean=x@bg.mean[i],
			bg.len=x@bg.len[i],
			bg.sd=x@bg.sd[i],
			bg.source=paste(x@bg.source, "--subset")
		)
	}
})

#' Get the background for a subset of PWMs
#'
#' @aliases [,PWMCutoffBackground-method
#' @name [,PWMCutoffBackground-method
#' @param x the PWMCutoffBackground object
#' @param i the indicies of PWMs
#' @param j unused
#' @param ... unused
#' @param drop unused
#' @rdname subsetting-PWMCutoffBackground
setMethod("[", "PWMCutoffBackground", 
function(x, i, j, ..., drop = TRUE){		
	new("PWMCutoffBackground",
		pwms=x@pwms[i],
		bg.cutoff=x@bg.cutoff[i],
		bg.P=x@bg.P[i],
		bg.source=paste(x@bg.source, "--subset")
	)
})

#' Get the background for a subset of PWMs
#'
#' @aliases [,PWMEmpiricalBackground-method
#' @name [,PWMEmpiricalBackground-method
#' @param x the PWMEmpiricalBackground object
#' @param i the indicies of PWMs
#' @param j unused
#' @param ... unused
#' @param drop unused
#' @rdname subsetting-PWMEmpiricalBackground
setMethod("[", "PWMEmpiricalBackground",
function(x, i, j, ..., drop = TRUE)
{		
	new("PWMEmpiricalBackground",
		pwms=x@pwms[i],
		bg.fwd=x@bg.fwd[,i,drop=FALSE],
		bg.rev=x@bg.rev[,i,drop=FALSE],
		bg.source=paste(x@bg.source, "--subset")
	)
})

#' Get the background for a subset of PWMs
#'
#' @aliases [,PWMGEVBackground-method
#' @name [,PWMGEVBackground-method
#' @param x the PWMGEVBackground object
#' @param i the indicies of PWMs
#' @param j unused
#' @param ... unused
#' @param drop unused
#' @rdname subsetting-PWMGEVBackground
setMethod("[", "PWMGEVBackground",
function(x, i, j, ..., drop = TRUE)
{		
	new("PWMGEVBackground",
		pwms=x@pwms[i],
		bg.loc=x@bg.loc[i],
		bg.scale=x@bg.scale[i],
		bg.shape=x@bg.shape[i],
		bg.source=paste(x@bg.source, "--subset")
	)
})

#' @keywords internal
"_PACKAGE"

# The following block is used by usethis to automatically manage
# roxygen namespace tags. Modify with care!
## usethis namespace: start
#' @import BiocGenerics Biostrings methods
#' @importFrom grid grid.newpage grid.text grid.polygon grid.xaxis grid.yaxis grid.layout gpar viewport plotViewport dataViewport pushViewport popViewport unit
#' @importFrom grDevices col2rgb palette rgb
#' @importFrom graphics lines par polygon rect text
#' @importFrom stats cor dlnorm ecdf lm median na.omit optimize pchisq plnorm predict.lm qlnorm quantile
#' @importFrom utils data
#' @importFrom S4Vectors metadata
#' @importFrom seqLogo makePWM plot
#' @importFrom evd fgev pgev
#' @importFrom gdata trim
## usethis namespace: end
NULL

# Functions to create background distributions

#' check consistency of bg.seq input parameter
#'
#' @param bg.seq a set of background sequences, either a list of DNAString object or DNAStringSet object
.normalize.bg.seq = function(bg.seq){
	# check if the sequences are in the right format
	if(!inherits(bg.seq, "DNAStringSet")) {
		if(is.list(bg.seq)) {
			if(length(bg.seq) > 0 && ! inherits(bg.seq[[1]], "DNAString"))
				stop("bg.seq needs to be a list of DNAString objects or a DNAStringSet object")
		} else {
			stop("bg.seq needs to be a list of DNAString objects or a DNAStringSet object")
		}
	} #else {
		#bg.seq = DNAStringSetToList(bg.seq)
	#}
	
	return(bg.seq)
}

#' Make priors from background sequences
#'
#' These priors serve both as background nucleotide frequencies and pseudo-counts
#' for PWMs. 
#'
#' @param bg.seq a set of background sequences
#' @param bg.pseudo.count the total pseudocount shared between nucleotides
#' @export
#' @examples
#' # some example sequences
#' sequences = list(DNAString("AAAGAGAGTGACCGATGAC"), DNAString("ACGATGAGGATGAC"))
#' # make priors with pseudo-count of 1 shared between them
#' makePriors(sequences, 1)
makePriors = function(bg.seq, bg.pseudo.count){
	bg.seq = .normalize.bg.seq(bg.seq)

	# start with the count of the first sequence
	acgt.count = alphabetFrequency(bg.seq[[1]])[c("A", "C", "G", "T")]
	acgt.count = acgt.count[c("A", "C", "G", "T")] + acgt.count[c("T", "G", "C", "A")]
	# add ACGT counts for the rest
	if(length(bg.seq) > 1 ){
		for(i in 2:length(bg.seq)){
			cont = alphabetFrequency(bg.seq[[i]])[c("A", "C", "G", "T")]
			# add the counts on the other strand
			cont[c("A", "C", "G", "T")] = cont[c("A", "C", "G", "T")] + cont[c("T", "G", "C", "A")]
			# sum up
			acgt.count = acgt.count + cont
		}
	}
	
	# scale to bg.pseudo.count
	prior = (acgt.count / sum(acgt.count)) * bg.pseudo.count

	return(prior)	
}


#' Make a lognormal background distribution
#'
#' Construct a lognormal background distribution for a set of sequences. 
#' Sequences concatenated are binned in 'bg.len' chunks and lognormal distribution 
#' fitted to them. 
#'
#' @param bg.seq a set of background sequences, either a list of DNAString object or DNAStringSet object
#' @param motifs a set of motifs, either a list of frequency matrices, or a list of PWM objects. If
#'               frequency matrices are given, the background distribution is fitted from bg.seq. 
#' @param bg.pseudo.count the pseudo count which is shared between nucleotides when frequency matrices are given
#' @param bg.len background sequences will be split into tiles of this length (default: 250bp)
#' @param bg.len.sizes background tiles will be joined into bigger tiles containing this much smaller tiles. 
#'                     The default is \code{2^(0:4)}, which with \code{bg.len} translates into 
#'                     250bp, 500bp, 1000bp, 1500bp, 2000bp, 4000bp. Note this is only used in the "human" algorithm.
#' @param bg.source a free-form textual description of how the background was generated
#' @param verbose if to produce verbose output
#' @param algorithm type of algorithm to use, valid values are: "default" and "human".
#' @export
#' @examples
#' \dontrun{
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    # make background for MotifDb motifs using 2kb promoters of all D. melanogaster transcripts 
#' 	  if(requireNamespace("BSgenome.Dmelanogaster.UCSC.dm3")) 
#'      makePWMLognBackground(Dmelanogaster$upstream2000, MotifDb.Dmel.PFM)
#' }
#' }
makePWMLognBackground = function(bg.seq, motifs, bg.pseudo.count=1, bg.len=250, bg.len.sizes=2^(0:4), bg.source="", verbose=TRUE, algorithm="default"){
	# check if the sequences are in the right format
	bg.seq = .normalize.bg.seq(bg.seq)

	# convert to list if a single motif is given
	if(!is.list(motifs))
		motifs = list(motifs)
		
	if(bg.len.sizes[1] != 1)
		stop("First value of 'bg.len.sizes' needs to be 1")
		
	if(!(algorithm %in% c("default", "human")))
		stop("Parameter 'algorithm' needs to be one of: ['default', 'human']")
		
	cat("NOTE: Using the '", 	algorithm, "' algorithm to infer background parameters,\n      ", sep="")
	if(algorithm == "default"){
		cat("appropriate for all organisms except human.\n")
	} else {
		cat("appropriate only for human data.\n")
	}

	# concatenate all the background sequences into a single long sequence
	bg.seq.all = concatenateSequences(bg.seq)
	# generate start and end positions
	bg.seq.start = seq(1, nchar(bg.seq.all)+1, bg.len)
	bg.seq.end = bg.seq.start - 1
	bg.seq.start = bg.seq.start[1:(length(bg.seq.start)-1)]
	bg.seq.end = bg.seq.end[2:length(bg.seq.end)]
	
	# split into bg.len sequences
	bg = DNAStringSet(bg.seq.all, start=bg.seq.start, end=bg.seq.end)
	
	if(length(bg)<1000)
		warnings(paste("The number of chunks of size", bg.len, "is smaller than 1000. This might lead to an non-robust estimate of lognormal distribution parameters."))
	
	# convert motifs to PWM format if neccessary
	if(!inherits(motifs[[1]], "PWM")) {
		prior = makePriors(list(DNAString(bg.seq.all)), bg.pseudo.count)
		pwms = PFMtoPWM(motifs, prior.params = prior)
	} else {
		pwms = motifs
	}
	
	# finally, do motif scanning and calculate mean and sd
	bg.res = motifScores(bg, pwms, verbose=verbose)
	
	# pwm lengths and base lengths
	pwm.len = sapply(pwms, length)
	bg.len.real = bg.len - pwm.len + 1
	
	# do a robust estimate of parameters

	# dnorm with left-censored data and known meanlog
	#
	# x value for which dnorm is needed
	# cen logical vector if the value is censored
	# meanlog meanlog parameter
	# sdlog sdlog parameter
	dlnorm.lcen = function(x, cen, meanlog, sdlog){
		if(sdlog <= 0)
			-Inf
		xn = x[!cen]
		xc = x[cen]

		sum(dlnorm(xn, meanlog, sdlog, log=TRUE)) + sum(plnorm(xc, meanlog, sdlog, lower.tail=TRUE, log.p=TRUE))
	}

	# Negative log-likelihood of left-censored data
	#
	# NOTE: this function assumes xc, cen and meanlog and in environment
	#
	# p set of parameters (in this case only sdlog)
	ll.lcen = function(p){
		-dlnorm.lcen(xc, cen, meanlog, p)
	}	
	
	if(algorithm == "default"){
		# the simple default algorithm
		bg.mean = colMeans(bg.res)
		bg.sd = apply(bg.res, 2, sd)
		
	} else {	
		# a matrix of inferred values that will be averaged over
		bg.mean.mat = bg.sd.mat = matrix(0, nrow=length(bg.len.sizes), ncol=ncol(bg.res))
		colnames(bg.mean.mat) = colnames(bg.sd.mat) = colnames(bg.res)
		if(verbose){
			cat("Parameter estimation...\n")
		}

		# do estimation for different sizes of background
		for(size.inx in 1:length(bg.len.sizes)){
			# current size multiplier
			cur.mul = bg.len.sizes[size.inx]
		
			if(verbose){
				cat("Recording distribution properties for", bg.len * cur.mul, "bp tiles (this may take a while...)\n") 
			}
		
			# summarise bg.res for the current size		
			max.len = nrow(bg.res) %/% cur.mul * cur.mul
			group = (0:(max.len-1)) %/% cur.mul
		
			# group by the groups and do an average
			if(cur.mul == 1){
				bg.res.size = bg.res
			} else {
				# new implementation for faster grouping!
				out = matrix(0, nrow=length(unique(group)), ncol=ncol(bg.res))
				for(i in 1:nrow(out)){
					row.inx = (i-1)*cur.mul+1
					r = bg.res[row.inx,]
		
					for(j in 1:(cur.mul-1)){
						r = r + bg.res[row.inx+j,]
					}
					out[i,] = r / cur.mul
				}
			
				bg.res.size = out
			
				# double-check just in case !
				#bg.res.size = by(bg.res[1:max.len,], group, colMeans)
				#bg.res.size = do.call("rbind", as.list(bg.res.size))
			}
		
			# consistency check
			stopifnot(nrow(bg.res.size) == max.len/cur.mul)
		
			# do robust estimate for each motif
			for(i in 1:ncol(bg.res)){
				if(verbose){
					cat("Estimating parameters for motif", i, "/", ncol(bg.res), "\n")
				}
				x = bg.res.size[,i]
		
				# censor everything below the 75% quantile
				b = quantile(x, 0.75)

				# left-censor data
				xc = x
				xc[x<=b] = b
				cen = rep(FALSE, length(x))
				cen[x<=b] = TRUE

				# meanlog based on median
				meanlog = median(log(x))

				# optimize sdlog
				p = optimize(ll.lcen, c(1e-8, 1e5))
		
				# transform and save
				ml = meanlog
				sl = p$minimum
				mx = exp(ml + (sl^2)/2)
				sx = sqrt((exp(sl^2)-1)*exp(2*ml+sl^2))
	
				# save
				bg.mean.mat[size.inx, i] = mx
				bg.sd.mat[size.inx, i] = sx
			}
		}
			
		# record the values
		bg.mean = bg.mean.mat
		bg.sd = bg.sd.mat
		
		# record the sizes
		bg.len.real = outer(bg.len.sizes, bg.len.real)
		rownames(bg.len.real) = NULL
	}
	
	new("PWMLognBackground", bg.source=bg.source, bg.len=bg.len.real, bg.mean=bg.mean, bg.sd=bg.sd, pwms=pwms)
}


#' Make a cutoff background
#'
#' Make a background based on number of motifs hits above a certain threshold. 
#'
#' @param bg.seq a set of background sequences, either a list of DNAString object or DNAStringSet object
#' @param motifs a set of motifs, either a list of frequency matrices, or a list of PWM objects. If
#'               frequency matrices are given, the background distribution is fitted from bg.seq. 
#' @param cutoff the cutoff at which the background should be made, i.e. at which a motif hit is called significant
#' @param bg.pseudo.count the pseudo count which is shared between nucleotides when frequency matrices are given
#' @param bg.source a free-form textual description of how the background was generated
#' @param verbose if to produce verbose output
#' @export
#' @examples
#' \dontrun{
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    # make background for MotifDb motifs using 2Kb promoters of all D. melanogaster transcripts 
#'    # using a cutoff of 5
#' 	  if(requireNamespace("BSgenome.Dmelanogaster.UCSC.dm3")) 
#'      makePWMCutoffBackground(Dmelanogaster$upstream2000, MotifDb.Dmel.PFM, cutoff=log2(exp(5)))
#' }
#' }
makePWMCutoffBackground = function(bg.seq, motifs, cutoff=log2(exp(4)), bg.pseudo.count=1, bg.source="", verbose=TRUE){
	# check if the sequences are in the right format
	bg.seq = .normalize.bg.seq(bg.seq)
	
	# convert to list if a single motif is given
	if(!is.list(motifs))
		motifs = list(motifs)
	
	# make priors and PWMs
	if(!inherits(motifs[[1]], "PWM")) {
		prior = makePriors(bg.seq, bg.pseudo.count)
		pwms = PFMtoPWM(motifs, prior.params = prior)
	} else {
		pwms = motifs
	}
	
	# scan with cutoff - this gives motif *hit counts*
	bg.res = motifScores(bg.seq, pwms, verbose=verbose, cutoff=cutoff)
	
	seq.len = sapply(bg.seq, length)
	pwm.len = sapply(pwms, length)
	
	# total length of the scanned sequences for each sequence
	total.len = sum(seq.len) - length(seq.len)*(pwm.len-1)
			
	# total number of hits
	total.hits = colSums(bg.res)
	
	# density of binding sites
	bg.P = total.hits / total.len
	
	new("PWMCutoffBackground", bg.source=bg.source, bg.cutoff=cutoff, bg.P=bg.P, pwms=pwms)
}

#' Make an empirical P-value background
#'
#' Make a background appropriate for empirical P-value calculation. The provided set of background
#' sequences is contcatenated into a single long sequence which is then scanned with the motifs
#' and raw scores are saved. This object can be very large. 
#'
#' For reliable P-value calculation the size of the background set needs to be at least seq.len / min.P.value.
#' For instance, to get P-values at a resolution of 0.001 for a single sequence of 500bp, we would need 
#' a background of at least 500/0.001 = 50kb. This ensures that we can make 1000 independent 500bp samples from
#' this background to properly estimate the P-value. For a group of sequences, we would take seq.len to be the
#' total length of all sequences in a group. 
#'
#' @param bg.seq a set of background sequences, either a list of DNAString object or DNAStringSet object
#' @param motifs a set of motifs, either a list of frequency matrices, or a list of PWM objects. If
#'               frequency matrices are given, the background distribution is fitted from bg.seq. 
#' @param bg.pseudo.count the pseudo count which is shared between nucleotides when frequency matrices are given
#' @param bg.source a free-form textual description of how the background was generated
#' @param verbose if to produce verbose output
#' @param ... currently unused (this is for convenience for makeBackground function)
#' @export
#' @examples
#' \dontrun{
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    # make empirical background by saving raw scores for each bp in the sequence. This can be 
#'    # very large in memory!
#' 	  if(requireNamespace("BSgenome.Dmelanogaster.UCSC.dm3")) 
#'      makePWMEmpiricalBackground(Dmelanogaster$upstream2000[1:100], MotifDb.Dmel.PFM)
#' }
#' }
makePWMEmpiricalBackground = function(bg.seq, motifs, bg.pseudo.count=1, bg.source="", verbose=TRUE, ...){
	# check if the sequences are in the right format
	bg.seq = .normalize.bg.seq(bg.seq)
	
	# convert to list if a single motif is given
	if(!is.list(motifs))
		motifs = list(motifs)
	
	# make priors and PWMs
	if(!inherits(motifs[[1]], "PWM")) {
		prior = makePriors(bg.seq, bg.pseudo.count)
		pwms = PFMtoPWM(motifs, prior.params = prior)
	} else {
		pwms = motifs
	}
	
	# scan one very long sequence that is formed by concatenating all sequences
	bg.seq.all = DNAString(concatenateSequences(bg.seq))
	
	bg.res = motifScores(bg.seq.all, pwms, raw.scores=TRUE, verbose=verbose)
	
	bg.len = length(bg.seq.all)
	bg.fwd = bg.res[[1]][1:bg.len,]
	bg.rev = bg.res[[1]][(bg.len+1):(bg.len*2),]
	
	if(length(motifs) == 1){
		bg.fwd = matrix(bg.fwd, ncol=1, dimnames=list(NULL, names(motifs)))
		bg.rev = matrix(bg.rev, ncol=1, dimnames=list(NULL, names(motifs)))
	}
	
	new("PWMEmpiricalBackground", bg.source=bg.source, bg.fwd=bg.fwd, bg.rev=bg.rev, pwms=pwms)
}

#' Construct a cutoff background from empirical background
#'
#' This function takes already calculated empirical background distribution and chooses
#' cutoff for each motif based on P-value cutoff for individual sites. 
#'
#' @param bg.p an object of class PWMEmpiricalBackground
#' @param p.value the P-value used to find cuttoffs for each of the motifs
#' @param bg.source textual description of background source
#' @return an object of type PWMCutoffBackground
#' @export
#' @examples
#' \dontrun{
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    # make empirical background - here we use only 100 sequences for illustrative purposes
#' 	  if(requireNamespace("BSgenome.Dmelanogaster.UCSC.dm3")) 
#'      bg.p = makePWMEmpiricalBackground(Dmelanogaster$upstream2000[1:100], MotifDb.Dmel.PFM)
#'
#'    # use the empirical background to pick a threshold and make cutoff background
#'    makePWMPvalCutoffBackground(bg.p, 0.001)
#' }
#' }
makePWMPvalCutoffBackground = function(bg.p, p.value=1e-3, bg.source=""){
	# extract stuffs
	bg.fwd = bg.p@bg.fwd
	bg.rev = bg.p@bg.rev
	pwms = bg.p@pwms
	
	bg.len = nrow(bg.fwd)
	
	if(bg.len * p.value < 1){
		stop("The P-value is too small for background of this size. Should have at least 1/p.value nucleotides in the background.")
	}
	
	# get cutoffs
	cutoff = structure(rep(0, length(pwms)), names=names(pwms))
	P = structure(rep(0, length(pwms)), names=names(pwms))
	for(i in 1:length(pwms)){
		# join both strands
		all.data = log2(c(bg.fwd[!is.na(bg.fwd[,i]),i], bg.rev[!is.na(bg.rev[,i]),i]))
		
		# stop if not all data is finite, because then there is an error!
		stopifnot(length(is.finite(all.data)) == length(all.data))
		
		# find out the cutoff for 1-p.value
		cutoff[i] = quantile(ecdf(all.data), 1 - p.value)
		# work out the actual P value
		# NOTE: since the distribution is decrete, this won't be exactly the same as 2*P.value but will be quite close
		P[i] = 2 * (sum(all.data >= cutoff[i]) / length(all.data))
	}

	# final object
	new("PWMCutoffBackground", bg.source=bg.source, bg.cutoff=cutoff, bg.P=P, pwms=pwms)
}

#' Construct a P-value cutoff background from a set of sequences
#'
#' This function creates a P-value cutoff background for motif enrichment. 
#'
#' @param bg.seq a set of background sequences, either a list of DNAString object or DNAStringSet object
#' @param motifs a set of motifs, either a list of frequency matrices, or a list of PWM objects. If
#'               frequency matrices are given, the background distribution is fitted from bg.seq. 
#' @param p.value the P-value used to find cuttoffs for each of the motifs
#' @param bg.pseudo.count the pseudo count which is shared between nucleotides when frequency matrices are given
#' @param bg.source textual description of background source
#' @param verbose if to print verbose output
#' @return an object of type PWMCutoffBackground
#' @export
#' @examples
#' \dontrun{
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    # use the empirical background to pick a threshold and make cutoff background
#'    makePWMPvalCutoffBackground(Dmelanogaster$upstream2000, 0.001)
#' }
#' }
makePWMPvalCutoffBackgroundFromSeq = function(bg.seq, motifs, p.value=1e-3, bg.pseudo.count=1, bg.source="", verbose=TRUE){
	# check if the sequences are in the right format
	bg.seq = .normalize.bg.seq(bg.seq)
	
	# convert to list if a single motif is given
	if(!is.list(motifs))
		motifs = list(motifs)
	
	# make priors and PWMs
	if(!inherits(motifs[[1]], "PWM")) {
		prior = makePriors(bg.seq, bg.pseudo.count)
		pwms = PFMtoPWM(motifs, prior.params = prior)
	} else {
		pwms = motifs
	}
	
	# pre-calculate the big sequence motifScoresBigMemory() is faster
	seq.input = .inputParamSequences(bg.seq)
	seq.all = DNAString(concatenateSequences(seq.input))
	
	# get cutoffs
	cutoff = structure(rep(0, length(pwms)), names=names(pwms))
	P = structure(rep(0, length(pwms)), names=names(pwms))
	for(i in 1:length(pwms)){	
		# get the raw values for this motif only!
		bg.res = motifScoresBigMemory(bg.seq, pwms[i], verbose=verbose, raw.scores=TRUE, seq.all=seq.all)
		bg.res = na.omit(unlist(bg.res))
		
		# transform to log2 to get the final data
		all.data = log2(bg.res)
		
		# find out the cutoff for 1-p.value
		cutoff[i] = quantile(ecdf(all.data), 1 - p.value)
		# work out the actual P value
		# NOTE: since the distribution is decrete, this won't be exactly the same as 2*P.value but will be quite close
		P[i] = 2 * (sum(all.data >= cutoff[i]) / length(all.data))
	}

	# final object
	new("PWMCutoffBackground", bg.source=bg.source, bg.cutoff=cutoff, bg.P=P, pwms=pwms)
}

#' Divide total.len into fragments of length len by providing start,end positions
#'
#' @param total.len total available length to be subdivided
#' @param len size of the individual chunk
#' @return a data.frame containing paired up start,end positions
makeStartEndPos = function(total.len, len){
	# make start positions
	start = seq(1, total.len+1, len)
	# make end positions
	end = start - 1
	# pair them up
	start = start[1:(length(start)-1)]
	end = end[2:length(end)]
	
	data.frame(start, end)
}

#' Make a GEV background distribution
#'
#' Construct a lognormal background distribution for a set of sequences. 
#' Sequences concatenated are binned in 'bg.len' chunks and lognormal distribution 
#' fitted to them. 
#'
#' @param bg.seq a set of background sequences, either a list of DNAString object or DNAStringSet object
#' @param motifs a set of motifs, either a list of frequency matrices, or a list of PWM objects. If
#'               frequency matrices are given, the background distribution is fitted from bg.seq. 
#' @param bg.pseudo.count the pseudo count which is shared between nucleotides when frequency matrices are given
#' @param bg.len the length range of background chunks
#' @param bg.source a free-form textual description of how the background was generated
#' @param verbose if to produce verbose output
#' @param fit.log if to fit log odds (instead of odds)
#' @export
#' @examples
#' \dontrun{
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    # make background for MotifDb motifs using 2kb promoters of all D. melanogaster transcripts 
#' 	  if(requireNamespace("BSgenome.Dmelanogaster.UCSC.dm3")) 
#'      makePWMGEVBackground(Dmelanogaster$upstream2000, MotifDb.Dmel.PFM)
#' }
#' }
makePWMGEVBackground = function(bg.seq, motifs, bg.pseudo.count=1, bg.len=seq(200,2000,200), bg.source="", verbose=TRUE, fit.log=TRUE){
	# check if the sequences are in the right format
	bg.seq = .normalize.bg.seq(bg.seq)

	# convert to list if a single motif is given
	if(!is.list(motifs))
		motifs = list(motifs)
		
	# give automatic names
	if(is.null(names(motifs))){
		names(motifs) = paste("Motif", 1:length(motifs), sep="")
	}


	# concatenate all the background sequences into a single long sequence
	bg.seq.all = concatenateSequences(bg.seq)
	
	# convert motifs to PWM format if neccessary
	if(!inherits(motifs[[1]], "PWM")) {
		prior = makePriors(list(DNAString(bg.seq.all)), bg.pseudo.count)
		pwms = PFMtoPWM(motifs, prior.params = prior)
	} else {
		pwms = motifs
	}
		
	# GEV parameters that need to be fitted in linear regression
	params = array(0, dim=c(length(bg.len), 3, length(pwms)), 
		dimnames=list(bg.len, c("loc", "scale", "shape"), names(pwms)))
	
	# iterate over background lengths and fit GEV distributions
	for(i in 1:length(bg.len)){
		if(verbose){
			message("Scanning background of size ", bg.len[i])
		}
		bg.pos = makeStartEndPos(nchar(bg.seq.all), bg.len[i])
		bg = DNAStringSet(bg.seq.all, start=bg.pos$start, end=bg.pos$end)
		
		# scan
		bg.res = motifScores(bg, pwms, verbose=verbose)
		
		# fit GEV for each PWM
		params[i,,] = apply(bg.res, 2, function(x) {
			if(fit.log)
				x = log(x)
			fgev(x, std.err=FALSE)$param[c("loc", "scale", "shape")]
		})
	}
	
	## now fit linear regression for each PWM
	
	bg.loc = lapply(names(pwms), function(pwm.name){
		loc = params[,"loc",pwm.name]
		log.len = log(bg.len)
		lm(loc~log.len)
	})
	names(bg.loc) = names(pwms)
	
	bg.scale = lapply(names(pwms), function(pwm.name){
		scale = params[,"scale",pwm.name]
		log.len = log(bg.len)
		lm(scale~log.len)
	})
	names(bg.scale) = names(pwms)
	
	bg.shape = lapply(names(pwms), function(pwm.name){
		shape = params[,"shape",pwm.name]
		log.len = log(bg.len)
		lm(shape~log.len)
	})
	names(bg.shape) = names(pwms)
	
	# return the object	
	new("PWMGEVBackground", bg.source=bg.source, bg.loc=bg.loc, bg.scale=bg.scale, bg.shape=bg.shape, pwms=pwms)
}

#' Get the promoter sequences either for a named organism such as "dm3" or a BSgenome object
#' 
#' @param organismOrGenome either organism name, e.g. "dm3", or BSgenome object
#' @return a list of: promoters - DNAStringSet of (unique) promoters; organism - name of species; version - genome version
getPromoters = function(organismOrGenome){
	org = organismOrGenome
	sek = NULL
	org.valid = c("dm3", "mm9", "hg19")
	
	# check if it's a valid UCSC name
	if(is.character(org)){
		if(org %in% org.valid){
			sel = org
		} else {
			stop(paste("Unrecognised organism name, valid values are:", paste(org.valid, collapse=", ")))
		}
	# check for a BSgenome object	
	} else if(is(org, "BSgenome")){
	  genome <- metadata(org)[["genome"]]
		if(genome %in% org.valid){
			sel = genome 
		} else {
			stop(paste("Promoter sequences cannot be retrieved automatically for ", genome, ", please provide a set of background sequences explicitely.", sep=""))
		}
	} else {
		stop("The input parameter needs to be a valid genome name ('dm3', 'mm9' or 'hg19') or a set of background sequences.")
	}
	
	e = new.env()
	# get the promoter sequences from the saved object
	if(sel == "dm3"){		
		if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
			data("dm3.upstream2000", package = "PWMEnrich.Dmelanogaster.background", envir=e)
			promoters = e$dm3.upstream2000
			organism = "D. melanogaster"
			version = "dm3"
		} else {
			stop("This function requires the 'PWMEnrich.Dmelanogaster.background' package, please install it.")
		}
	} else if(sel == "mm9"){
		if(requireNamespace("PWMEnrich.Mmusculus.background")){
			data("mm9.upstream2000", package = "PWMEnrich.Mmusculus.background", envir=e)
			promoters = e$mm9.upstream2000
			organism = "M. musculus"
			version = "mm9"
		} else {
			stop("This function requires the 'PWMEnrich.Mmusculus.background' package, please install it.")
		}
	} else if(sel == "hg19"){
		if(requireNamespace("PWMEnrich.Hsapiens.background")){
			data("hg19.upstream2000", package = "PWMEnrich.Hsapiens.background", envir=e)
			promoters = e$hg19.upstream2000
			organism = "H. sapiens"
			version = "hg19"
		} else {
			stop("This function requires the 'PWMEnrich.Hsapiens.background' package, please install it.")
		}
	} else {
		stop("Internal error, should never reach this point!")
	}
	
	list(promoters=promoters, organism=organism, version=version)
}

#' Make a background for a set of position frequency matrices
#'
#' This is a convenience front-end function to compile new backgrounds for a set of PFMs. 
#' Currently only supports D. melanogaster, but in the future should support other common organisms as well. 
#'
#' @param motifs a list of position frequency matrices (4xL matrices)
#' @param organism either a name of the organisms for which the background should be compiled 
#'                 (currently supported names are "dm3", "mm9" and "hg19"), or a \code{BSgenome} object (see \code{BSgenome} package). 
#' @param type the type of background to be compiled. Possible types are: 
#'             \itemize{
#'                 \item "logn" - estimate a lognormal background
#'                 \item "cutoff" - estimate a Z-score background with fixed log-odds cutoff (in log2)
#'                 \item "pval" - estimate a Z-score background with a fixed P-value cutoff. Note that this may require a lot of memory
#'                                since the P-value of motif hits is first estimated from the empirical distribution. 
#'                 \item "empirical" - create an empirical P-value background. Note that this may require a lot of memory (up to 10GB in
#'                                     default "slow" mode (quick=FALSE) for 126 JASPAR motifs and 1000 D. melanogaster promoters).
#'                 \item "GEV" - estimate a generalized extreme value (GEV) distribution background by fitting linear regression to distribution 
#'                               parameters in log space
#'             }
#' @param quick if to preform fitting on a reduced set of 100 promoters. This will not give as good results but is much quicker than fitting to all the promoters (~10k). 
#'              Usage of this parameter is recommended only for testing and rough estimates. 
#' @param bg.seq a set of background sequences to use. This parameter overrides the "organism" and "quick" parameters.
#' @param ... other named parameters that backend function makePWM***Background functions take.
#' @export
#' @author Robert Stojnic, Diego Diez
#' @examples
#' 
#' # load in the two example de-novo motifs
#' motifs = readMotifs(system.file(package = "PWMEnrich", dir = "extdata", file = "example.transfac"), 
#'   remove.acc = TRUE)
#' 
#' \dontrun{
#'   # construct lognormal background
#'   bg.logn = makeBackground(motifs, organism="dm3", type="logn")
#'
#'   # alternatively, any BSgenome object can also be used
#'   if(requireNamespace("BSgenome.Dmelanogaster.UCSC.dm3"))
#'     bg.logn = makeBackground(motifs, organism=Dmelanogaster, type="logn")
#'
#'   # construct a Z-score of hits with P-value background
#'   bg.pval = makeBackground(motifs, organism="dm3", type="pval", p.value=1e-3)
#'
#'   # now we can use them to scan for enrichment in sequences (in this case there is a consensus 
#'   # Tin binding site).
#'   motifEnrichment(DNAString("TGCATCAAGTGTGTAGTG"), bg.logn)
#'   motifEnrichment(DNAString("TGCATCAAGTGTGTAGTG"), bg.pval)
#' }
#' 
makeBackground = function(motifs, organism="dm3", type="logn", quick=FALSE, bg.seq=NULL, ...){
	# check input parameters
	valid.types = c("logn", "cutoff", "pval", "empirical", "GEV")
	if(!(type %in% valid.types)){
		stop(paste("Invalid type, please choose from:", paste(valid.types, collapse=", ")))
	}

	# make sure we have this defined.... 
	if(!hasArg("bg.source"))
		bg.source = NULL
	else
		bg.source = list(...)$bg.source

	# use the explicitely set sequences
	if(!is.null(bg.seq)){
		bg.seq = .normalize.bg.seq(bg.seq)
	} else {
		# get the promoters for the organism
		promoters.all = getPromoters(organism)
		promoters = promoters.all$promoters
	
		if(quick){
			bg.seq = promoters[seq(1, length(promoters), length.out=100)]
			if(is.null(bg.source))
				bg.source = paste(promoters.all$organism, " (", promoters.all$version, ") 100 unique 2kb promoters", sep="")
		} else {
			if(type %in% c("pval")){
				bg.seq = promoters[seq(1, length(promoters), length.out=500)]
				if(is.null(bg.source))
					bg.source = paste(promoters.all$organism, " (", promoters.all$version, ") 500 unique 2kb promoters", sep="")
			} else {
				bg.seq = promoters
				if(is.null(bg.source))
					bg.source = paste(promoters.all$organism, " (", promoters.all$version, ") ", length(promoters), " unique 2kb promoters", sep="")
			}
		}
	}
	
	#bg.seq = DNAStringSetToList(bg.seq)
	
	# capture ... as parameters so we can remove bg.source if present
	# and set the other parameters
	params = list(...)	
	params$bg.seq = bg.seq
	params$motifs = motifs
	params$bg.source = bg.source
	
	# select the human algorithm
	if(type == "logn" && is.character(organism) && organism == "hg19" && !("algorithm" %in% names(params)))
		params$algorithm = "human"
	
	## now run the appropriate backend function
	if(type == "logn"){
		bg = do.call("makePWMLognBackground", params)
	} else if(type == "cutoff"){
		bg = do.call("makePWMCutoffBackground", params)
	} else if(type == "pval"){
		bg = do.call("makePWMPvalCutoffBackgroundFromSeq", params)
	} else if(type == "empirical"){
		bg = do.call("makePWMEmpiricalBackground", params)
	} else if(type == "GEV"){
		bg = do.call("makePWMGEVBackground", params)
	}
	
	return(bg)
}

#' Get the four nucleotides background frequencies
#'
#' Estimate the background frequencies of A,C,G,T on a set of promoters from an organism
#'
#' @param organism either a name of the organisms for which the background should be compiled 
#'                 (supported names are "dm3", "mm9" and "hg19"), a \code{BSgenome} object,
#'                  \code{DNAStringSet}, or list of \code{DNAString} objects
#' @param pseudo.count the number to which the frequencies sum up to, by default 1
#' @param quick if to preform fitting on a reduced set of 100 promoters. This will not give as good results but is much quicker than fitting to all the promoters (~10k). 
#'              Usage of this parameter is recommended only for testing and rough estimates.
#' @export
#' @author Robert Stojnic, Diego Diez
#' @examples
#' \dontrun{
#'   getBackgroundFrequencies("dm3")
#' }
getBackgroundFrequencies = function(organism="dm3", pseudo.count=1, quick=FALSE){
	# bug reported on support.bioconductor.org
	if (inherits(organism, "DNAStringSet")) {
		bg.seq = organism
	} else if (is.list(organism) && length(organism) > 0 && inherits(organism[[1]], "DNAString")) {
		bg.seq = organism
	} else {
		# pick the set of background sequences
		promoters = getPromoters(organism)$promoters
		
		if(quick){
			bg.seq = promoters[seq(1, length(promoters), length.out=100)]
		} else {
			bg.seq = promoters
		}
	}
	#bg.seq = DNAStringSetToList(bg.seq)
	
	makePriors(bg.seq, pseudo.count)
}

#' Calculate the empirical distribution score distribution for a set of motifs
#'
#' @param motifs a set of motifs, either a list of frequency matrices, or a list of PWM objects. If
#'               frequency matrices are given, the background distribution is fitted from bg.seq. 
#' @param organism either a name of the organisms for which the background should be compiled 
#'                 (supported names are "dm3", "mm9" and "hg19"), or a \code{BSgenome} object (see \code{BSgenome} package).
#' @param bg.seq a set of background sequence (either this or organism needs to be specified!). Can be a DNAString or DNAStringSet object.
#' @param quick if to do the fitting only on a small subset of the data (only in combination with \code{organism}). Useful only for code testing!
#' @param pseudo.count the pseudo count which is shared between nucleotides when frequency matrices are given
#' @return a list of \code{ecdf} objects (see help page for \code{ecdf} for usage). 
#' @export
motifEcdf = function(motifs, organism=NULL, bg.seq=NULL, quick=FALSE, pseudo.count=1){
	if(is.null(organism) && is.null(bg.seq)){
		stop("Either the 'organism' or 'bg.seq' parameter need to be specified!")
	}
	
	if(!is.list(motifs))
		motifs = list(motifs)
	
	if(!is.null(bg.seq)){
		# check if the sequences are in the right format
		bg.seq = .normalize.bg.seq(bg.seq)
	} else {
		# take only a single promoter from each of the genes
		promoters = getPromoters(organism)$promoters
		
		if(quick){
			bg.seq = promoters[seq(1, length(promoters), length.out=100)]
		} else {
			bg.seq = promoters
		}
	}
	
	# make priors and PWMs
	if(! inherits(motifs[[1]], "PWM")) {
		prior = makePriors(bg.seq, pseudo.count)
		pwms = PFMtoPWM(motifs, prior.params = prior)
	} else {
		pwms = motifs
	}	
	
	# always use the big memory implementation as it is much faster in typical usage!
	s = motifScoresBigMemory(bg.seq, pwms, raw.scores=TRUE)
	
	# group together distributions for motifs
	s = lapply(1:length(pwms), function(i) na.omit(unlist(lapply(s, function(x) x[,i]))))
	
	# create empirical CDFs and return
	e = lapply(s, ecdf)
	names(e) = names(pwms)
	
	e
}

library(PWMEnrich)
library(testthat)

# check if two things are numerically equal, e.g. to precision of 1e-8
numEqual = function(x, y, prec=1e-8){
	all(abs(x-y) < prec)
}

motifs.denovo = readMotifs(system.file(package="PWMEnrich", dir="extdata", file="example.transfac"), remove.acc=TRUE)

# test that motif reading in works properly
test_that("readMotifs", {
	expect_equal(length(motifs.denovo), 2)
	expect_equal(names(motifs.denovo), c("tin_like_motif", "gata_like_motif"))	
})

# create a GATA motif ACGT 
gata = rbind("A"=c(0, 10, 0, 10), "C"= c(0, 0, 0, 0), "G"=c(10, 0, 0, 0), "T"=c(0, 0, 10, 0) )
gata = t(apply(gata, 1, as.integer))

# GATA PWM and example sequence
gata.pwm = PFMtoPWM(gata)
s = DNAString("AAAAGATAAA")
s1 = DNAString("AAAAAAAAAGATA")

sequences = list(s, s1)

scores = motifScores(s, gata.pwm, raw.scores=T)
scores.count = motifScores(s, gata.pwm, cutoff=log2(exp(5)))

scores2 = motifScores(list(s,s1), gata.pwm)

test_that("motifScores works properly", {
	expect_true(numEqual( scores[[1]][5,1], 2^(gata.pwm$pwm["G",1]*4))) #  hand-calculate PWM score
	expect_equal(nrow(scores[[1]]), 20)
	
	# one significant motif hit
	expect_true( all( scores.count == matrix(1) ) )
	
	expect_equal(dim(scores2), c(2,1))
})

# now do something else
res.affinity = motifEnrichment(s, gata.pwm)
res.cutoff = motifEnrichment(s, gata.pwm, cutoff=log2(exp(5)), score="cutoff")

# check affinity and cutoff scores
test_that("motifEnrichment for raw affinity and cutoff", {
	# check if the affinity is right
	expect_true( numEqual( mean(scores[[1]], na.rm=TRUE), res.affinity$group.nobg[1] ))
	expect_equal( res.cutoff$group.nobg[1], 1)
})

###
# make backgrounds and check scores

# load the testing bg.seq object
load(system.file(package="PWMEnrich", dir="extdata", file="bg.seq-test.RData"))

## make diferent background distributions and use them to scan

bg.logn = makePWMLognBackground(bg.seq, gata.pwm, bg.len=1000)
bg.z5 = makePWMCutoffBackground(bg.seq, gata.pwm, cutoff=log2(exp(5)))

# check if the Z-score calculation works, on background the z-score should be 0 for the group
res.bg.z5 = motifEnrichment(bg.seq, bg.z5)
res.z5 = motifEnrichment(sequences, bg.z5)
test_that("motifEnrichment Z-score", {
	expect_true(numEqual(res.bg.z5$group.bg,0))
	# both sequence have one binding site
	expect_equal(as.vector(res.z5$sequence.nobg), c(1,1))
	# both have 1 binding site, but first sequence is longer
	expect_true(res.z5$sequence.bg[1,1] > res.z5$sequence.bg[2,1]) 
})

# check lognormal results 
res.logn = motifEnrichment(sequences, bg.logn)

# calculate lognormal p-value by hand
mx = bg.logn$bg.mean
sx = bg.logn$bg.sd * sqrt(1000-3) / sqrt(10-3) # first sequence is 10-4+1 = 7bp long

ml = 2*log(mx) - 0.5*log(mx^2+sx^2)
sl = sqrt(-2*log(mx) + log(mx^2+sx^2))

# compare lognormal P-value 
test_that("motifEnrichment P-value", {
	expect_true(numEqual(res.logn$sequence.bg[1,1], plnorm(res.logn$sequence.nobg[1,], meanlog=ml, sdlog=sl, lower.tail=FALSE)))
})

## other backgrounds
test_that("other background produce no error", {
	bg.p = makePWMEmpiricalBackground(bg.seq, gata.pwm)
	
	expect_equal(nrow(bg.p$bg.fwd), 10000)
	expect_equal(nrow(bg.p$bg.rev), 10000)

	bg.1e2 = makePWMPvalCutoffBackground(bg.p, 1e-2)
	expect_equal(length(bg.1e2$bg.cutoff), 1)
	expect_equal(length(bg.1e2$bg.P), 1)
	
	res.bg.1e2 = motifEnrichment(bg.seq, gata.pwm, cutoff=bg.1e2$bg.cutoff, score="cutoff")
})

bg.gev = makePWMGEVBackground(bg.seq, gata.pwm, bg.len=seq(200, 1000, 200))
test_that("GEV", {
	expect_equal(length(bg.gev$bg.loc), 1)
	expect_equal(class(bg.gev$bg.loc[[1]]), "lm")
	expect_equal(class(bg.gev$bg.scale[[1]]), "lm")		
	expect_equal(class(bg.gev$bg.shape[[1]]), "lm")		
})

####
## Differential enrichment

diff.logn = motifDiffEnrichment(s, s1, bg.logn)
diff.z5 = motifDiffEnrichment(s, s1, bg.z5)	
test_that("motifDiffEnrichment", {	
	expect_true(diff.logn$group.bg > 0)
	expect_equal(diff.z5$group.nobg, 0)
	expect_true(diff.z5$group.bg > 0)
})

### test priors calculation
prior = makePriors(list(DNAString(c("AAAACCCCCC"))), 1)
test_that("makePriors", {
	expect_equal(prior, c("A"=0.2, "C"=0.3, "G"=0.3, "T"=0.2))
})


#### Test MotifEnrichmentResults

pfm.all = list(tin_like_motif=motifs.denovo[[1]], gata_like_motif=motifs.denovo[[2]], gata=gata)
motifs.all = PFMtoPWM(pfm.all, name=c("tin", "GATA", "GATA"))

test_that("PFMtoPWM names", {
	expect_equal(sapply(motifs.all, function(x) x$name), c(tin_like_motif="tin", gata_like_motif="GATA", gata="GATA"))
})

# setup stuff for motifEnrichment

bg.logn = makePWMLognBackground(bg.seq, motifs.all)
bg.z5 = makePWMCutoffBackground(bg.seq, motifs.all, cutoff=log2(exp(4)))

sequences = list(DNAString("AAATTTAAGATAAAATTGCGT"), DNAString("AAAAAGATAAAAAAAA"))

res.logn = motifEnrichment(sequences, bg.logn)
res.z5 = motifEnrichment(sequences, bg.z5)

### test new methods for motifEnrichmentResults

test_that("MotifEnrichmentResults methods for logn", {
	expect_equal(names(motifRankingForGroup(res.logn)), c("GATA", "GATA", "tin"))
	expect_equal(names(motifRankingForGroup(res.logn, id=TRUE)), c("gata", "gata_like_motif", "tin_like_motif"))
	expect_equal(motifRankingForGroup(res.logn, rank=TRUE), c("tin"=3, "GATA"=2, "GATA"=1))
	expect_equal(motifRankingForGroup(res.logn, order=TRUE, id=TRUE), c("gata"=3, "gata_like_motif"=2, "tin_like_motif"=1))
	expect_equal(names(motifRankingForGroup(res.logn, unique=TRUE)), c("GATA", "tin"))
	expect_equal(motifRankingForGroup(res.logn, rank=TRUE, unique=TRUE), c("tin"=2, "GATA"=1))
	expect_error(motifRankingForGroup(res.logn, order=TRUE, unique=TRUE))
})

test_that("MotifEnrichmentResults methods for z5", {
	expect_equal(names(motifRankingForGroup(res.z5)), c("GATA", "GATA", "tin"))
	expect_equal(names(motifRankingForGroup(res.z5, id=TRUE)), c("gata_like_motif", "gata", "tin_like_motif"))
	expect_equal(motifRankingForGroup(res.z5, rank=TRUE), c("tin"=3, "GATA"=1, "GATA"=2))
	expect_equal(motifRankingForGroup(res.z5, order=TRUE, id=TRUE), c("gata_like_motif"=2, "gata"=3, "tin_like_motif"=1))
	expect_equal(names(motifRankingForGroup(res.z5, unique=TRUE)), c("GATA", "tin"))
	expect_equal(motifRankingForGroup(res.z5, rank=TRUE, unique=TRUE), c("tin"=2, "GATA"=1))
	expect_error(motifRankingForGroup(res.z5, order=TRUE, unique=TRUE))
})

### test the new parameter to PWMUnscaled
gatan = gata/10
gatan.pwm = PWMUnscaled(gatan, seq.count=10)
gatan.pwm2 = PFMtoPWM(gatan, seq.count=10)
test_that("seq.count parameter", {
	expect_equal(gata.pwm$pfm, gatan.pwm$pfm)
	expect_equal(gata.pwm$pwm, gatan.pwm$pwm)
	expect_equal(gata.pwm$pfm, gatan.pwm2$pfm)
	expect_equal(gata.pwm$pwm, gatan.pwm2$pwm)
})

### define generics, mostly for MotifEnrichmentResults

setGeneric("motifRankingForGroup", function(obj, ...) standardGeneric("motifRankingForGroup"))
setGeneric("motifRankingForSequence", function(obj, ...) standardGeneric("motifRankingForSequence"))

setGeneric("plotTopMotifsGroup", function(obj, ...) standardGeneric("plotTopMotifsGroup"))
setGeneric("plotTopMotifsSequence", function(obj, ...) standardGeneric("plotTopMotifsSequence"))

setGeneric("groupReport", function(obj, ...) standardGeneric("groupReport"))
setGeneric("sequenceReport", function(obj, ...) standardGeneric("sequenceReport"))

#' Plot a PFM (not PWM) using seqLogo
#'
#' @param pfm a matrix where rows are the four nucleotides
#' @param ... additional parameters for plot()
plotPFM = function(pfm, ...){
	plot(makePWM(divideRows(pfm,colSums(pfm))), ...)
}

#' Plotting for the PWM class
#'
#' This function produces a sequence logo (via package seqLogo). 
#'
#' @aliases plot,PWM,missing-method
#' @param x the PWM object
#' @param y unused
#' @param ... other parameters to pass to seqLogo's \code{plot} function
#' @export
#' @examples
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'   data(MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")
#'
#'   # plot the tinman motif from MotifDb
#'   plot(MotifDb.Dmel[["tin"]])
#' }
setMethod("plot", signature=signature(x="PWM", y="missing"), function(x, y, ...){
	pfm = x$pfm
	
	plot(makePWM(divideRows(pfm,colSums(pfm))), ...)	
})

#' Plot mulitple motifs in a single plot
#'
#' Individual motif logos are plotted on a rows x cols grid. This function is a convenience
#' interface for the \code{seqLogoGrid} function that deals with viewpoint placement in a 
#' matrix-like grid layout. 
#'
#' By default will try to make a square grid plot that would fit all the motifs and use
#' list names as captions. 
#'
#' @param pwms a list of PWM objects or frequency matrices
#' @param titles a characater vector of titles for each of the plots
#' @param rows number of rows in the grid
#' @param cols number or cols in the grid
#' @param xmargin.scale the scaling parameter for the X-axis margin. Useful when plotting more than one logo on a page
#' @param ymargin.scale the scaling parameter for the Y-axis margin. Useful when plotting more than one logo on a page
#' @param ... other parameters passed to seqLogoGrid()
#' @export
plotMultipleMotifs = function(pwms, titles=names(pwms), rows=ceiling(sqrt(length(pwms))), 
	cols=ceiling(sqrt(length(pwms))), xmargin.scale=0.4, ymargin.scale=0.4, ...){
	if(!is.list(pwms))
		pwms = list(pwms)
		
	if(length(pwms) != length(titles))
		stop("Number of titles in the 'titles' parameter does not match the number of input motifs")

	# start a new viewport page
	grid.newpage()
	pushViewport(viewport(layout = grid.layout(rows,cols)))
	
	# use the grid layout
	for(i in 1:rows){
		for(j in 1:cols){
			pushViewport(viewport(layout.pos.row = i, layout.pos.col = j))
			 
			# work out which PWM to plot
			inx = (i-1)*cols + j
			# only plot if available
			if( inx <= length(pwms) ){
				pwm = pwms[[inx]]
				if(inherits(pwm, "PWM"))
					pwm = pwm$pfm
				# use the backend functions to plot
				seqLogoGrid(divideRows(pwm,colSums(pwm)), 
					xmargin.scale=xmargin.scale, ymargin.scale=ymargin.scale, title=titles[inx], ...)
			}
			popViewport()
		}
	}
	popViewport()
}

#' Plot the motif enrichment report
#'
#' Plots a graphical version of the motif enrichment report. Note that all values are plotted, if you want to plot only a subset of
#' a report, first select this subset (see examples). 
#'
#' @aliases plot,MotifEnrichmentReport,missing-method
#' @param x a MotifEnrichmentReport object
#' @param y unused
#' @param fontsize font size to use in the plot
#' @param id.fontsize font size to use for the motif IDs
#' @param header.fontsize font size of the header
#' @param widths the relative widths of columns
#' @param ... unused
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    ###
#'    # load the pre-compiled lognormal background
#'    data(PWMLogn.dm3.MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    # scan two sequences for motif enrichment
#'    sequences = list(DNAString("GAAGTATCAAGTGACCAGTAAGTCCCAGATGA"), DNAString("AGGTAGATAGAACAGTAGGCAATGAAGCCGATG"))
#'
#'    res = motifEnrichment(sequences, PWMLogn.dm3.MotifDb.Dmel)
#'
#'    # produce a report for all sequences taken together
#'    r = groupReport(res)
#'
#'    # plot the top 10 most enriched motifs
#'    plot(r[1:10])
#' 
#' }
setMethod("plot", signature=signature(x="MotifEnrichmentReport", y="missing"), function(x, y, fontsize=14, id.fontsize=fontsize, header.fontsize=fontsize, widths=NULL, ...){
	d = x@d
	pwms = x@pwms
	
	rows = nrow(d)+1
	cols = ncol(d)+1 
	
	# some default widths
	if(is.null(widths))
		widths = c(0.05, 0.1, 0.2, 0.36, 0.08, 0.08, 0.08)[1:(ncol(d)+1)]
		
	widths = widths / sum(widths)
	
	if("z.score" %in% colnames(d)){
		names(d) = c("Rank", "Target", "Motif ID", "Raw score", "Z score", "In top\nmotifs")[1:ncol(d)]
	} else {
		names(d) = c("Rank", "Target", "Motif ID", "Raw score", "P-value", "In top\nmotifs")[1:ncol(d)]
	}
	
	# start a new viewport page
	grid.newpage()
	pushViewport(viewport(layout = grid.layout(rows, cols, widths=widths)))
	
	# use the grid layout
	for(ii in 1:rows){
		for(j in 1:cols){
			pushViewport(viewport(layout.pos.row = ii, layout.pos.col = j))
						
			# figure out which column to plot
			if(j <= 2){ 
				inx = j
			} else {
				inx = j - 1
			}
			
			if(ii == 1){
				# header
				if(j == 3)
					grid.text("PWM", gp=gpar(fontsize=header.fontsize, fontface="bold"))
				else
					grid.text(names(d)[inx], gp=gpar(fontsize=header.fontsize, fontface="bold"))
				
			} else {
				# rest of the table
				i = ii - 1

				# 3rd column is PWM			
				if(j == 3){			
					pwm = pwms[[i]]$pfm
					# use the backend functions to plot
					seqLogoGrid(divideRows(pwm,colSums(pwm)), 
						xmargin.scale=0.01, ymargin.scale=0.01, xaxis=FALSE, yaxis=FALSE, ...)
				} else {
					if(inx == 6){
						grid.text(paste(round(d[i,inx]*100), "%"), gp=gpar(fontsize=fontsize))
					} else if(inx == 3){
						grid.text(d[i,inx], gp=gpar(fontsize=id.fontsize))
					} else if(inx > 3){
						grid.text(signif(d[i,inx],3), gp=gpar(fontsize=fontsize))
					} else {
						grid.text(d[i,inx], gp=gpar(fontsize=fontsize))
					}
				}
			}
				
			popViewport()
		}
	}
	popViewport()
})

#' Draw a motif logo on an existing viewport
#'
#' This function comes from the seqLogo package. It has been modified to remove 
#' some unneccessary code as suggested by W Huber (https://stat.ethz.ch/pipermail/bioconductor/2010-September/035267.html).
#' 
#' Use this function for more advanced plotting where the viewports are directly set up and maintained (see package \code{grid}). 
#'
#' @param pwm numeric The 4xW position weight matrix.
#' @param ic.scale logical If TRUE, the height of each column is proportional to its information
#'                 content. Otherwise, all columns have the same height.
#' @param xaxis logical If TRUE, an X-axis will be plotted.
#' @param yaxis logical If TRUE, a Y-axis will be plotted.
#' @param xfontsize numeric Font size to be used for the X-axis.
#' @param yfontsize numeric Font size to be used for the Y-axis.
#' @param xmargin.scale the scaling parameter for the X-axis margin. Useful when plotting more than one logo on a page
#' @param ymargin.scale the scaling parameter for the Y-axis margin. Useful when plotting more than one logo on a page
#' @param title to be shown on the top
#' @param titlefontsize the fontsize of the title
#' @export
seqLogoGrid <- function(pwm, ic.scale=TRUE, xaxis=TRUE, yaxis=TRUE, xfontsize=10, yfontsize=10, xmargin.scale=1, ymargin.scale=1, title="",
	titlefontsize=15){

  if (inherits(pwm, "pwm")){
    pwm <- pwm@pwm    
  }else if (is.data.frame(pwm)){
    pwm <- as.matrix(pwm)
  }else if (!is.matrix(pwm)){
    stop("pwm must be of class matrix or data.frame")
  }

  if (any(abs(1 - apply(pwm,2,sum)) > 0.01))
    stop("Columns of PWM must add up to 1.0")

  
  chars <- c("A","C","G","T")
  letters <- list(x=NULL,y=NULL,id=NULL,fill=NULL)
  npos <- ncol(pwm)

  
  if (ic.scale){
    ylim <- 2
    ylab <- "Information content"
    facs <- pwm2ic(pwm)
  }else{
    ylim <- 1
    ylab <- "Probability"
    facs <- rep(1, npos)
  }
  
  wt <- 1  
  x.pos <- 0  
  for (j in 1:npos){
    
    column <- pwm[,j]
    hts <- 0.95*column*facs[j]
    letterOrder <- order(hts)
        
    y.pos <- 0    
    for (i in 1:4){
      letter <- chars[letterOrder[i]]
      ht <- hts[letterOrder[i]]
      if (ht>0) letters <- addLetter(letters,letter,x.pos,y.pos,ht,wt)
      y.pos <- y.pos + ht + 0.01
    }
    x.pos <- x.pos + wt
  }

  bottomMargin = ifelse(xaxis, 2 + xfontsize/3.5, 2) * ymargin.scale
  leftMargin = ifelse(yaxis, 2 + yfontsize/3.5, 2) * xmargin.scale
  rightMargin = 2 * xmargin.scale
  topMargin = 2 * ymargin.scale
  
  pushViewport(plotViewport(c(bottomMargin,leftMargin,topMargin,rightMargin)))
  pushViewport(dataViewport(0:ncol(pwm),0:ylim,name="vp1"))
  grid.polygon(x=unit(letters$x,"native"), y=unit(letters$y,"native"),
               id=letters$id,
               gp=gpar(fill=letters$fill,col="transparent"))

  # put in the title
  grid.text(title, y=1.1, vjust=0, gp=gpar(fontsize=titlefontsize))
               
  if (xaxis){
    grid.xaxis(at=seq(0.5,ncol(pwm)-0.5),label=1:ncol(pwm), gp=gpar(fontsize=xfontsize))
    grid.text("Position",y=unit(-3,"lines"), gp=gpar(fontsize=xfontsize))
  }
  if (yaxis){
    grid.yaxis(gp=gpar(fontsize=yfontsize))
    grid.text(ylab,x=unit(-3,"lines"),rot=90, gp=gpar(fontsize=yfontsize))
  }
  popViewport()
  popViewport()
}

#' Plot the raw motifs scores as returned by motifScores()
#' 
#' This function visualises the motif scores for one or more sequences. Sequences are drawn as lines, and scores are plotted
#' as triangles at both sides of the line (corresponding to the two strands). The width of the base of the triangle corresponds to motif width and 
#' the height to the motif \code{log(score)} that is positive and greater than the \code{cutoff} parameter (if specified). All scores
#' have the same y-axis, so the heights of bars are comparable between sequences and motifs.
#' 
#' @param scores the list of motifs scores. Each element of the list is a matrix of scores for one sequences. The columns in the matrix
#'               correspond to different motifs. Each column contains the odds (not log-odds!) scores over both strands. For example, 
#'               for a sequence of length 5, scores for a 3 bp motifs could be: \code{c(0.1, 1, 4, NA, NA, 1, 0.3, 2, NA, NA)}. The first
#'               3 numbers are odds scores starting at first three bases, and the second lot of 3 numbers is the scores starting at the
#'               same positions but with the reverse complement of the motif. The last two values are NA on both strands because we do not
#'               support partial motif hits.
#' @param sel.motifs a vector of motif names. Use this parameter to show the motif hits to only a subset of motifs for which the scores are available.
#' @param seq.names a vector of sequence names to show in the graph. If none specified, the sequences will be named Sequence 1, Sequence 2, ...
#' @param cols a vector of colours to use to colour code motif hits. If none are specified, the current palette will be used. 
#' @param cutoff either a single value, or a vector of values. The values are PWM cutoffs after \code{log.fun} (see below). Only motif scores above these cutoffs will be shown. 
#'               If a single values is specified, it will be used for all PWMs, otherwise the vector needs to specify one cutoff per PWM. 
#' @param log.fun the logarithm function to use to calculate log-odds. By default log2 is used for consistency with Biostrings.               
#' @param main the main title
#' @param legend.space the proportion of horizontal space to reserve for the legend. The default is 30\%.
#' @param max.score the maximal log-odds score used to scale all other scores. By default this values is automatically determined, but it can
#'                  also be set manually to make multiple plots comparable. 
#' @param trans the level of transparency. By default 50\% transparency to be able to see overlapping binding sites
#' @param text.cex the scaling factor for sequence names
#' @param legend.cex the scaling factor for the legend
#' @param motif.names optional vector of motif names to show instead of those present as column names in \code{scores}
#' @param seq.len.spacing the spacing (in bp units) between the end of the sequence line and the text showing the length in bp
#' @param shape the shape to use to draw motif occurances, valid values are "rectangle" (default), "line" and "triangle"
#' @export
#' @examples
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    ###
#'    # Load Drosophila PWMs
#'    data(MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    # two sequences of interest
#'    sequences = list(DNAString("GAAGTATCAAGTGACCAGGTGAAGTCCCAGATGA"), 
#'      DNAString("AGGTAGATAGAACAGTAGGCAATGAAGCCGATG"))
#'
#'    # select the tinman and snail motifs
#'    pwms = MotifDb.Dmel[c("tin", "sna")]
#'
#'    # get the raw score that will be plotted
#'    scores = motifScores(sequences, pwms, raw.scores=TRUE)
#'
#'    # plot the scores in both sequences, green for tin and blue for sna
#'    plotMotifScores(scores, cols=c("green", "blue"))
#'     
#' }
plotMotifScores = function(scores, sel.motifs=NULL, seq.names=NULL, cols=NULL, cutoff=NULL, log.fun=log2, main="", legend.space=0.30, max.score=NULL,
	trans=0.5, text.cex=0.9, legend.cex=0.9, motif.names=NULL, seq.len.spacing=8, shape="rectangle"){
	# subset motifs
	if(!is.null(sel.motifs)){
		scores = lapply(scores, function(x) x[, sel.motifs, drop=FALSE])
	}	
	
	if(length(unique(sapply(scores, ncol)))!=1){
		stop("All elements of the 'scores' list need to have matrices with the same number of columns.")
	}
	
	if(!(shape %in% c("line", "triangle", "rectangle"))){
		stop("'shape' parameter needs to be 'rectangle', 'line' or 'triangle'")
	}
	
	# reverse the scores for plotting order!
	scores = rev(scores)

	# number of sequences
	num.seq = length(scores)
	# maximal sequence length
	seq.len = sapply(scores, nrow)/2
	max.seq.len = max(seq.len)
	
	# find out the length of each motif by the number of NAs
	motif.len = apply(scores[[1]], 2, function(x) sum(is.na(x))/2 + 1)
	num.motifs = length(motif.len)
	
	# threshold the signal
	if(is.null(cutoff)){
		cutoff = rep(0, num.motifs)
	} else if(length(cutoff) == 1) {
		cutoff = rep(cutoff, num.motifs)
	} else if(length(cutoff) != num.motifs){
		stop("The length of 'cutoff' does not match the number of shown motifs")
	}
	
	# do the log of scores
	scores = lapply(scores, log.fun)
	
	# apply the cutoff to the scores
	scores = lapply(scores, function(s){
		for(i in 1:ncol(s)){
			sel = which(s[,i] <= cutoff[i])
			if(length(sel) > 0)
				s[sel,i] = 0
		} 
		s
	})
	
	# the largest score to use to scale all scores
	if(is.null(max.score))
		max.score = max(sapply(scores, function(s) max(s, na.rm=TRUE)))
	
	############# PLOTING #############
	
	if(is.null(cols)){
		pal = palette()
		cols = pal[ (1:num.motifs) %% length(pal) ]
	}
		
	# add transparency
	cols.rgb = col2rgb(cols)
	cols.rgb = rbind(cols.rgb, "alpha"=(1-trans)*255) / 255
	
	for(i in 1:length(cols)){
		cols[i] = rgb(cols.rgb[1, i], cols.rgb[2, i], cols.rgb[3, i], cols.rgb[4, i])
	}
	
	
	# set up the empty plotting area
	ylim = c(0, 2*num.seq)
	xlim = c(0, max.seq.len/(1-legend.space)) # allow for extra space for the legend
	
	par(mar=c(0,0,2,1))
	plot(NULL, xlim=xlim, ylim=ylim, xaxt="n", yaxt="n", ylab="", xlab="", bty="n", main=main)
	
	# plot the lines corresponding to the sequences
	for(i in 1:num.seq){
		y = 1+(i-1)*2
		lines(c(1, seq.len[i]+1), c(y, y))
		# ticks at the dn
		lines(c(1,1), c(y-0.03, y+0.03))
		lines(c(seq.len[i]+1, seq.len[i]+1), c(y-0.03, y+0.03))
	}
	
	
	# now plot the signal
	for(i in 1:num.seq){
		s = scores[[i]]
		
		# the basic y axis
		y = 1+(i-1)*2
		
		# iterate over motifs
		for(j in 1:ncol(s)){
			by.strand = matrix(s[,j], ncol=2)
			for(k in 1:2){
				x.start = which(by.strand[,k] > 0)
				x.end = x.start + motif.len[j]
				
				y.start = rep(y, length(x.start))
				if(k == 1){
					# multiply by 0.8 to leave some space between sequences!
					y.end = y.start + by.strand[x.start,k] / max.score * 0.8
				} else {
					y.end = y.start - by.strand[x.start,k] / max.score * 0.8
				}
				
				for(kk in 1:length(x.start)){
					if(shape == "triangle"){
						polygon(c(x.start[kk], x.end[kk], (x.start[kk]+x.end[kk])/2), c(y.start[kk], y.start[kk], y.end[kk]), col=cols[j], border=cols[j])
					} else if(shape == "rectangle"){
						rect(x.start[kk], y.start[kk], x.end[kk], y.end[kk], col=cols[j], border=cols[j])
					} else {
						xmid = (x.start[kk]+x.end[kk])/2
						rect(xmid-0.5, y.start[kk], xmid+0.5, y.end[kk], col=cols[j], border=cols[j])
					}
				}
			}
		}
	}
	
	# find out max scores for each motif separately
	max.score.motif = sapply(1:num.motifs, function(i){
		max(sapply(scores, function(s) max(s[,i], na.rm=TRUE)))
	})
	
	# set up the legend
	if(is.null(motif.names))
		motif.names = colnames(scores[[1]])
		
	legend = paste(motif.names, " (", round(max.score.motif, 2), " max)", sep="")
	legend("topright", pch=rep(15, num.motifs), col=cols, legend=legend, cex=legend.cex)
	
	# plot sequence names
	if(is.null(seq.names)){
		if(is.null(names(scores)))
			seq.names = paste("Sequence", 1:length(scores))
		else
			seq.names = names(scores)
	}
	
	seq.names = rev(seq.names)
		
	for(i in 1:length(seq.names)){
		y = 1+(i-1)*2 + 1
		text(1, y, seq.names[i], adj=0, cex=text.cex)
	}
	
	# plot the lengths of sequences
	for(i in 1:length(seq.len)){
		y = 1+(i-1)*2
		x = seq.len[i] + seq.len.spacing
		
		text(x, y, paste(seq.len[i], "bp"), adj=0, cex=text.cex*0.8)
	}
}

# Globals from Biostrings
DNA_BASES = c("A", "C", "G", "T")
DNA_ALPHABET = c("A", "C", "G", "T", "M", "R", "W", "S", "Y", "K", "V", "H", "D", "B", "N", "-", "+")

#' Input parameter normalization function for PWMUnscaled
#'
#' This function is from Biostrings package
#'
#' @param prior.params Typical 'prior.params' vector: c(A=0.25, C=0.25, G=0.25, T=0.25)
.normargPriorParams <- function(prior.params)
{
    if (!is.numeric(prior.params))
        stop("'prior.params' must be a numeric vector")
    if (length(prior.params) != length(DNA_BASES) ||
        !setequal(names(prior.params), DNA_BASES))
        stop("'prior.params' elements must be named A, C, G and T")
    ## Re-order the elements.
    prior.params <- prior.params[DNA_BASES]
    if (any(is.na(prior.params)) || any(prior.params < 0))
        stop("'prior.params' contains NAs and/or negative values")
    prior.params
}

#' Input parameter normalization for PWMUnscaled
#'
#' This function is from Biostrings package.
#' A Position Frequency Matrix (PFM) is also represented as an ordinary
#' matrix. Unlike a PWM, it must be of type integer (it will typically be
#' the result of consensusMatrix()).
#'
#' @param x a frequency matrix
.normargPfm <- function(x)
{
    if (!is.matrix(x) || !is.integer(x))
        stop("invalid PFM 'x': not an integer matrix")
    ## Check the row names.
    if (is.null(rownames(x)))
        stop("invalid PFM 'x': no row names")
    if (!all(rownames(x) %in% DNA_ALPHABET))
        stop("invalid PFM 'x': row names must be in 'DNA_ALPHABET'")
    if (!all(DNA_BASES %in% rownames(x)))
        stop("invalid PFM 'x': row names must contain A, C, G and T")
    if (any(duplicated(rownames(x))))
        stop("invalid PFM 'x': duplicated row names")
    ## Check the nb of cols.
    if (ncol(x) == 0L)
        stop("invalid PFM 'x': no columns")
    ## Check the values.
    if (any(is.na(x)) || any(x < 0L))
        stop("invalid PFM 'x': values cannot be NA or negative")
    if (any(x[!(rownames(x) %in% DNA_BASES), ] != 0L))
        stop("invalid PFM 'x': IUPAC ambiguity letters are represented")
    x <- x[DNA_BASES, , drop=FALSE]
    x
}

#' The PWM function from Biostrings without unit scaling
#'
#' By default the Biostrings package scales the log-odds score so it is within 0 and 1. In this function
#' we take a more traditional approach with no unit scaling and offer unit scaling as an additional parameter.
#'
#' See ?PWM from Biostrings for more information on input arguments. 
#'
#' @title Create a PWM from PFM
#' @param x the integer count matrix representing the motif, rows as nucleotides
#' @param id a systematic ID given to this PWM, could include the source, version, etc
#' @param name the name of the transcription factor (TF) to which the PWM corresponds to
#' @param type the type of PWM calculation, either as log2-odds, or posterior probability (frequency matrix)
#' @param prior.params the pseudocounts for each of the nucleotides 
#' @param pseudo.count the pseudo-count values if different from priors
#' @param unit.scale if to unit.scale the pwm (default is no unit scaling)
#' @param seq.count if x is a normalised PFM (i.e. with probabilities instead of sequence counts), then this sequence count
#'                  will be used to convert \code{x} into a count matrix
#' @return a new PWM object representing the PWM 
#' @export
#' @examples
#'
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    ttk = MotifDb.Dmel.PFM[["ttk"]]
#'    
#'    # make a PWM with uniform background
#'    PWMUnscaled(ttk, id="ttk-JASPAR", name="ttk")
#'    
#'    # custom background
#'    PWMUnscaled(ttk, id="ttk-JASPAR", name="ttk", 
#'      prior.params=c("A"= 0.2, "C" = 0.3, "G" = 0.3, "T" = 0.2))
#'
#'    # get background for drosophila (quick mode on a reduced dataset)
#'    prior = getBackgroundFrequencies("dm3", quick=TRUE)
#'    
#'    # convert using genomic background
#'    PWMUnscaled(ttk, id="ttk-JASPAR", name="ttk", prior.params=prior)
#' }
#'
PWMUnscaled = function(x, id="", name="", type=c("log2probratio", "prob"), prior.params=c(A=0.25, C=0.25, G=0.25, T=0.25), pseudo.count=prior.params, 
	unit.scale=FALSE, seq.count=NULL){
	
	# convert to PFM if needed
	if(!is.null(seq.count)){
		x = apply(round(x * seq.count), 1:2, as.integer)
	}
	
	# match input params
    x <- .normargPfm(x)
    nseq <- colSums(x)
    type <- match.arg(type)
    prior.params <- .normargPriorParams(prior.params)
    
    # total prior added
    priorN <- sum(prior.params)
    
    # posterior probabilities with unequal number of counts per row
    postProbs <- divideRows(x + prior.params, nseq + priorN)
    rownames(postProbs) = rownames(x)
    colnames(postProbs) = colnames(x)
    
    # calculate logodds, or return probabilities
    if (type == "log2probratio") {
        if (any(prior.params == 0)) 
            stop("infinite values in PWM due to 0's in 'prior.params'")
        prior.probs <- prior.params/priorN
        ans <- log2(postProbs/prior.probs)
    }
    else {
        ans <- postProbs
    }
    
    # if to apply unit.scale
    if(unit.scale)
	   	ans = unitScale(ans)
	   	
	# return an object 
	new("PWM", id=id, name=name, pfm=x, prior.params=prior.params, pwm=ans)
}

#' Scan the whole sequence on both strands
#'
#' The whole sequence is scanned with a PWM and scores returned beginning at each position. Partial motif
#' matches are not done, thus the last #[length of motif]-1 scores are NA. 
#' 
#' The function returns either an odds average (*not* log-odds average), maximal score on each strand,
#' or scores on both strands. 
#'
#' The function by default returns the score in log2 following the package \code{Biostrings}. 
#'
#' @param pwm PWM object
#' @param dna a DNAString or other sequence from Biostrings
#' @param pwm.rev the reverse complement for a pwm (if it is already pre-computed)
#' @param odds.score if to return raw scores in odds (not logodds) space
#' @param both.strands if to return results on both strands
#' @param strand.fun which function to use to summarise values over two strands (default is "mean")
#' @return a vector representing scores starting at each position, or a matrix with score in the two strands
#' @export
#' @examples
#' 
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    data(MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    ttk = MotifDb.Dmel[["ttk"]]
#'
#'    # odds average over the two strands expressed as log2-odds
#'    scanWithPWM(ttk, DNAString("CGTAGGATAAAGTAACT"))
#'    
#'    # log2-odds scores on both strands
#'    scanWithPWM(ttk, DNAString("CGTAGGATAAAGTAACT"), both.strands=TRUE)
#' }
#' 
scanWithPWM = function(pwm, dna, pwm.rev=NULL, odds.score=FALSE, both.strands=FALSE, strand.fun="mean"){
	if(is.character(dna))
		dna = DNAString(dna)

	if(!inherits(dna, c("DNAString", "DNAStringSet")))
		stop("The input sequence needs to be either of type DNAString or DNAStringSet")
	

	if(is.null(pwm.rev))
		pwm.rev = reverseComplement(pwm)
		
	# extract only the PWM matrices
	pwm = pwm$pwm
	pwm.rev = pwm.rev$pwm
	
	if(length(dna) < ncol(pwm)){
		stop("DNA sequence needs to be at least as long as the PWM")
	}

	fwd.motif = PWMscoreStartingAt(pwm, dna, starting.at=1:(length(dna)-ncol(pwm)+1))
	back.motif = PWMscoreStartingAt(pwm.rev, dna, starting.at=1:(length(dna)-ncol(pwm)+1))
	
	if(both.strands){
		res = cbind(fwd.motif, back.motif)
		colnames(res) = c("fwd", "rev")
		res = rbind(res, matrix(NA, nrow=(ncol(pwm)-1), ncol=2))
	} else {
		if(strand.fun == "max"){
			res = apply(cbind(fwd.motif, back.motif), 1, max)
		} else if(strand.fun == "mean"){
			res = 2^cbind(fwd.motif, back.motif)
			res = log2(rowMeans(res))
		} else {
			stop("Unknown strand function", strand.fun, ". Valid values are: mean, max")
		}
		# pad out the result so it is of same length as input sequence
		res = c(res, rep(NA, ncol(pwm)-1))
	}
	
	if(odds.score)
		return(2^res)
	else
		return(res)
}

#' Convert frequencies into motifs using PWMUnscaled
#'
#' Note that this function is deprecated and replaced by \code{toPWM()}. 
#'
#' @param motifs a list of motifs represented as matrices of frequencies (PFM)
#' @param id the set of IDs for the motifs (defaults to names of the 'motifs' list)
#' @param name the set of names for the motifs (defaults to names of the 'motifs' list)
#' @param seq.count if frequencies in the motifs are normalized to 1, provides a vector of sequence counts (e.g. for MotifDb motifs)
#' @param ... other parameters to PWMUnscaled
#'
#' @export
#' @examples
#' \dontrun{
#' if (requireNamespace("PWMEnrich.Dmelanogaster.background")) {
#'   data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")
#'
#'   # convert to PWM with uniform background
#'   PFMtoPWM(MotifDb.Dmel.PFM)
#'
#'   # get background for drosophila (quick mode on a reduced dataset)
#'   prior = getBackgroundFrequencies("dm3", quick=TRUE)
#'    
#'   # convert with genomic background 
#'   PFMtoPWM(MotifDb.Dmel.PFM, prior.params=prior)
#' }
#' }
PFMtoPWM = function(motifs, id=names(motifs), name=names(motifs), seq.count=NULL, ...){
	if(!is.list(motifs)){
		was.list = FALSE
		motifs = list(motifs)
	} else {
		was.list = TRUE
	}
	
	if(is.null(id))
		id = rep("", length(motifs))
	if(is.null(name))
		name = rep("", length(motifs))
	
	if(length(id) != length(motifs))
		stop("The number of IDs (parameter 'id') need to be the same as number of motifs (parameter 'motifs')")

	if(length(name) != length(motifs))
		stop("The number of names (parameter 'name') need to be the same as number of motifs (parameter 'motifs')")
		
	if(!is.null(seq.count) && length(seq.count) != length(motifs)){
		stop("The 'seq.count' vector needs to be of the same length as the list of motifs (parameters 'motifs')")
	}
	
	# call PWMUnscaled
	res = list()
	for(i in 1:length(motifs)){
		if(is.null(seq.count)){
			res[[i]] = PWMUnscaled(motifs[[i]], id=id[i], name=name[i], ...)
		} else {
			res[[i]] = PWMUnscaled(motifs[[i]], id=id[i], name=name[i], seq.count=seq.count[i], ...)
		}
	}
	
	names(res) = names(motifs)
	
	# convert back to single object if that's how the input was
	if(!was.list){
		return(res[[1]])
	} else {
		return(res)
	}

}

#' Convert motifs into PWMs
#'
#' @param motifs a list of motifs either as position probability matrices (PPM) or frequency matirces (PFMs)
#' @param ids the set of IDs for the motifs (defaults to names of the 'motifs' list)
#' @param targets the set of target TF names for the motifs (defaults to names of the 'motifs' list)
#' @param seq.count provides a vector of sequence counts for probability matrices (PPMs). Default it 50. 
#' @param prior frequencies of the four letters in the genome. Default is uniform background.
#' @param ... other parameters to PWMUnscaled
#'
#' @export
#' @examples
#' \dontrun{
#' if (requireNamespace("PWMEnrich.Dmelanogaster.background")) {
#'    data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    toPWM(MotifDb.Dmel.PFM) # convert to PWM with uniform background
#'
#'    # get background for drosophila (quick mode on a reduced dataset)
#'    prior = getBackgroundFrequencies("dm3", quick=TRUE)
#'    toPWM(MotifDb.Dmel.PFM, prior=prior) # convert with genomic background 
#' }
#' }
toPWM = function(motifs, ids=names(motifs), targets=names(motifs), seq.count=50, prior=c(A=0.25, C=0.25, G=0.25, T=0.25), ...){
	if(!is.list(motifs)){
		was.list = FALSE
		motifs = list(motifs)
	} else {
		was.list = TRUE
	}
	
	# extend seq.count if needed
	if(length(seq.count) == 1 && length(seq.count) != length(motifs))
		seq.count = rep(seq.count, length(motifs))
	
	# convert each individual motif into integers or multiply with seq.count
	for(i in 1:length(motifs)){
		m = motifs[[i]]
		
		mi = apply(m, 1:2, as.integer)
		if(all(m == mi)){
			# can be coersced to an integer matrix, use that
			motifs[[i]] = mi
		} else {
			# if the values is NA use 50 as default
			if(is.na(seq.count[i])){
				motifs[[i]] = apply(round(m * 50), 1:2, as.integer)
			} else {
				motifs[[i]] = apply(round(m * seq.count[i]), 1:2, as.integer)
			}
		}
		
	}
	
	if(is.null(ids))
		ids = rep("", length(motifs))
	if(is.null(targets))
		targets = rep("", length(motifs))
	
	if(length(ids) != length(motifs))
		stop("The number of IDs (parameter 'ids') need to be the same as number of motifs (parameter 'motifs')")

	if(length(targets) != length(motifs))
		stop("The number of TF target names (parameter 'targets') need to be the same as number of motifs (parameter 'motifs')")
	
	# call PWMUnscaled
	res = list()
	for(i in 1:length(motifs)){
		res[[i]] = PWMUnscaled(motifs[[i]], id=ids[i], name=targets[i], prior.params=prior, ...)
	}
	
	names(res) = names(motifs)
	
	# convert back to single object if that's how the input was
	if(!was.list){
		return(res[[1]])
	} else {
		return(res)
	}

}

#' Normalizes the motifs input argument for multiple functions
#'
#' @param motifs a list of motifs either as frequency matrices (PFM) or as PWM objects. If PFMs are specified
#'               they are converted to PWMs using uniform background. 
.inputParamMotifs = function(motifs){
	# check motifs format and convert to PWM
	if(!is.list(motifs))
		motifs = list(motifs)
		
	if(is.matrix(motifs[[1]]))
		pwms = PFMtoPWM(motifs)
	else if(inherits(motifs[[1]], "PWM"))
		pwms = motifs
	else
		stop("motifs need to be either frequency matrices or PWM objects")
		
	return(pwms)
}

#' Normalize the sequences input argument
#'
#' @param sequences a set of sequences to be scanned, a list of DNAString or other scannable objects
.inputParamSequences = function(sequences){
	if(is.character(sequences)){
		sequences = readDNAStringSet(sequences)
	}
	# make sure sequences are in the right format
	if(!is.list(sequences) & !inherits(sequences, "DNAStringSet"))
		sequences = list(sequences)
	
	if(is.list(sequences) & length(sequences)>0){
		sequences = lapply(sequences, function(s){
			if(is.character(s))
				DNAString(s)
			else
				s
		})
	}
		
	#if(class(sequences) == "DNAStringSet")
	#	sequences = DNAStringSetToList(sequences)
		
	return(sequences)
}

#' Motif affinity or number of hits over a threshold
#'
#' Scan a number of sequences either to find overall affinity, or a number of hits over a score threshold. 
#'
#' @param sequences a set of sequences to be scanned, a list of DNAString or other scannable objects
#' @param motifs a list of motifs either as frequency matrices (PFM) or as PWM objects. If PFMs are specified
#'               they are converted to PWMs using uniform background. 
#' @param raw.scores if to return raw scores (odds) for each position in the sequence. Note that scores for forward and reverse 
#'                   strand are concatenated into a single long vector of scores (twice the length of the sequence)
#' @param verbose if to print verbose output
#' @param cutoff if not NULL, will count number of matches with score above value specified (instead of returning the average affinity). 
#'               Can either be one value, or a vector of values for each of the motifs. 
#' @return if raw.scores=FALSE, returns a matrix of mean scores (after cutoff if any), where columns are motifs. 
#'         The returned values are either mean odd scores (not log-odd), or number of hits above a threshold;
#'         otherwise if raw.scores=TRUE, returns a list of raw score values (before cutoff)
#' @export
#' @examples
#'
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    data(MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    # affinity scores
#'    affinity = motifScores(DNAString("CGTAGGATAAAGTAACTAGTTGATGATGAAAG"), MotifDb.Dmel)
#'    
#'    # motif hit count with Patser score of 4
#'    counts = motifScores(DNAString("CGTAGGATAAAGTAACTAGTTGATGATGAAAG"), MotifDb.Dmel, 
#'      cutoff=log2(exp(4)))
#'    
#'    print(affinity)
#'    print(counts)
#'
#'    # scanning multiple sequences
#'    sequences = list(DNAString("CGTAGGATAAAGTAACTAGTTGATGATGAAAG"), 
#'      DNAString("TGAGACGAAGGGGATGAGATGCGGAAGAGTGAAA"))
#'    affinity2 = motifScores(sequences, MotifDb.Dmel)
#'    print(affinity2)
#' }
motifScores = function(sequences, motifs, raw.scores=FALSE, verbose=TRUE, cutoff=NULL){	
	if(!is.null(.PWMEnrich.Options[["useBigMemory"]]) && .PWMEnrich.Options[["useBigMemory"]])
		return(motifScoresBigMemory(sequences, motifs, raw.scores, verbose, cutoff))

	# check motifs format and convert to PWM
	pwms = .inputParamMotifs(motifs)
	sequences = .inputParamSequences(sequences)
	
	# check if any of the sequences is all Ns, if so, produce an error
	if(is(sequences, "DNAStringSet")){
		al = alphabetFrequency(sequences)
	} else {
		al = do.call("rbind", lapply(sequences, alphabetFrequency))
	}
	
	# check if any of the sequences is all Ns
	all.n = which(al[,"N"] == rowSums(al))
	if(length(all.n) >0){
		stop(paste("Sequence with index(es):", paste(all.n, collapse=","), "only contain N's. Please remove this sequence as the PWM score cannot be computed for any position."))
	}
		
	pwms.rev = lapply(pwms, reverseComplement)
	
	# always unfold cutoff into a vector of values
	if(!is.null(cutoff)){
		if(length(cutoff) == 1){
			cutoff = rep(cutoff, length(pwms))
		} else if(length(cutoff) != length(pwms)) {
			stop("The lengths of cutoff and pwms do not match. Either provide one values for cutoff, or a vector of values, one for each PWM")
		} 
	}
	
	# inner loop function to use for parallel processing
	motifScoresLoop = function(i){
		if(verbose)
			message(paste("Scanning sequence", i, "/", length(sequences)))
		s = sequences[[i]]
		
		# if using raw scores, record matrix of values;
		# otherwise a single final value for each pwm
		if(raw.scores){
			r = matrix(0, nrow=length(s)*2, ncol=length(pwms))
			colnames(r) = names(pwms)
		} else {
			r = rep(0, length(pwms))
			names(r) = names(pwms)
		}
		
		for(j in 1:length(pwms)){
			# if we are interested in counts, use max over two strands
			
			if(raw.scores){
				# record raw scores that are averages over strands
				r[,j] = as.vector(scanWithPWM(pwms[[j]], s, pwms.rev[[j]], odds.score=TRUE, both.strands=TRUE))
			} else if(!is.null(cutoff)){
				# count number of hits on both strands
				r.pwm = scanWithPWM(pwms[[j]], s, pwms.rev[[j]], odds.score=FALSE, both.strands=TRUE)
				r[j] = sum(r.pwm >= cutoff[j], na.rm=TRUE)
			} else {
				# do average over both strands and also over all values
				r[j] = mean(scanWithPWM(pwms[[j]], s, pwms.rev[[j]], odds.score=TRUE), na.rm=TRUE)
			}
		}
		
		r
	}
	
	####################################### END OF INNER LOOP ################

	# either do it parallel or serial
	if(!is.null(.PWMEnrich.Options[["numCores"]])){
		cat("Parallel scanning with", .PWMEnrich.Options[["numCores"]], "cores\n")
		# do it in parallel
		res = parallel::mclapply(1:length(sequences), motifScoresLoop, mc.cores = .PWMEnrich.Options[["numCores"]])
		
		if(is.list(res)){
			if( any(sapply(res, is.null)) ){
				stop("Parallel scanning failed for some sequences. This could be due to a number of reasons including not enough memory.")
			}
		}
	} else {
		# do it serial
		res = lapply(1:length(sequences), motifScoresLoop)
	}
	
	## return either raw scores, or counts or means
	if(raw.scores){
		names(res) = names(sequences)
		return(res)
	} else {
		if(length(pwms) == 1){
			return( matrix(sapply(res, identity), ncol=1, dimnames=list(NULL, names(pwms))) )
		} else {
			r = t(sapply(res, identity))
			rownames(r) = names(sequences)
			colnames(r) = names(pwms)
			return( r )
		}
	}
}

#' This is a memory intensive version of motifScore() which is about 2 times faster
#'
#' The parameters and functionality are the same as \code{\link{motifScores}}. Please refer to documentation of this function
#' for detailed explanation of functionality. 
#'
#' This function is not meant to be called directly, but is indirectly called by motifScores() once a global parameters useBigMemory is set. 
#'
#' @param sequences set of input sequences
#' @param motifs set of input PWMs or PFMs
#' @param raw.scores if to return scores for each base-pair
#' @param verbose if to produce verbose output
#' @param cutoff the cutoff for calling binding sites (in base 2 log). 
#' @param seq.all already concatenated sequences if already available (used to internally speed up things)
#'
#' @seealso \code{\link{motifScores}}
motifScoresBigMemory = function(sequences, motifs, raw.scores=FALSE, verbose=TRUE, cutoff=NULL, seq.all=NULL){	
	# check motifs format and convert to PWM
	pwms = .inputParamMotifs(motifs)
	sequences = .inputParamSequences(sequences)
		
	pwms.rev = lapply(pwms, reverseComplement)
	pwms.len = sapply(pwms, length)
	min.pwm.len = min(pwms.len)
	
	# always unfold cutoff into a vector of values
	if(!is.null(cutoff)){
		if(length(cutoff) == 1){
			cutoff = rep(cutoff, length(pwms))
		} else if(length(cutoff) != length(pwms)) {
			stop("The lengths of 'cutoff' and 'pwms' do not match. Either provide one values for 'cutoff' or a vector of values, one for each PWM")
		} 
		
		# cutoff in odds space
		cutoff.2 = 2^cutoff
	}
	
	# work on a single sequence that is all concatenated together because it's faster
	if(is.null(seq.all))
		seq.all = DNAString(concatenateSequences(sequences))
	seq.len = sapply(sequences, length)
	
	# a common error with shorter sequences
	shorter.seq = which(seq.len < min.pwm.len)
	if(length(shorter.seq)>0){
		stop(paste(length(shorter.seq), "sequence(s) have length shorter than the shortest PWM (", min.pwm.len, "), please identify and remove these sequences."))
	}
	
	# a grouping data frame
	seq.len.sum = cumsum(seq.len)
	seq.group = data.frame("from"=rep(0, length(sequences)), "to"=0)
	seq.group$from = c(1, 1+seq.len.sum[-length(seq.len.sum)])
	seq.group$to = seq.len.sum
	
	# inner loop function to use for parallel processing
	#
	# @param motif.start the index of the first motif
	# @param motif.end the index of the last motif 
	motifScoresLoop = function(input.params){
		motif.start = input.params[[1]]
		motif.end = input.params[[2]]
	
		if(verbose){
			if(motif.start == motif.end){
				message(paste("Starting scanning with motif", names(pwms)[motif.start]))
			} else {
				message(paste("Starting scanning with motifs from", motif.start, "to", motif.end))
			}
		}
		# local copy of the sequences and motifs used in the function
		s = seq.all
		s.group = seq.group
		pwms.l = pwms[motif.start:motif.end]
		pwms.rev.l = pwms.rev[motif.start:motif.end]
		pwms.len.l = pwms.len[motif.start:motif.end]
		if(!is.null(cutoff))
			cutoff.2.l = cutoff.2[motif.start:motif.end]
		
		# create the output structure
		res = list()
		for(i in 1:nrow(s.group)){
			if(raw.scores){			
				r = matrix(0, nrow=seq.len[i]*2, ncol=length(pwms.l))
				colnames(r) = names(pwms.l)
				res[[i]] = r		
			} else {
				r = rep(0, length(pwms.l))
				names(r) = names(pwms.l)		
				res[[i]] = r
			}
		}
		
		### do the scanning, convert back to individual sequences and do the post-processing
		for(j in 1:length(pwms.l)){
			if(verbose){
				message(paste("Scanning all sequences with motif", j, "/", length(pwms.l)))
			}
			raw = as.vector(scanWithPWM(pwms.l[[j]], s, pwms.rev.l[[j]], odds.score=TRUE, both.strands=TRUE))
			
			### split the raw results by sequence
			for(i in 1:nrow(s.group)){
				# selector for this sequence
				from = seq.group$from[i]
				to = seq.group$to[i]
				from.rev = length(raw)/2 + seq.group$from[i]
				to.rev = length(raw)/2 + seq.group$to[i]
				sel = c(from:to, from.rev:to.rev)
			
				r = raw[sel]
				
				# fwd strand
				r[((seq.len[i]-pwms.len.l[j])+2):seq.len[i]] = NA
				# rev strand
				r[((2*seq.len[i]-pwms.len.l[j])+2):(2*seq.len[i])] = NA

				# save the values				
				if(raw.scores){
					res[[i]][,j] = r
				} else if(!is.null(cutoff)){
					# count number of hits on both strands 
					res[[i]][j] = sum(r >= cutoff.2.l[j], na.rm=TRUE)
				} else {
					# MeanAffinity
					res[[i]][j] = mean(r, na.rm=TRUE)
				}
				
			}
		}
				
		res
	}
	######################################## END OF INNER LOOP ######################################

	# either do it parallel or serial
	if(!is.null(.PWMEnrich.Options[["numCores"]]) && length(pwms) >= .PWMEnrich.Options[["numCores"]]){
		cores = .PWMEnrich.Options[["numCores"]]
		sel = round(seq(0, length(pwms), length.out=cores+1))
		start = sel[1:cores]+1
		end = sel[2:(cores+1)]
		input = lapply(1:cores, function(i) list(start[i], end[i]))
		# do it in parallel
		res.parallel = parallel::mclapply(input, motifScoresLoop, mc.cores = cores)
		
		if(is.list(res.parallel)){
			if( any(sapply(res.parallel, is.null)) ){
				stop("Parallel scanning failed for some sequences. This could be due to a number of reasons including not enough memory.")
			}
		}	

		# concatenate results for different motifs		
		if(raw.scores)
			res = lapply(1:length(sequences), function(i) do.call("cbind", lapply(res.parallel, function(x) x[[i]])))	
		else
			res = lapply(1:length(sequences), function(i) do.call("c", lapply(res.parallel, function(x) x[[i]])))
	} else {
		# do it serial
		res = motifScoresLoop(list(1, length(pwms)))
	}
	
	
	
	## return either raw scores, or counts or means
	if(raw.scores){
		names(res) = names(sequences)
		return(res)
	} else {
		if(length(pwms) == 1){
			return( matrix(sapply(res, identity), ncol=1, dimnames=list(names(sequences), names(pwms))) )
		} else {
			r = t(sapply(res, identity))
			rownames(r) = names(sequences)
			colnames(r) = names(pwms)
			return( r )
		}
	}
}


#' Information content for a PWM or PFM
#'
#' @param motif a matrix of frequencies, or a PWM object
#' @param prior.params the prior parameters to use when a matrix is given (ignored if motif is already a PWM)
#' @param bycol if to return values separately for each column
#' @return information content in bits (i.e. log2)
#' @export
#' @examples
#'
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    data(MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")
#'    data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    # the nucleotide distribution is taken from the PWM (in this case genomic background)
#'    motifIC(MotifDb.Dmel[["ttk"]]) 
#'    # information content with default uniform background because the input is a matrix, 
#'    # not PWM object
#'    motifIC(MotifDb.Dmel.PFM[["ttk"]]) 
#' }
motifIC = function(motif, prior.params=c(A=0.25, C=0.25, G=0.25, T=0.25), bycol=FALSE){
	if(inherits(motif, "PWM")) {
		p = PWMUnscaled(motif$pfm, type="prob", prior.params=motif$prior.params)
		bg = motif$prior.params
	} else {
		p = PWMUnscaled(motif, type="prob", prior.params=prior.params)
		bg = prior.params
	}
		
	bg = bg/sum(bg) # normalize to 1
	
	cols = p$pwm * log2(p$pwm/bg)
	if(bycol)
		return(colSums(cols))
	else
		return(sum(cols))
}

#' Calculate motif enrichment using one of available scoring algorithms and background corrections. 
#'
#' This function provides and interface to all algorithms available in PWMEnrich
#' to find motif enrichment in a single or a group of sequences with/without
#' background correction. 
#'
#' Since for all algorithms the first step involves calculating raw scores without background correction, the output
#' always contains the scores without background correction together with (optional) background-corrected
#' scores. 
#'
#' Unless otherwise specified the scores are returned both separately for each sequence (without/with background) and
#' for the whole group of sequences (without/with background). 
#'
#' To use a background correction you need to supply a set of PWMs with precompiled background distribution parameters
#' (see function \code{\link{makeBackground}}). When such an object is supplied as the \code{pwm} parameter, the scoring 
#' scheme and background correction are automatically determined. 
#'
#' There are additional packages with already pre-computed background (e.g. see package \code{PWMEnrich.Dmelanogaster.background}).
#'
#' Please refer to (Stojnic & Adryan, 2012) for more details on the algorithms. 
#'
#' @title Motif enrichment
#' @param sequences the sequences to be scanned for enrichment. Can be either a single sequence 
#'        (an object of class DNAString), or a list of DNAString objects, or a DNAStringSet object.
#' @param pwms this parameter can take multiple values depending on the scoring scheme and background correction used.
#'             When the \code{method} parameter is set to "autodetect", the following default algorithms
#'             are going to be used: 
#'        \itemize{
#'           \item if \code{pwms} is a list containing either frequency matrices or a list of PWM objects then
#'                 the "affinity" algorithm is selected. If frequency matrices are given, they are converted 
#'                 to PWMs using uniform background. For best performance, convert frequency matrices to PWMs
#'                 before calling this function using realistic genomic background. 
#'           \item Otherwise, appropriate scoring scheme and background correction are selected based on the
#'                 class of the object (see below). 
#'        }
#' @param score this parameter determines which scoring scheme to use. Following scheme as available:
#'        \itemize{
#'           \item "autodetect" - default value. Scoring method is determined based
#'                 on the type of \code{pwms} parameter. 
#'           \item "affinity" - use threshold-free affinity score. The \code{pwms}
#'                 parameter can either be a list of frequency matrices, \code{PWM} objects, or a 
#'                 \code{PWMLognBackground} object. 
#'           \item "cutoff" - use number of motif hits above a score cutoff. The \code{pwms}
#'                 parameter can either be a list of frequency matrices, \code{PWM} objects, or a 
#'                 \code{PWMCutoffBackground} object.
#'           \item "clover" - use the Clover algorithm (Frith et al, 2004). The Clover score of a single 
#'                 sequence is identical to the affinity score, while for a group of sequences is an
#'                 average of products of affinities over all sequence subsets. 
#'         }
#'            
#' @param bg this parameter determines how the raw score is compared to the background distribution. 
#'        \itemize{
#'           \item "autodetect" - default value. Background correction is determined based on the type
#'                  of the \code{pwms} parameter. 
#'           \item "logn" - use a lognormal distribution background pre-computed for a set of PWMs.
#'                 This requires \code{pwms} to be of class \code{PWMLognBackground}.
#'           \item "z" - use a z-score for the number of significant motif hits compared to background number of hits.
#'                 This requires \code{pwms} to be of class \code{PWMCutoffBackground}.
#'           \item "pval" - use empirical P-value based on a set of background sequences. This requires
#'                 \code{pwms} to be of class \code{PWMEmpiricalBackground}. Note that PWMEmpiricalBackground
#'                 objects tend to be very large so that the empirical P-value can be calculated in reasonable time.
#'           \item "ms" - shuffle columns of motif matrices and use that as basis for P-value calculation. Note that
#'                  since the sequences need to rescanned with all of the new shuffled motifs this can be very slow. 
#'                  Also, this also works only no *individual* sequences, not groups. 
#'           \item "none" - no background correction
#'         }
#' @param cutoff the score cutoff for a significant motif hit if scoring scheme "cutoff" is selected. 
#' @param verbose if to print verbose output
#' @param motif.shuffles number of times to shuffle motifs if using "ms" background correction
#' @param B number of replicates when calculating empirical P-value
#' @param group.only if to return statistics only for the group of sequences, not individual sequences. In the case of
#'                   empirical background the P-values for individual sequences are not calculated (thus saving time), for other 
#'                   backgrounds they are calculated but not returned.  
#' @return a MotifEnrichmentResults object containing a subset following elements:
#'         \itemize{
#'           \item "score" - scoring scheme used
#'           \item "bg" - background correction used
#'           \item "params" - any additional parameters
#'			 \item "sequences" - the set of sequences used
#'           \item "pwms" - the set of pwms used
#'           \item "sequence.nobg" - per-sequence scores without any background correction. 
#'                   For "affinity" and "clover" a matrix of mean affinity scores; for
#'                   "cutoff" number of significant hits above a cutoff 
#'           \item "sequence.bg" - per-sequence scores after background correction. For "logn" and "pval" the P-value (smaller is better);
#'                                 for "z" and "ms" background corrections the z-scores (bigger is better). 
#'           \item "group.nobg" - aggregate scores for the whole group of sequences without background correction. For "affinity"
#'                                and "clover" the mean affinity over all sequences in the set; for "cutoff" the total number of hits in all
#'                                sequences.
#'           \item "group.bg" - aggregate scores for the whole group of sequences with background correction. For "logn" and "pval",
#'                              the P-value for the whole group (smaller is better); for "z" and "ms" the z-score for the whole set (bigger is better).
#'           \item "sequence.norm" - (only for "logn") the length-normalized scores for each of the sequences. Currently only implemented
#'                                   for "logn", where it returns the values normalized from LogN(0,1) distribution
#'           \item "group.norm" - (only for "logn") similar to sequence.norm, but for the whole group of sequences
#'         }
#' @export
#' @references \itemize{ 
#'  \item R. Stojnic & B. Adryan: Identification of functional DNA motifs using a binding affinity lognormal background distribution, submitted.
#' 	\item MC Frith et al: Detection of functional DNA motifs via statistical over-representation, Nucleid Acid Research (2004).
#' }
#' @examples 
#'
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    ###
#'    # load the pre-compiled lognormal background
#'    data(PWMLogn.dm3.MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    # scan two sequences for motif enrichment
#'    sequences = list(DNAString("GAAGTATCAAGTGACCAGTAGATTGAAGTAGACCAGTC"), 
#'      DNAString("AGGTAGATAGAACAGTAGGCAATGGGGGAAATTGAGAGTC"))
#'    res = motifEnrichment(sequences, PWMLogn.dm3.MotifDb.Dmel)
#'
#'    # most enriched in both sequences (lognormal background P-value)
#'    head(motifRankingForGroup(res))
#'
#'    # most enriched in both sequences (raw affinity, no background)
#'    head(motifRankingForGroup(res, bg=FALSE))
#'
#'    # most enriched in the first sequence (lognormal background P-value)
#'    head(motifRankingForSequence(res, 1))
#'
#'    # most enriched in the first sequence (raw affinity, no background)
#'    head(motifRankingForSequence(res, 1, bg=FALSE))
#'
#'    ###
#'    # Load the pre-compiled background for hit-based motif counts with cutoff of P-value = 0.001 
#'    data(PWMPvalueCutoff1e3.dm3.MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    res.count = motifEnrichment(sequences, PWMPvalueCutoff1e3.dm3.MotifDb.Dmel)
#'
#'    # Enrichment in the whole group, z-score for the number of motif hits
#'    head(motifRankingForGroup(res))
#'
#'    # First sequence, sorted by number of motif hits with P-value < 0.001
#'    head(motifRankingForSequence(res, 1, bg=FALSE))
#'    
#' }
motifEnrichment = function(sequences, pwms, score="autodetect", bg="autodetect", cutoff=NULL, verbose=TRUE, motif.shuffles=30, B=1000,
	group.only=FALSE){
	
	# detect scoring method
	if(score == "autodetect"){
		if(inherits(pwms, "PWMLognBackground")) {
			score = "affinity"
		} else if(inherits(pwms, "PWMCutoffBackground")) {
			score = "cutoff"
		} else {
			score = "affinity"
		}
	}
	
	if(score == "cutoff" & is.null(cutoff))
		cutoff = pwms@bg.cutoff
	
	# the PWM* object
	pwmobj = NULL
	
	# detect background correction
	if(!(bg %in% c("none", "ms"))){
		if(inherits(pwms, "PWMLognBackground")) {
			bg = "logn"
			pwmobj = pwms
			pwms = pwmobj@pwms
		} else if(inherits(pwms, "PWMCutoffBackground")) {
			bg = "z"
			pwmobj = pwms
			pwms = pwmobj@pwms
		} else if(inherits(pwms, "PWMEmpiricalBackground")) {
			bg = "pval"
			pwmobj = pwms
			pwms = pwmobj@pwms
		} else if(inherits(pwms, "PWMGEVBackground")) {
			bg = "gev"
			pwmobj = pwms
			pwms = pwmobj@pwms
		} else {
			bg = "none"
		}
	}

	if(!is.list(pwms))
		pwms = list(pwms)
	
	sequences = .inputParamSequences(sequences)
	
	# return list
	res = list(score=score, bg=bg, pwms=pwms, sequences=sequences, params=list())
	
	# apply no-bg scoring
	if(score == "affinity"){
		# lengths of sequences and PWMs
		seq.len = sapply(sequences, length)
		pwm.len = sapply(pwms, length)
		
		res$sequence.nobg = motifScores(sequences, pwms, verbose=verbose)
		res$group.nobg = affinitySequenceSet(res$sequence.nobg, seq.len, pwm.len)
	} else if(score == "clover"){
		res$sequence.nobg = motifScores(sequences, pwms, verbose=verbose)
		res$group.nobg = cloverScore(res$sequence.nobg, verbose=verbose)
	} else if(score == "cutoff"){
		res$params = list(cutoff=cutoff)
		res$sequence.nobg = motifScores(sequences, pwms, cutoff=cutoff, verbose=verbose)
		res$group.nobg = colSums(res$sequence.nobg)
	} else {
		stop(paste("Unknown scoring algorithm: '", score, "'. Please select one of: 'affinity', 'cutoff', 'clover'", sep=""))
	}
	
	if(verbose){
		cat("Calculating motif enrichment scores ...\n")
	}
	
	# apply background correction if needed
	if(bg == "none"){
		res$sequence.bg = NULL
		res$group.bg = NULL
	} else if(bg == "logn"){
		# lengths of sequences and PWMs
		seq.len = sapply(sequences, length)
		pwm.len = sapply(pwms, length)
		# do it per sequence
		res$sequence.bg = logNormPval(res$sequence.nobg, seq.len, pwm.len, pwmobj@bg.mean, pwmobj@bg.sd, pwmobj@bg.len)
		colnames(res$sequence.bg) = names(pwms)
		# convert logn P-values into normalized observations and run Clover on that
		res$sequence.norm = apply(res$sequence.bg, 1:2, qlnorm, lower.tail=FALSE)
		
		if(score == "affinity"){
			# and for the group
			if(is.matrix(pwmobj@bg.mean)){
				# convert back to P-values, using the chi-sq distribution
				res$group.bg = apply(res$sequence.bg, 2, function(x) {
					pchisq(-2*sum(log(x)), 2*length(x), lower.tail=FALSE)
				})
				#res$group.bg = colMeans(log(res$sequence.bg))
				res$group.norm = sapply(res$group.bg, qlnorm, lower.tail=FALSE)
			} else {
				res$group.bg = logNormPvalSequenceSet(res$sequence.nobg, seq.len, pwm.len, pwmobj@bg.mean, pwmobj@bg.sd, pwmobj@bg.len)
				res$group.norm = sapply(res$group.bg, qlnorm, lower.tail=FALSE)
			}
			
		} else if(score == "clover"){
			# now run Clover on normalized scores
			res$group.bg = cloverScore(res$sequence.norm, verbose=verbose)
		}
	} else if(bg == "z"){
		# lengths of sequences and PWMs
		seq.len = sapply(sequences, length)
		pwm.len = sapply(pwms, length)
		res$sequence.bg = cutoffZscore(res$sequence.nobg, seq.len, pwm.len, pwmobj@bg.P)
		res$group.bg = cutoffZscoreSequenceSet(res$sequence.nobg, seq.len, pwm.len, pwmobj@bg.P)
	} else if(bg == "pval"){
		seq.len = sapply(sequences, length)
		pwm.len = sapply(pwms, length)
		
		# if to use cutoff
		usecutoff = NULL
		if(score == "cutoff")
			usecutoff = cutoff
		
		if(!group.only){
			res$sequence.bg = t(sapply(1:length(seq.len), function(i)
				 empiricalPvalue(res$sequence.nobg[i,], seq.len[i], pwm.len, pwmobj@bg.fwd, pwmobj@bg.rev, cutoff=usecutoff, B=B, verbose=verbose)))
		}
		
		# do empirical P-value
		if(score == "clover")
			res$group.bg = cloverPvalue1seq(res$sequence.nobg, seq.len, pwm.len, pwmobj@bg.fwd, pwmobj@bg.rev, B=B, verbose=verbose, clover=res$group.nobg)
		else	 
			res$group.bg = empiricalPvalueSequenceSet(res$sequence.nobg, seq.len, pwm.len, pwmobj@bg.fwd, pwmobj@bg.rev, cutoff=usecutoff, B=B, verbose=verbose)
	} else if(bg == "ms"){
		# if to use cutoff
		usecutoff = NULL
		if(score == "cutoff")
			usecutoff = cutoff
		res$sequence.bg = matrixShuffleZscorePerSequence(res$sequence.nobg, sequences, pwms, cutoff=usecutoff, B=motif.shuffles)
	} else if(bg == "gev"){
		seq.len = sapply(sequences, length)
		pwm.len = sapply(pwms, length)
		
		res$sequence.bg = gevPerSequence(res$sequence.nobg, seq.len, pwm.len, pwmobj@bg.loc, pwmobj@bg.scale, pwmobj@bg.shape)
		res$group.bg = NULL
	} else {
		stop(paste("Uknown background correction algorithm: '", bg, "', Please select one of: 'none', 'logn', 'z', 'pval', 'ms'", sep=""))
	}
	
	# only store the values for the group, not individual sequences!
	if(group.only){
		seq.n = grep("^sequence[.]", names(res))
		if(length(seq.n)>0){
			res = res[-seq.n]
		}
	}
	
	# restore the sequence names
	if("sequence.nobg" %in% names(res)){
		rownames(res$sequence.nobg) = names(sequences)
	}
	if("sequence.bg" %in% names(res)){
		rownames(res$sequence.bg) = names(sequences)
	}
	
	return(new("MotifEnrichmentResults", res=res))
		
}

#' Obtain z-score for motif column shuffling
#'
#' All PWMs are shuffled at the same time. This function would be too slow to produce
#' empirical P-values, thus we return a z-score from a small number of shuffles. 
#'
#' The z-scores are calculated for each sequence individually. 
#' 
#' @param scores a set of already calculated scores
#' @param sequences either one sequence or a list/set of sequences (objects of type DNAString or DNAStringSet)
#' @param pwms a list of PWMs
#' @param cutoff if NULL, will use affinity, otherwise will use number of hits over this log2 odds cutoff
#' @param B number of replicates, i.e. PWM column shuffles
matrixShuffleZscorePerSequence = function(scores, sequences, pwms, cutoff=NULL, B=30){
	# scores from different replicates for each of the sequences
	scores.matrix = array(0, dim=c(nrow(scores), ncol(scores), B))
	dimnames(scores.matrix) = list(rownames(scores), colnames(scores), NULL)
	
	# perfom shuffles	
	for(i in 1:B){
		cat("Perfoming shuffle", i, "/", B, "\n")
		pwms.shuffled = pwms
		for(j in 1:length(pwms)){
			p = pwms[[j]]
			pwms.shuffled[[j]]@pwm = p@pwm[, sample(ncol(p@pwm))]
		}
		
		scores.suffled = motifScores(sequences, pwms.shuffled, cutoff=cutoff, verbose=FALSE)
		scores.matrix[,,i] = scores.suffled
		
	}
	
	# work out mean and sd
	shuffled.mean = apply(scores.matrix, c(1,2), mean)
	shuffled.sd = apply(scores.matrix, c(1,2), sd)
	
	return( (scores - shuffled.mean) / shuffled.sd )
}


#' Calculate the P-value from lognormal distribution with background of equal length
#' 
#' @param scores affinity scores for the PWMs, can contain scores for more than one sequence (as rows), P-values are extracted separately
#' @param seq.len the length distribution of the sequences
#' @param pwm.len the leggths of PWMs
#' @param bg.mean the mean values from the background for PWMs
#' @param bg.sd the sd values from the background
#' @param bg.len the length distribution of the background (we currently support only constant length)
#' @param log if to produce log p-values
logNormPval = function(scores, seq.len, pwm.len, bg.mean, bg.sd, bg.len, log=FALSE){
	if(is.vector(scores)){
		scores = matrix(scores, nrow=1, dimnames=list(NULL, names(scores)))
	}
	if( length(seq.len) != nrow(scores) ){
		stop("The sequence length distribution and number of rows for scores doesn't match")
	}
	if( !all(colnames(scores) == names(bg.mean)) ){
		stop("The motifs column names in 'scores' and 'bg.mean' do not match")
	}
	
	seq.mean = seq.sd = matrix(0, nrow=nrow(scores), ncol=ncol(scores))

	slen = matrix(seq.len, nrow=nrow(scores), ncol=ncol(scores)) - 
		   matrix(pwm.len, nrow=nrow(scores), ncol=ncol(scores), byrow=TRUE) + 1

	# rows (i) - sequences
	# cols (j) - motifs
	if(is.matrix(bg.mean)){
		# human implementation ... 
		
		bg.len.min = matrix(bg.len[1,], nrow=nrow(scores), ncol=ncol(scores), byrow=TRUE)
		bg.len.max = matrix(bg.len[nrow(bg.len),], nrow=nrow(scores), ncol=ncol(scores), byrow=TRUE)
	
		bg.len.all = lapply(1:nrow(bg.len), function(i) matrix(bg.len[i,], nrow=nrow(scores), ncol=ncol(scores), byrow=TRUE))
	
		# split into three classes
		min.inx = slen <= bg.len.min
		max.inx = slen >= bg.len.max
		int.inx = !min.inx & !max.inx

		# bg.sd correction factor value
		bgsd = bg.sd * sqrt(bg.len/matrix(bg.len[1,], nrow=nrow(bg.len), ncol=ncol(bg.len), byrow=TRUE))
		bgsd = bgsd / matrix(bgsd[1,], nrow=nrow(bgsd), ncol=ncol(bgsd), byrow=TRUE)
	
		bgsd.all = lapply(1:nrow(bgsd), function(i) matrix(bgsd[i,], nrow=nrow(scores), ncol=ncol(scores), byrow=TRUE))

		# smaller
		if(any(min.inx)){
			bg.mean.min = matrix(bg.mean[1,], nrow=nrow(scores), ncol=ncol(scores), byrow=TRUE)
			bg.sd.min = matrix(bg.sd[1,], nrow=nrow(scores), ncol=ncol(scores), byrow=TRUE)

			# keep mean, use quadratic for sd
			seq.mean[min.inx] = bg.mean.min[min.inx]
			seq.sd[min.inx] = bg.sd.min[min.inx] / sqrt(slen[min.inx]/bg.len.min[min.inx])
		} 
		if(any(max.inx)){
			bg.mean.max = matrix(bg.mean[nrow(bg.mean),], nrow=nrow(scores), ncol=ncol(scores), byrow=TRUE)
			bg.sd.max = matrix(bg.sd[nrow(bg.sd),], nrow=nrow(scores), ncol=ncol(scores), byrow=TRUE)

			# keep mean, use quadratic for sd
			seq.mean[max.inx] = bg.mean.max[max.inx]
			seq.sd[max.inx] = bg.sd.max[max.inx] / sqrt(slen[max.inx]/bg.len.max[max.inx])
		}
		if(any(int.inx)){
			bg.mean.all = lapply(1:nrow(bg.mean), function(i) matrix(bg.mean[i,], nrow=nrow(scores), ncol=ncol(scores), byrow=TRUE))
			bg.sd.all = lapply(1:nrow(bg.sd), function(i) matrix(bg.sd[i,], nrow=nrow(scores), ncol=ncol(scores), byrow=TRUE))
			# interpolate!		
			for(k in 1:(nrow(bg.mean)-1)){
				a = bg.len.all[[k]]
				b = bg.len.all[[k+1]]
				inx = int.inx & slen >= a & slen < b
				if(any(inx)){
					# direct linear interpolation for mean
					seq.mean[inx] = bg.mean.all[[k]][inx] + (bg.mean.all[[k+1]][inx] - bg.mean.all[[k]][inx])/(b[inx]-a[inx]) * (slen[inx]-a[inx])
				
					# base value of seq.sd
					seq.sd[inx] = bg.sd.all[[1]][inx] / sqrt(slen[inx]/bg.len.all[[1]][inx])
				
					# this correction factor would ideally be 1
					seq.sd[inx] = seq.sd[inx] * (bgsd.all[[k]][inx] + (bgsd.all[[k+1]][inx]-bgsd.all[[k]][inx])/(b[inx]-a[inx]) * (slen[inx]-a[inx]))
				
				}
			}
		}
	} else {
		# default implementation
		seq.mean = matrix(bg.mean, nrow=nrow(scores), ncol=ncol(scores), byrow=TRUE)
		seq.sd = matrix(bg.sd, nrow=nrow(scores), ncol=ncol(scores), byrow=TRUE) / 
					sqrt(slen / matrix(bg.len, nrow=nrow(scores), ncol=ncol(scores), byrow=TRUE))
	}
	
	# calculate p-values
	seq.p = matrix(0, nrow=nrow(scores), ncol=ncol(scores))
	colnames(seq.p) = colnames(scores)
	rownames(seq.p) = rownames(scores)
	
	# calculate the mean/sd parameters of the lognormal distribution
	seq.ml = 2*log(seq.mean) - 0.5*log(seq.mean^2+seq.sd^2)
	seq.sl = sqrt(-2*log(seq.mean) + log(seq.mean^2+seq.sd^2))
	
	# convert to z-scores so we can streamline... 
	z = (log(scores) - seq.ml) / seq.sl
	seq.p[,] = plnorm(exp(z), meanlog=0, sdlog=1, lower.tail=FALSE, log.p=log)
	
	# convert to log10 P-values
	if(log)
		seq.p = seq.p * log10(exp(1))
		
	seq.p
}

#' Lognormal P-value for a set of sequences
#'
#' @param scores a matrix of per-sequence affinity scores
#' @param seq.len lengths of sequences
#' @param pwm.len lengths of pwms
#' @param bg.mean mean background at length of bg.len
#' @param bg.sd standard deviation of background at length of bg.len
#' @param bg.len the length for which mean and sd are calculated
#' @return P-value
logNormPvalSequenceSet = function(scores, seq.len, pwm.len, bg.mean, bg.sd, bg.len){
	# total score for all the sequences
	s = structure(rep(0, ncol(scores)), names=colnames(scores))
	res = structure(rep(0, ncol(scores)), names=colnames(scores))
	for(i in 1:ncol(scores)){
		# lengths of sequences for this pwm, all of them are shorter by pwm.len-1
		seq.len.pwm = seq.len - pwm.len[i] + 1
		
		# sum over sequences then average by total length
		s[i] = sum(scores[,i] * seq.len.pwm) / sum(seq.len.pwm)
		if(is.matrix(bg.mean)){
			res[i] = logNormPval(s[i], sum(seq.len.pwm)+pwm.len[i]-1, pwm.len[i], bg.mean[,i,drop=FALSE], bg.sd[,i,drop=FALSE], bg.len[,i,drop=FALSE])
		} else {
			res[i] = logNormPval(s[i], sum(seq.len.pwm)+pwm.len[i]-1, pwm.len[i], bg.mean[i], bg.sd[i], bg.len[i])
		}
	}
	
 	return(res)
}


#' Replace all infinite values by 0
#'
#' @param x a vector of values
keepFinite = function(x) {
	if(any(!is.finite(x)))
		x[!is.finite(x)] = 0
	x
}

#' Z-score calculation for cutoff hits
#'
#' The Z-score is calculated separately for each sequence
#'
#' @param scores the hit counts for the sequences
#' @param seq.len the length distribution of sequences
#' @param pwm.len the length distribution of the PWMs
#' @param bg.P background probabilities of observing a motif hit at nucleotide resolution 
#'             (scaled to sequence length, not 2 * length)
#' @return Z-score
cutoffZscore = function(scores, seq.len, pwm.len, bg.P){
	if(is.vector(scores))
		scores = matrix(scores, nrow=1)

	# actual probability is 1/2 because we have two strands
	bg.P = bg.P / 2
	
	z = matrix(0, nrow=nrow(scores), ncol=ncol(scores))
	rownames(z) = rownames(scores)
	colnames(z) = colnames(scores)
	for(i in 1:nrow(scores)){
		# actualy length is 2x because we have two strands
		P.n = 2 * (seq.len[i] - pwm.len + 1)
		P.mean = bg.P * P.n
		P.sd = sqrt(P.n * bg.P * (1-bg.P))
		# so this would be the poisson approximation
		# z[i,] = 1 / ppois(scores[i,], P.mean, lower.tail=FALSE)
		z[i,] = keepFinite( (scores[i,] - P.mean) / P.sd )
	}
	
	return(z)
}

#' Z-score calculation for cutoff hits for group of sequences
#'
#' The Z-score is calculated as if the sequence came for one very long sequence
#'
#' @param scores the hit counts for the sequences
#' @param seq.len the length distribution of sequences
#' @param pwm.len the length distribution of the PWMs
#' @param bg.P background probabilities of observing a motif hit at nucleotide resolution
#' @return Z-score
cutoffZscoreSequenceSet = function(scores, seq.len, pwm.len, bg.P){	
	total.hits = colSums(scores)
	total.len = sum(seq.len) - length(seq.len)*(pwm.len-1) + pwm.len - 1
	
	# do it seperate for each PWM to make sure the lengths are right
	res = sapply(1:length(total.hits), function(i) cutoffZscore(total.hits[i], total.len[i], pwm.len[i], bg.P[i]))
	names(res) = names(total.hits)
	
	return(res)
}

#' Calculate the empirical P-value by affinity of cutoff. 
#'
#' This is the new backend function for empirical P-values for either affinity or cutoff. 
#' The function only works on single sequences. 
#'
#' @param scores the scores obtained for the sequence
#' @param seq.len the length of the sequence, if a single value will take a single sequence
#'                of given length. If a vector of values, will take sequences of given lengths
#'                and joint them together
#' @param pwm.len the lengths of PWMs
#' @param bg.fwd raw odds scores for the forward strand of background
#' @param bg.rev raw odds scores for the reverse strand of background
#' @param cutoff if not NULL, will use hit count above this cutoff. The cutoff should be specified in log2. 
#' @param B the number of random replicates
#' @param verbose if to give verbose progress reports
#' @param exact.length if to take into consideration that the actual sequence lengths differ for different PWMs.
#'                     For very long sequences (i.e. seq.len >> pwm.len) this make very little difference, however
#'                     the run time with exact.length is much longer. 
empiricalPvalue = function(scores, seq.len, pwm.len, bg.fwd, bg.rev, cutoff=NULL, B=10000, verbose=FALSE, exact.length=FALSE){
	# length of sequences
	bg.len = nrow(bg.fwd)
	
	if(max(seq.len) > bg.len){
		stop("The length of sequence greater than background!")
	} 
	
	if(max(seq.len) * B > bg.len){
		warning("The length of the sequence multiplied by number of runs (B) is greater than background length. This might lead to unreliable P-value estimates.")
	}
		
	# the empricial p-value
	score.p = rep(0, length(scores))
		
	for(i in 1:B){
		if(verbose)
			message("Random sample ", i, " / ", B)
		
		# calculate the final score as sum over different seq.len sequences
		final.score = 0
		for(k in 1:length(seq.len)){
			# choose a subsequence with matching length
			start.range = 1:(bg.len - seq.len[k])
			start = sample(start.range, 1)
		
			# fetch the scores from the two strands
			score.fwd = bg.fwd[start:(start+seq.len[k]-1),]
			score.rev = bg.rev[start:(start+seq.len[k]-1),]

			# simulate that we don't have scores for last pwm.len+1 nucleotides
			if(exact.length){
				for(j in 1:length(pwm.len)){
					score.fwd[(nrow(score.fwd)-pwm.len[j]+1):nrow(score.fwd),j] = NA
					score.rev[(nrow(score.rev)-pwm.len[j]+1):nrow(score.rev),j] = NA
				}
			}
			
			# append both strands to one long string		
			score.both = rbind(score.fwd, score.rev)
		
			if(is.null(cutoff)){
				# affinity algorithm
				new.score = colSums(score.both, na.rm=TRUE)
			} else {
				# number of hits above threshold
				new.score = colSums(score.both >= 2^cutoff, na.rm=TRUE)
			}
			final.score = final.score + new.score
		}
		
		# to obtain the mean we divide by twice the length (because it's both strands)
		final.score = final.score / (2 * sum(seq.len)) 
		
		score.p = score.p + ((final.score > scores) + 0)
		
	}
	
	return(score.p / B)
}

#' Empirical P-value for a set of sequences
#'
#' Calculate empirical P-value for a set of sequences, using either affinity or cutoff. When cutoff is used, the score
#' is a number of motif hits above a certain log-odds cutoff. 
#'
#' @param scores a matrix of scores, rows for sequences, columns for PWMs
#' @param seq.len the lengths of sequences
#' @param pwm.len the lengths of PWMs
#' @param bg.fwd raw odds scores for the forward strand of background
#' @param bg.rev raw odds scores for the reverse strand of background
#' @param cutoff if not NULL, will use hit count above this cutoff. The cutoff should be specified in log2. 
#' @param B the number of random replicates
#' @param verbose if to give verbose progress reports
empiricalPvalueSequenceSet = function(scores, seq.len, pwm.len, bg.fwd, bg.rev, cutoff=NULL, B=10000, verbose=FALSE){
	# affinity
	if(is.null(cutoff)){
		# total score for all the sequences
		s = structure(rep(0, ncol(scores)), names=colnames(scores))
		res = structure(rep(0, ncol(scores)), names=colnames(scores))
		exact.lengths = structure(rep(0, ncol(scores)), names=colnames(scores))
		for(i in 1:ncol(scores)){
			# lengths of sequences for this pwm, all of them are shorter by pwm.len-1
			seq.len.pwm = seq.len - pwm.len[i] + 1
			exact.lengths[i] = sum( seq.len.pwm )
		
			# sum over sequences then average by total length
			s[i] = sum(scores[,i] * seq.len.pwm) / sum(seq.len.pwm)			
		}
		
		# approximate sequence length without all the last positions being matched
		total.len = seq.len - round(mean(pwm.len))
		
		# run it on mean sequence length
		res = empiricalPvalue(s, total.len, pwm.len, bg.fwd, bg.rev, cutoff, B, verbose, exact.length=FALSE)
	
	 	return(res)
	} else {
		total.hits = colSums(scores)
		total.len = seq.len - round(mean(pwm.len)) #sum(seq.len) - length(seq.len)*pwm.len
	
		# run ti on mean sequence lengths (with pwm.len)
		res = empiricalPvalue(total.hits, total.len, pwm.len, 
					bg.fwd, bg.rev, cutoff, B, verbose, exact.length=FALSE)
					
		return(res)
	}
}

#' Apply GEV background normalization per every sequence
#' 
#' @param scores affinity scores for the PWMs, can contain scores for more than one sequence (as rows), P-values are extracted separately
#' @param seq.len the length distribution of the sequences
#' @param pwm.len the lengths of PWMs
#' @param bg.loc list of linear regression for location parameter
#' @param bg.scale list of linear regression for scale parameter
#' @param bg.shape list of linear regression for shape parameter
gevPerSequence = function(scores, seq.len, pwm.len, bg.loc, bg.scale, bg.shape){
	if(is.vector(scores)){
		scores = matrix(scores, nrow=1, dimnames=list(NULL, names(scores)))
	}
	if( length(seq.len) != nrow(scores) ){
		stop("The sequence length distribution and number of rows for scores doesn't match")
	}
	
	# calculate the expected sd values for the length distribution for each sequence
	seq.sd = matrix(0, nrow=nrow(scores), ncol=ncol(scores))
	
	log.seqlen = data.frame("log.len"=log(seq.len))
	
	# predict loc, scale, shape for each PWM
	loc = matrix(0, nrow=nrow(scores), ncol=ncol(scores))
	scale = matrix(0, nrow=nrow(scores), ncol=ncol(scores))
	shape = matrix(0, nrow=nrow(scores), ncol=ncol(scores))
	for(i in 1:ncol(scores)){
		loc[,i] = as.vector(predict.lm(bg.loc[[i]], newdata=log.seqlen))
		scale[,i] = as.vector(predict.lm(bg.scale[[i]], newdata=log.seqlen))
		shape[,i] = as.vector(predict.lm(bg.shape[[i]], newdata=log.seqlen))
	}
	
	## work out the P-values
	seq.p = matrix(0, nrow=nrow(scores), ncol=ncol(scores))
	colnames(seq.p) = colnames(scores)
	rownames(seq.p) = rownames(scores)
	
	for(i in 1:nrow(seq.p)){
		for(j in 1:ncol(seq.p)){
			# if scale is <0 the GEV approximation is no longer valid
			if(scale[i,j] < 0)
				seq.p[i,j] = NA
			else
				seq.p[i,j] = pgev(log(scores[i,j]), loc=loc[i,j], scale=scale[i,j], shape=shape[i,j], lower.tail=FALSE)
		}
	}
	
	seq.p
}

#' Calculate total affinity over a set of sequences
#'
#' @param scores affinity scores for individual sequences
#' @param seq.len lengths of sequences
#' @param pwm.len lengths of PWMs
affinitySequenceSet = function(scores, seq.len, pwm.len){
	if(is.vector(scores))
		scores = matrix(scores, nrow=1, dimnames=list(NULL, names(scores)))

	# final scores for the group
	final = structure(rep(0, ncol(scores)), names=colnames(scores))
	
	for(i in 1:ncol(scores)){
		# actual length of scanned sequence
		seq.len.pwm = seq.len - pwm.len[i] + 1
		
		final[i] = sum(scores[,i] * seq.len.pwm) / sum(seq.len.pwm)
	}
	
	return(final)
}

#' Calculate Recovery-AUC for motifs ranked according to some scoring scheme
#'
#' Note that this function asssumes that smaller values are better!
#' 
#' @param seq.res a matrix where each column represents a PWM and each row a result for a different sequence. 
motifRecoveryAUC = function(seq.res){
	# calculate the ranks
	r = t(apply(seq.res, 1, rank))
	
	# previous point needed to calculate AUC-ROC
	auc = rep(0, ncol(r))
	names(auc) = colnames(r)
	
	# do it for all whole steps
	rec = t(sapply(1:ncol(r), function(i) colSums(r<=i)))
	
	list("rec"=rec, "auc"=colSums(rec))
}

#' Calculate PR-AUC for motifs ranked according to some scoring scheme
#'
#' Note that this function asssumes that smaller values are better!
#' 
#' @param seq.res a matrix where each column represents a PWM and each row a result for a different sequence. 
motifPrAUC = function(seq.res){
	# calculate the ranks
	r = t(apply(seq.res, 1, rank))
	
	# previous point needed to calculate AUC-ROC
	auc = rep(0, ncol(r))
	names(auc) = colnames(r)
	
	# do it for all whole steps
	rec = t(sapply(1:ncol(r), function(i) colSums(r<=i)))
	
	recall = rec / nrow(r)
	prec = recall / 1:nrow(rec)
	
	list("prec"=prec, "recall"=recall)
}

library(PWMEnrich)
library(testthat)

# test for cases when the input is somehow invalid although it looks like a sequence

motifs.denovo = readMotifs(system.file(package="PWMEnrich", dir="extdata", file="example.transfac"), remove.acc=TRUE)

inseq = list(DNAString("AGTACCGATGACCGATGACC"), DNAString("NNNNNNNNNNNNNNNNNNN"))

# this should produce an error on the second sequence
test_that("N as input", {
	expect_error(motifScores(inseq, motifs.denovo))

	expect_error(motifEnrichment(inseq, motifs.denovo))
})

#' Name of different pieces of information associated with MotifEnrichmentResults
#'
#' @title Names of variables
#' @name names,MotifEnrichmentResults
#' @aliases names,MotifEnrichmentResults-method
#' @param x the MotifEnrichmentResults object
#' @return the names of the variables
#' @rdname operators-MotifEnrichmentResults
setMethod("names", signature=signature(x="MotifEnrichmentResults"), function(x) names(x@res))

#' Access a property by name
#'
#' @aliases $,MotifEnrichmentResults-method
#' @param x the MotifEnrichmentResults object
#' @param name the variable name
#' @rdname operators-MotifEnrichmentResults
setMethod("$", signature=signature(x="MotifEnrichmentResults"), function(x, name){
	x@res[[name]]
})


#' show method for MotifEnrichmentResults
#' @param object the MotifEnrichmentResults object
setMethod("show", signature=signature(object="MotifEnrichmentResults"), function(object){
	res = object@res
	is.group.only = length(grep("sequence[.]", names(res))) == 0
	
	cat("An object of class 'MotifEnrichmentResults':\n")
	cat("* created with '", res$score, "' scoring function with '", res$bg, "' background correction\n", sep="")
	cat("* on a set of ", length(res$sequences), " sequence(s) and ", length(res$pwms), " PWMs\n", sep="")
	cat("Result sets for the group:",paste("$", names(res)[grep("group[.]", names(res))], sep="", collapse=", "), "\n")
	if(!is.group.only){
		cat("Result sets for individual sequences:", paste("$", names(res)[grep("sequence[.]", names(res))], sep="", collapse=", "), "\n")
		cat("Report methods: groupReport(), sequenceReport()\n")
		#cat("Methods to extract data: motifRankingForGroup(), motifRankingForSequence()\n")
		#cat("Methods to plot data: plotTopMotifsGroup(), plotTopMotifsSequence()\n")
	} else {
		cat("Report method: sequenceReport()\n")
		#cat("Methods to extract data: motifRankingForGroup()\n")
		#cat("Methods to plot data: plotTopMotifsGroup()\n")
	}
	
})

#' A helper function for motifRankingForGroup and motifRankingForSequence with the common code
#'
#' @param res the list of results from MotifEnrichmentResults object
#' @param r the vector of raw results that needs to be processed
#' @param id if to return IDs instead of names
#' @param order if to return the ordering of motifs
#' @param rank if to return the rank of motifs
#' @param unique if to remove duplicates
#' @param decreasing specifies the sorting order
rankingProcessAndReturn = function(res, r, id, order, rank, unique, decreasing){
	if((unique & id) || (unique & order)){
		stop("Parameter 'unique' can be set to TRUE only if 'id' and 'order' are FALSE.")
	}


	# set either the names or IDs
	all.ids = sapply(res$pwms, function(x) x@id)
	all.names = sapply(res$pwms, function(x) x@name)
	
	if(id){
		names(r) = all.ids
	} else {
		if(!all(all.names == ""))
			names(r) = all.names
	}
	
	# do the required transformation on the results
	ret = NULL
	if(rank){
		x = base::rank(r)
		if(decreasing)
			x = length(x) - x + 1
		names(x) = names(r)
		ret = x
	} else if(order){
		x = base::order(r, decreasing=decreasing)
		names(x) = names(r)[x]
		ret = x
	} else {
		ret = sort(r, decreasing=decreasing)
	}
	
	# remove duplicates if applicable	
	if(unique){
		original.names = names(ret)		
		if(decreasing & !rank)
			ret = tapply(ret, names(ret), max)
		else
			ret = tapply(ret, names(ret), min)
			
		if(rank){
			# re-rank the ranks... 
			ret = rank(ret) 
		}
		
		# unique names with correct ordering
		uniq.names = c()
		for(i in 1:length(original.names)){
			if(!(original.names[i] %in% uniq.names))
				uniq.names[length(uniq.names)+1] = original.names[i]
		}
		
		# re-order in the original ordering	
		ret = ret[uniq.names]
	}
	
	ret

}

#' Get a ranking of motifs by their enrichment in the whole set of sequences
#'
#' @name motifRankingForGroup,MotifEnrichmentResults-method
#' @aliases motifRankingForGroup
#' @param obj a MotifEnrichmentResults object
#' @param bg if to use background corrected P-values to do the ranking (if available)
#' @param id if to show PWM IDs instead of target TF names
#' @param order if to output the ordering of PWMs instead of actual P-values or raw values
#' @param rank if the output should be rank of a PWM instead of actual P-values or raw values
#' @param unique if TRUE, only the best rank is taken for each TF (only when id = FALSE, order = FALSE)
#' @param ... currently unused
#'
#' @return a vector of P-values or raw enrichments sorted such that the first motif is most enriched
#' @export
#' @examples
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    ###
#'    # load the pre-compiled lognormal background
#'    data(PWMLogn.dm3.MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    # scan two sequences for motif enrichment
#'    sequences = list(DNAString("GAAGTATCAAGTGACCAGTAAGTCCCAGATGA"), 
#'      DNAString("AGGTAGATAGAACAGTAGGCAATGAAGCCGATG"))
#'    res = motifEnrichment(sequences, PWMLogn.dm3.MotifDb.Dmel)
#'
#'    # most enriched in both sequences (sorted by lognormal background P-value)
#'    head(motifRankingForGroup(res))
#'
#'    # Return a non-redundant set of TFs
#'    head(motifRankingForGroup(res, unique=TRUE))
#'
#'    # sorted by raw affinity instead of P-value
#'    head(motifRankingForGroup(res, bg=FALSE))
#'
#'    # show IDs instead of target TF names
#'    head(motifRankingForGroup(res, id=TRUE))
#'
#'    # output the rank instead of P-value
#'    head(motifRankingForGroup(res, rank=TRUE))
#' }
setMethod("motifRankingForGroup", signature=signature(obj="MotifEnrichmentResults"), function(obj, bg=TRUE, id=FALSE, order=FALSE, rank=FALSE, unique=FALSE, ...){
	res = obj@res
	
	# vector of scores
	if(bg && "group.bg" %in% names(res)){
		r = res$group.bg
		if(res$score == "cutoff" | res$bg == "ms")
			decreasing = TRUE
		else
			decreasing = FALSE
	} else {
		#if(bg) 
		#	warning("Parameter 'bg' is TRUE but this MotifEnrichmentResults object has no background correction, ignoring parameter.")
		r = res$group.nobg
		decreasing = TRUE
	}
	
	rankingProcessAndReturn(res, r, id, order, rank, unique, decreasing)
})

#' Get a ranking of motifs by their enrichment in one specific sequence
#'
#' @name motifRankingForSequence,MotifEnrichmentResults-method
#' @aliases motifRankingForSequence
#' @param obj a MotifEnrichmentResults object
#' @param seq.id either the sequence number or sequence name 
#' @param bg if to use background corrected P-values to do the ranking (if available)
#' @param id if to show PWM IDs instead of target TF names
#' @param order if to output the ordering of PWMs instead of actual P-values or raw values
#' @param rank if the output should be rank of a PWM instead of actual P-values or raw values
#' @param unique if TRUE, only the best rank is taken for each TF (only when id = FALSE, order = FALSE)
#' @param ... currently unused
#'
#' @export
#' @return a vector of P-values or raw enrichments sorted such that the first motif is most enriched
#'
#' @examples
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    ###
#'    # load the pre-compiled lognormal background
#'    data(PWMLogn.dm3.MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    # scan two sequences for motif enrichment
#'    sequences = list(DNAString("GAAGTATCAAGTGACCAGTAAGTCCCAGATGA"), 
#'      DNAString("AGGTAGATAGAACAGTAGGCAATGAAGCCGATG"))
#'    res = motifEnrichment(sequences, PWMLogn.dm3.MotifDb.Dmel)
#'
#'    # most enriched in the second sequences (sorted by lognormal background P-value)
#'    head(motifRankingForSequence(res, 2))
#'
#'    # return unique TFs enriched in sequence 2
#'    head(motifRankingForSequence(res, 2, unique=TRUE))
#'
#'    # sorted by raw affinity instead of P-value
#'    head(motifRankingForSequence(res, 2, bg=FALSE))
#'
#'    # show IDs instead of target TF names
#'    head(motifRankingForSequence(res, 2, id=TRUE))
#'
#'    # output the rank instead of P-value
#'    head(motifRankingForSequence(res, 2, rank=TRUE))
#' }
setMethod("motifRankingForSequence", signature=signature(obj="MotifEnrichmentResults"), function(obj, seq.id, bg=TRUE, id=FALSE, order=FALSE, rank=FALSE, unique=FALSE, ...){
	res = obj@res
	
	if(missing(seq.id)){
		stop("Please specify the sequence number with 'seq.id'")
	}
	
	# vector of scores
	if(bg && "sequence.bg" %in% names(res)){
		r = res$sequence.bg[seq.id,]
		if(res$score == "cutoff" | res$bg == "ms")
			decreasing = TRUE
		else
			decreasing = FALSE
	} else {
		#if(bg) 
		#	warning("Parameter 'bg' is TRUE but this MotifEnrichmentResults object has no background correction, ignoring parameter.")
		r = res$sequence.nobg[seq.id,]
		decreasing = TRUE
	}
	
	rankingProcessAndReturn(res, r, id, order, rank, unique, decreasing)

})

#' Plot the top N enrichment motifs in a group of sequences
#'
#' @name plotTopMotifsGroup,MotifEnrichmentResults-method
#' @aliases plotTopMotifsGroup
#' @param obj a MotifEnrichmentResults object
#' @param n the number of top ranked motifs to plot
#' @param bg if to use background corrected P-values to do the ranking (if available)
#' @param id if to show PWM IDs instead of target TF names
#' @param ... other parameters passed to \code{plotMultipleMotifs()}
#' @export
#' @examples
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    ###
#'    # load the pre-compiled lognormal background
#'    data(PWMLogn.dm3.MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    # scan two sequences for motif enrichment
#'    sequences = list(DNAString("GAAGTATCAAGTGACCAGTAAGTCCCAGATGA"), 
#'      DNAString("AGGTAGATAGAACAGTAGGCAATGAAGCCGATG"))
#'
#'    res = motifEnrichment(sequences, PWMLogn.dm3.MotifDb.Dmel)
#'
#'    # plot the top 4 motifs in a 2x2 grid
#'    plotTopMotifsGroup(res, 4)
#'
#'    # plot top 3 motifs in a single row
#'    plotTopMotifsGroup(res, 3, row=1, cols=3)
#' }
setMethod("plotTopMotifsGroup", signature=signature(obj="MotifEnrichmentResults"), function(obj, n, bg=TRUE, id=FALSE, ...){
	o = motifRankingForGroup(obj, bg, id, order=TRUE)
	
	plotMultipleMotifs(obj@res$pwms[o[1:n]], names(o)[1:n], ...)
})

#' Plot the top N enrichment motifs in a single sequence
#'
#' @name plotTopMotifsSequence,MotifEnrichmentResults-method
#' @aliases plotTopMotifsSequence
#' @param obj a MotifEnrichmentResults object
#' @param seq.id either the sequence number or sequence name 
#' @param n the number of top ranked motifs to plot
#' @param bg if to use background corrected P-values to do the ranking (if available)
#' @param id if to show PWM IDs instead of target TF names
#' @param ... other parameters passed to \code{plotMultipleMotifs()}
#' @export
#' @examples
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    ###
#'    # load the pre-compiled lognormal background
#'    data(PWMLogn.dm3.MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    # scan two sequences for motif enrichment
#'    sequences = list(DNAString("GAAGTATCAAGTGACCAGTAAGTCCCAGATGA"), 
#'      DNAString("AGGTAGATAGAACAGTAGGCAATGAAGCCGATG"))
#'
#'    res = motifEnrichment(sequences, PWMLogn.dm3.MotifDb.Dmel)
#'
#'    # plot the top 4 motifs in a 2x2 grid
#'    plotTopMotifsSequence(res, 1, 4)
#'
#'    # plot top 3 motifs in a single row
#'    plotTopMotifsSequence(res, 1, 3, row=1, cols=3)
#' }
setMethod("plotTopMotifsSequence", signature=signature(obj="MotifEnrichmentResults"), function(obj, seq.id, n, bg=TRUE, id=FALSE, ...){
	o = motifRankingForSequence(obj, seq.id, bg, id, order=TRUE)
	
	plotMultipleMotifs(obj@res$pwms[o[1:n]], names(o)[1:n], ...)
})

#' Generate a motif enrichment report for the whole group of sequences together
#'
#' @name groupReport,MotifEnrichmentResults-method
#' @aliases groupReport
#' @param obj a MotifEnrichmentResults object
#' @param top what proportion of top motifs should be examined in each individual sequence (by default 0.05, i.e. 5\%)
#' @param bg if to use background corrected P-values to do the ranking (if available)
#' @param by.top.motifs if to rank by the proportion of sequences where the motif is within 'top' percentage of motifs
#' @param ... unused
#' @return a MotifEnrichmentReport object containing a table with the following columns: 
#' \itemize{
#'    \item 'rank' - The rank of the PWM's enrichment in the whole group of sequences together
#'    \item 'target' - The name of the PWM's target gene, transcript or protein complex. 
#'    \item 'id' - The unique identifier of the PWM (if set during PWM creation).
#'    \item 'raw.score' - The raw score before P-value calculation
#'    \item 'p.value' - The P-value of motif enrichment (if available)
#'    \item 'top.motif.prop' - The proportion (between 0 and 1) of sequences where the motif is within \code{top} proportion of enrichment motifs. 
#' } 
#' @export
#' @examples
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    ###
#'    # load the pre-compiled lognormal background
#'    data(PWMLogn.dm3.MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    # scan two sequences for motif enrichment
#'    sequences = list(DNAString("GAAGTATCAAGTGACCAGTAAGTCCCAGATGA"), 
#'      DNAString("AGGTAGATAGAACAGTAGGCAATGAAGCCGATG"))
#'
#'    res = motifEnrichment(sequences, PWMLogn.dm3.MotifDb.Dmel)
#'
#'    # produce a report for all sequences taken together
#'    r.default = groupReport(res)
#'
#'    # produce a report where the last column takes top 1% motifs
#'    r = groupReport(res, top=0.01)
#'
#'    # view the results
#'    r
#'
#'    # plot the top 10 most enriched motifs
#'    plot(r[1:10])
#' 
#' }
setMethod("groupReport", signature=signature(obj="MotifEnrichmentResults"), function(obj, top=0.05, bg=TRUE, by.top.motifs=FALSE, ...){
	pwms = obj$pwms	
	res = obj@res
		
	# correct ordering of motifs
	o = motifRankingForGroup(obj, rank=TRUE, bg=bg)
	
	targets = sapply(obj$pwms, function(x) x@name)
	ids = sapply(obj$pwms, function(x) x@id)
	
	# construct the initial data frame object
	df = data.frame(rank=o, target=targets, id=ids, raw.score=obj$group.nobg, stringsAsFactors=FALSE)
	
	if(bg && "group.bg" %in% names(obj)){
		p.value = obj$group.bg
	} else {
		p.value = as.numeric(NA)
	}
	
	if(res$score == "cutoff" | res$bg == "ms"){
		df = data.frame(df, z.score=p.value, stringsAsFactors=FALSE)
	} else {
		df = data.frame(df, p.value=p.value, stringsAsFactors=FALSE)
	}
	
	# calculate in how many top sequences is the motif present
	if("sequence.nobg" %in% names(obj)){
		pct.top = rep(0, nrow(df))
		pct.cutoff = nrow(df) * top
		num.seq = nrow(obj$sequence.nobg)
		for(i in 1:num.seq){
			os = motifRankingForSequence(obj, i, rank=TRUE, bg=bg)
			pct.top = pct.top + (os <= pct.cutoff)
		}
		pct.top = pct.top / num.seq
		
		top.motif = pct.top
	} else {
		top.motif = as.numeric(NA)
	}
	
	df = data.frame(df, "top.motif.prop"=top.motif, stringsAsFactors=FALSE)
	
	if(by.top.motifs){
		if(length(pwms) < 20)
			warning("You are sorting by top motifs, but this can be unreliable when number of PWMs is small.")
		df$rank = base::rank(-top.motif)
	}
	
	# sort and return
	correct.order = order(df$rank)
	
	df = df[correct.order,]
	rownames(df) = NULL
	pwms = pwms[correct.order]
	
	# return a MotifEnrichmentReport object
	new("MotifEnrichmentReport", d=df, pwms=pwms)
})

#' Generate a motif enrichment report for a single sequence
#'
#' @name sequenceReport,MotifEnrichmentResults-method
#' @aliases sequenceReport
#' @param obj a MotifEnrichmentResults object
#' @param seq.id the sequence index or name
#' @param bg if to use background corrected P-values to do the ranking (if available)
#' @param ... unused
#' @return a MotifEnrichmentReport object containing a table with the following columns: 
#' \itemize{
#'    \item 'rank' - The rank of the PWM's enrichment in the sequence
#'    \item 'target' - The name of the PWM's target gene, transcript or protein complex. 
#'    \item 'id' - The unique identifier of the PWM (if set during PWM creation).
#'    \item 'raw.score' - The raw score before P-value calculation
#'    \item 'p.value' - The P-value of motif enrichment (if available)
#' } 
#' @export
#' @examples
#' if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
#'    ###
#'    # load the pre-compiled lognormal background
#'    data(PWMLogn.dm3.MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")
#'
#'    # scan two sequences for motif enrichment
#'    sequences = list(DNAString("GAAGTATCAAGTGACCAGTAAGTCCCAGATGA"), 
#'      DNAString("AGGTAGATAGAACAGTAGGCAATGAAGCCGATG"))
#'
#'    res = motifEnrichment(sequences, PWMLogn.dm3.MotifDb.Dmel)
#'
#'    # reports for the two sequences
#'    r1 = sequenceReport(res, 1)
#'    r2 = sequenceReport(res, 2)
#'
#'    # view the results
#'    r1
#'    r2
#'
#'    # plot the top 10 most enriched motifs in the first, and then second sequence
#'    plot(r1[1:10])
#'    plot(r2[1:10])
#' 
#' }
setMethod("sequenceReport", signature=signature(obj="MotifEnrichmentResults"), function(obj, seq.id, bg=TRUE, ...){
	if(missing(seq.id)){
		stop("Please specify the sequence number with 'seq.id'")
	}
	res = obj@res

	pwms = obj$pwms	
		
	# correct ordering of motifs
	o = motifRankingForSequence(obj, seq.id, rank=TRUE, bg=bg)
	
	targets = sapply(obj$pwms, function(x) x@name)
	ids = sapply(obj$pwms, function(x) x@id)
	
	# construct the initial data frame object
	df = data.frame(rank=o, target=targets, id=ids, raw.score=obj$sequence.nobg[seq.id,], stringsAsFactors=FALSE)
	
	if(bg && "sequence.bg" %in% names(obj)){
		p.value = obj$sequence.bg[seq.id,]
	} else {
		p.value = as.numeric(NA)
	}

	if(res$score == "cutoff" | res$bg == "ms"){
		df = data.frame(df, z.score=p.value, stringsAsFactors=FALSE)
	} else {
		df = data.frame(df, p.value=p.value, stringsAsFactors=FALSE)
	}
		
	# sort and return
	correct.order = order(df$rank)
	
	df = df[correct.order,]
	rownames(df) = NULL
	pwms = pwms[correct.order]
	
	# return a MotifEnrichmentReport object
	new("MotifEnrichmentReport", d=df, pwms=pwms)
})

## load in motifs 

#' Read in motifs in JASPAR or TRANSFAC format
#'
#' The format is autodetected based on file format. If the autodetection fail
#' then the file cannot be read. 
#'
#' @param file the filename
#' @param remove.acc if to remove accession numbers. If TRUE, the AC entry in TRANSFAC files is ignored,
#'                   and the accession is stripped from JASPAR, e.g. motif with name "MA0211.1 bap" would 
#'                   become just "bap". If FALSE, botht he AC and ID are used to generate the TRANSFAC name
#'                   and the original motif names are preserved in JASPAR files. 
#' @return a list of 4xL matrices representing motifs (four nucleotides as rows)
#' @export
#' @examples
#'
#' # read in example TRANSFAC motifs without accession codes (just IDs)
#' readMotifs(system.file(package = "PWMEnrich", dir = "extdata", file = "example.transfac"), 
#'   remove.acc = TRUE)
#'
#' # read in the JASPAR insects motifs provided as example
#' readMotifs(system.file(package = "PWMEnrich", dir = "extdata", file = "jaspar-insecta.jaspar"), 
#'   remove.acc = TRUE)
readMotifs = function(file, remove.acc=FALSE){
	t = readLines(file)
	
	if(length(t) == 0){
		stop(paste("Non-existing or empty file", file))
	}
	
	is.transfac = length(grep("^XX", t)) > 0
	is.jaspar = length(grep("^>", t)) > 0
	
	if((is.transfac & is.jaspar) | (!is.transfac & !is.jaspar)){
		stop("Cannot detect the file format of supplied file. Please look at the JASPAR and TRANSFAC websites for examples of well-formed motif files.")
	}
	
	if(is.jaspar){
		return(readJASPAR(file, remove.acc))
	} else {
		return(readTRANSFAC(file, remove.acc)) 
	}
}


#' Read motifs in JASPAR format
#'
#' @param file the filename
#' @param remove.ids if to strip JASPAR ID's from motif names, e.g. "MA0211.1 bap" would become just "bap"
#' @return a list of matrices representing motifs (with four nucleotides as rows)
readJASPAR = function(file, remove.ids=FALSE){
	t = readLines(file)
	
	h = grep("^>", t)
	
	# ordering of nucleotides
	norder = c("A", "C", "G", "T")

	motifs = list()

	for(i in 1:length(h)){
		# header and motif from jaspar format
		header = t[h[i]]
		h.inx = (h[i]+1)
		motif = t[h.inx:(h.inx+3)]
	
		# motif in clover format
		motif.matrix = t(sapply(strsplit(motif, "[ \t\\[]+"), function(x) as.integer(x[2:(length(x)-1)])))
		nucleotides = sapply(strsplit(motif, "[ \t\\[]+"), function(x) x[1])
		# in the new version of JASPAR format there is no ACGT... 
		if(!all(nucleotides %in% norder)){
			nucleotides = norder
			motif.matrix = t(sapply(strsplit(motif, "[ \t\\[]+"), function(x) as.integer(x)))
		}	
		# if the ordering is not the same, re-order into ACGT order
		motif.matrix = motif.matrix[match(norder, nucleotides), ]
		rownames(motif.matrix) = norder
		
		motifs[[i]] = motif.matrix
		motif.name = trim(gsub(">", "", header))
		if(remove.ids){
			motif.parts = unlist(strsplit(motif.name, " +"))
			if(length(motif.parts)>1){
				motif.name = paste(motif.parts[2:length(motif.parts)], collapse="_")
			}
		}
		names(motifs)[i] = motif.name
	
	}
	
	motifs
}

#' Read in motifs in TRANSFAC format
#'
#' @param file the filename
#' @param remove.acc if to ignore transfac accession numbers
#' @return a list of matrices representing motifs (with four nucleotides as rows)
readTRANSFAC = function(file, remove.acc=TRUE){
	t = readLines(file)
	
	# ordering of nucleotides
	norder = c("A", "C", "G", "T")
	
	# get indicies of different tags
	ac.inx = grep("^AC", t)
	id.inx = grep("^ID", t)
	po.inx = grep("^P[O0]", t)
	xx.inx = grep("^XX", t)
	
	if(length(ac.inx) != length(id.inx) || length(ac.inx) != length(po.inx) || !all(ac.inx < id.inx) || !all(id.inx < po.inx)){
		stop("Inconsistent TRANSFAC format. Every motif needs to have exactly one AC, ID and PO/P0 entry (in that order).")
	}

	# extract individual motifs	
	motifs = list()
	for(i in 1:length(ac.inx)){
		ac = trim(gsub("^AC", "", t[ac.inx[i]]))
		# find the id entry that is just after the ac entry
		id.cur = min( id.inx[id.inx > ac.inx[i]] )
		id = trim(gsub("^ID", "", t[id.cur]))
		# find boundaries of the motif
		po.cur = min( po.inx[po.inx > ac.inx[i]] )
		xx.cur = min( xx.inx[xx.inx > po.cur] )
		
		# check the ordering of nucleotides
		po = trim(gsub("^P[O0]", "", t[po.cur]))
		po = unlist(strsplit(po, "[ \t]+"))
		if(!identical(po, norder)){
			stop(paste("In all motifs the nucleotides need to be ordered: A C G T. This is not the case for motif", id))
		}
		
		# extract motif
		m = t[(po.cur+1) : (xx.cur-1)]
		m = strsplit(m, "[ \t]+")
		m = sapply(m, as.integer)[-1,]		
		rownames(m) = norder
		
		# generate the name and save
		if(remove.acc)
			name = id
		else
			name = paste(ac, id, sep="_")
		
		motifs[[name]] = m
	}
	
	motifs

}

%\VignetteEngine{knitr::knitr}
%\VignetteIndexEntry{Overview of the 'PWMEnrich' package}
%\VignetteKeywords{Motif enrichment, PWM}
%\VignettePackage{PWMEnrich}
\documentclass{article}

\usepackage{float}
\usepackage{a4wide}

<<include=FALSE>>=
library(knitr)
opts_chunk$set(
echo=TRUE,eval=TRUE,cache=FALSE,tidy=FALSE
)
@

<<include=FALSE>>=
library(knitr)
opts_chunk$set(
tidy=FALSE,dev='pdf',
message=FALSE, warning=FALSE
)
@

<<style-knitr, eval=TRUE, echo=FALSE, results="asis">>=
BiocStyle::latex()
@

%% colors
\usepackage{color}
\definecolor{Red}{rgb}{0.7,0,0}
\definecolor{Blue}{rgb}{0,0,0.8}


\hypersetup{%
  hyperindex = {true},
  colorlinks = {true},
  linktocpage = {true},
  plainpages = {false},
  linkcolor = {Blue},
  citecolor = {Blue},
  urlcolor = {Blue},
  pdfstartview = {Fit},
  pdfpagemode = {UseOutlines},
  pdfview = {XYZ null null null}
}

\author{Robert Stojni\'{c}\footnote{
  e-mail: \email{robert.stojnic@gmail.com},
  Cambridge Systems Biology Institute,
  University of Cambridge, UK}
}


\begin{document}

\title{Overview of the \Biocpkg{PWMEnrich} package}

\maketitle

\tableofcontents

\section{Introduction}\label{sec:intro} 

The main functionality of the package is Position Weight Matrix (PWM)\footnote{In this vignette we use "PWM", "DNA motif" and "motif" interchangeably.} enrichment analysis in a single sequence (e.g. enhancer of interest) or a set of sequences (e.g. set of ChIP-chip/seq peaks). Note that this is not the same as \textit{de-novo} motif finding which discovers novel motifs, nor motif comparison which aligns motifs.  

The package is built upon \Robject{Biostrings} and offers high-level functions to scan for DNA motif occurrences and compare them against a genomic background. There are multiple packages with pre-compiled genomic backgrounds such as \Robject{PWMEnrich.Dmelanogaster.background}, \Robject{PWMEnrich.Hsapiens.background} and \Robject{PWMEnrich.Mmusculus.background}. In these packages the genomic distribution is calculated for motifs from the \Robject{MotifDb} database. The \Robject{PWMEnrich} package contains all the functions used to create these packages, so you can calculate your own background distributions for your own set of motifs. In this vignette we will use the \textit{Drosophila} package, but the other background packages are used in the same way (see Section \ref{sec:human} for minor human-specific differences). 

\subsection{Implemented algorithms}

\Robject{PWMEnrich} uses the PWM scanning algorithm implemented by the package \Robject{Biostrings}. This package returns PWM scores at each position on one strand of a sequence. \Robject{PWMEnrich} extends this with a higher-level functions which automatically scans both strands for multiple motifs and sequences.

The main goal of the package is to assess the enrichment of motif hits in a sequence (or group of sequences) compared to a genomic background. The traditional way of doing this is to use a threshold for the PWM score and count the number of motif hits in the sequence(s) of interest. Since this converts the sequence into a binary bound/not-bound string, the enrichment of binding events can be assessed using a binomial formula. The \Robject{PWMEnrich} package implements this algorithm, but by default uses a lognormal threshold-free approach \cite{stojnic_2012} which is related to the score used in Clover \cite{frith_detection_2004}. 

In the lognormal threshold-free approach average affinity is calculated over the whole sequence (or set of sequences) and compared to the average affinity of length-matched sequences from the genomic background. This approach performs better or same as the best threshold approach \cite{stojnic_2012}, with the added benefit of not having to choose a threshold or compare the results for multiple thresholds. We will use this threshold-free approach in all of our examples. Please consult the reference manual on how to use the fixed-threshold algorithms. 

\subsection{S4 class structure and accessors}

As the \Biocpkg{PWMEnrich} package builds upon the \Biocpkg{Biostrings} package it uses the classes from this package to represent DNA sequences (\Robject{DNAString} and \Robject{DNAStringSet}). FASTA files can be loaded using functions from \Biocpkg{Biostrings} such as \Robject{readDNAStringSet}. The package introduces a new class \Robject{PWM} to represent a PWM together with the frequency matrix and other parameters (background nucleotide frequencies and pseudo-counts). All motif scoring is performed by the \Biocpkg{Biostrings} package which is why the \Biocpkg{PWMEnrich} package also returns log2 scores instead of more common log base \textit{e} scores. 

The results of motif scanning are stored in objects of class \Robject{MotifEnrichmentResults} and \Robject{MotifEnrichmentReport}. The package also introduces a number of classes that represent different background distributions: \Robject{PWMLognBackground}, \Robject{PWMCutoffBackground}, \Robject{PWMEmpiricalBackground}, \Robject{PWMGEVBackground}. In all cases, the classes are implemented with a list-like interface, that is, individual pieces of information within the objects are accessibly using \Rfunction{names(obj)} and \Rfunction{obj\$prop}. 

\section{Use case 1: Finding enrichment motifs in a single sequence}

One of the most well-known example of combinatorial control by transcription factors in \textit{Drosophila} is the \textit{even skipped (eve)} stripe 2 enhancer. This well-studied enhancer has a number of annotated binding sites for TFs \textit{Kr}, \textit{vfl}, \textit{bcd}, \textit{hb} and \textit{gt}. We will use this enhancer as an example as we already know its functional structure.

In order to predict which TFs are likely to functionally bind to the stripe 2 enhancer, we will calculate motif enrichment for a set of experimentally derived motifs from the \Biocpkg{MotifDb} database. We will do this by comparing the average affinity of each motif in the stripe 2 enhancers to the affinity over all \textit{D. melanogaster} promoters\footnote{For more information see \cite{stojnic_2012}}. These background distributions are already pre-calculated in the \Robject{PWMEnrich.Dmelanogaster.background} package which we will simply load and use. See the last section of this vignette for using your own motifs and background sequences. 

<<simple,echo=TRUE>>=
library(PWMEnrich)
library(PWMEnrich.Dmelanogaster.background)

# load the pre-compiled lognormal background
data(PWMLogn.dm3.MotifDb.Dmel)

# load the stripe2 sequences from a FASTA file for motif enrichment
sequence = readDNAStringSet(system.file(package="PWMEnrich", 
  dir="extdata", file="stripe2.fa"))
sequence  

# perform motif enrichment!
res = motifEnrichment(sequence, PWMLogn.dm3.MotifDb.Dmel)

report = sequenceReport(res, 1)
report

# plot the motif with P-value < 0.05
plot(report[report$p.value < 0.05], fontsize=7, id.fontsize=6)
@

The main function we used is \Robject{motifEnrichment} which took our sequence and calculated motif enrichment using the lognormal affinity background distribution (fitted on a set of 10031 \textit{D. melanogaster} 2kb promoters). This function returns a set of scores and P-values for our sequence. We then used the \Robject{sequenceReport} function that create a ranked list of motifs, which we then plot using \Robject{plot}. The first column is the rank, the second shows the target name, which is either a gene name, an isoform name (such as ttk-PF), or a dimer name (such as tgo\_sim not present in this list). The next column in the plot is the PWM logo, and after that the motif ID. This ID comes from the \Robject{MotifDb} package and can be used to look up further information about the motif (such as the motif source). The next-to-last column is the raw affinity score, and the last column is the P-value of motif enrichment. 

As we can see, the top of the list is dominated by motifs similar to bcd. By further examining the list, we find we recovered the Kr, bcd and gt motifs, but not the vfl and hb motifs. These two TFs (vfl and hb) have the smallest number of annotated binding sites out of the five TFs in the stripe 2 enhancer. As a result, this affinity is not large enough to be picked up by motif enrichment. However, the other three motifs were picked up. We find this to be the typical case for many enhancers.  

\section{Use case 2: Examining the binding sites}

We continue with our example of the eve stripe 2 enhancer from the previous section. We now want to visualise the binding sites for Kr, bcd and gt. 

<<stripe2visual,echo=TRUE,fig.width=4,fig.height=4,fig.align='center'>>=

# extract the 3 PWMs for the TFs we are interested in
ids = c("bcd_FlyReg_FBgn0000166", 
        "gt_FlyReg_FBgn0001150", 
        "Kr")
sel.pwms = PWMLogn.dm3.MotifDb.Dmel$pwms[ids]
names(sel.pwms) = c("bcd", "gt", "Kr")

# scan and get the raw scores
scores = motifScores(sequence, sel.pwms, raw.scores=TRUE)

# raw scores for the first (and only) input sequence
dim(scores[[1]])
head(scores[[1]])

# score starting at position 1 of forward strand
scores[[1]][1, "bcd"]
# score for the reverse complement of the motif, starting at the same position
scores[[1]][485, "bcd"]

# plot
plotMotifScores(scores, cols=c("green", "red", "blue"))
@

Here we used the \Robject{motifScores} function to obtain the raw scores at each position in the sequence. The result of this function is a list of matrices, each element of the list corresponding to an input sequence. In this case we had only one input sequence, and as a result we get a list of length 1. The matrix of scores is a 968 x 3 matrix, where the rows correspond to the two strands (2 x 484) and the columns correspond to motifs. It is important to remember that the scores are in real and not log space. In other words, a conventional PWM log2 score of 3 is represented as number 8 ($2^3$). 

The scores for the two strands are concatenated one after the other. Therefore, row 1 has the scores for the motif starting at position 1, and row 485 has the score at the same position, but with the reverse complement of the motif (i.e. motif score on the reverse strand). Note that there will be some NA values at the end of the sequence (e.g. position 484) because we do not support partial motif matches. 

Finally we use the \Robject{plotMotifScores} function to plot the log2 scores over the sequence. We colour-code the motifs with green, red and blue. The motif hits are shown as rectangles with the base being the length of the motif, and the hight being the log2 score of the motif hit. By default we show all motif hits with log2 scores larger then 0. The forward strand hits are shown on the top, and the reverse strand hits are shown on the bottom. 

We next might be interested in finding the P-value for individual motif hits so we can get an idea which sites are the most important. To do this we need to calculate the empirical PWM score distribution for single sites. We did not provide these values precalculated because they take up a very large amount of memory. To calculate it based on a set of promoter, we will need the \textit{D. melanogaster} genome sequence. Because the objects are so large, in this example we will determine the P-value only for the hits of the bcd motif, using only a small subset of promoters (controlled by the parameter \Robject{quick=TRUE}).

<<motifEcdf,echo=TRUE,fig.width=4,fig.height=4,fig.align='center'>>=
library(BSgenome.Dmelanogaster.UCSC.dm3)

# empirical distribution for the bcd motif
bcd.ecdf = motifEcdf(sel.pwms$bcd, Dmelanogaster, quick=TRUE)[[1]]

# find the score that is equivalent to the P-value of 1e-3
threshold.1e3 = log2(quantile(bcd.ecdf, 1 - 1e-3))
threshold.1e3 

# replot only the bcd motif hits with the P-value cutoff of 1e-3 (0.001)
plotMotifScores(scores, cols="green", sel.motifs="bcd", cutoff=threshold.1e3)

# Convert scores into P-values
pvals = 1 - bcd.ecdf(scores[[1]][,"bcd"])
head(pvals)
@

Here we have used the \Robject{motifEcdf} function to create an empirical cumulative distribution function (ECDF) for the bcd motif score on Drosophila promoters. This function returns an \Robject{ecdf} object which is part of base R. We can then use the quantile function to find which scores correspond to a P-value of 0.001, or we can use it to convert all the scores into P-values (not shown above). To plot the individual motif hits with P-values smaller than 0.001 we again use the \Robject{plotMotifScores} function, but now we apply the threshold so that only those motif hits above the threshold are drawn.  

In the last line we find out the positions of those motif hits where the P-value is smaller then 1e-3. Note that the values larger than the sequence length (484) indicate the reverse strand. Therefore, we find the four strong motif hits at positions 90 on the forward strand and 110, 354 and 475 on the reverse strand. 

Note that \Robject{plotMotifScores} can also plot multiple sequences on a single plot, and that the \Robject{cutoff} parameter can contain a vector of values if we wish to apply different cutoff to different motifs. 

\section{Use case 3: Finding enriched motifs in multiple sequences}

So far we have only looked at motif enrichment in a single sequence, which was able to recover some but not all of the truly functional motifs. The power of the motif enrichment approach can be significantly boosted by performing it jointly on multiple sequences. 

For this example we are going to use the top 20 ChIP-chip peaks for transcription factor Tinman in \textit{Drosophila} \cite{jin_genome-wide_2013}. We are going to scan these 20 ChIP-chip peaks with all the motifs and then compare their enrichment to genomic background. Running on the whole set of peaks (i.e. thousands) is also possible but can take a long time (i.e. tens of minutes). The speed can be improved by using multiple CPU cores (see next section). 

<<tinman,echo=TRUE>>=
library(PWMEnrich.Dmelanogaster.background)

# load the pre-compiled lognormal background
data(PWMLogn.dm3.MotifDb.Dmel)

sequences = readDNAStringSet(system.file(package="PWMEnrich", 
  dir="extdata", file="tinman-early-top20.fa"))
 
res = motifEnrichment(sequences, PWMLogn.dm3.MotifDb.Dmel)

report = groupReport(res)
report

plot(report[1:10], fontsize=7, id.fontsize=5)
@

As in Use case 1, the main function is \Robject{motifEnrichment} which took our sequences and calculated motif enrichment using the lognormal affinity background distribution (fitted on a set of 10031 \textit{D. melanogaster} 2kb promoters). We then applied the \Robject{groupReport} function to calculate the enrichment over the whole group of sequences. This produced a ranked list of motifs according to the estimated P-values. Then we used \Robject{plot} to plot the top 10 enriched motifs.  

The first three motifs are very similar and correspond to the tinman, which is the transcription factor for which the ChIP-chip experiment was performed. The first five columns are the same as before (see Use case 1). The sixth column gives the estimate P-value. The last column indicates the breadth of enrichment using a 5\% ranking threshold. This column helps to differentiate cases where the motif enrichment is strongly focused to a small subset of sequences (in which case breadth is small), versus being more widespread but weaker (in which case breadth is bigger). We can also sort by this column:

<<tinman-alt,echo=TRUE>>=
report.top = groupReport(res, by.top.motifs=TRUE)

report.top
@

This ranks motifs by breadth of enrichment, which is calculated by comparing enrichment \textit{between motifs} in individual sequences. This measure only makes sense when applied to a large number of sequence and when scanning with a large number of motifs (>20). 

The object returned by \Robject{motifEnrichment} has more information in it, as can be seen below:

<<tinman2,echo=TRUE>>=
res

# raw scores
res$sequence.nobg[1:5, 1:2]

# P-values
res$sequence.bg[1:5, 1:2]
@

In these two matrices the rows correspond to the different input sequences and the columns correspond to motifs. The first matrix (sequence.nobg) contains the raw affinity scores, while the second (sequence.bg) contains the corresponding P-values. If you are using a fixed threshold background (e.g. scanning with \Robject{PWMPvalueCutoff1e3.dm3.MotifDb.Dmel}) the first matrix will contain the number of motif hits, and the second the corresponding Z-scores. 

\section{Using PWMEnrich on human sequences}\label{sec:human}

Starting from PWMEnrich version 4.0 (October 2014) a new algorithm is used to better fit the background distributions in human sequences. The only difference from the usage perspective is in creating new background files - please make sure to set the parameter \Robject{algorithm="human"} in \Robject{makeBackground()} (and other related functions for creating backgrounds). This will instruct the function to fit separate parameters for different sequence lengths. The sequence lengths are obtained by multiplying the parameters \Robject{bg.len} and \Robject{bg.len.sizes}. The defaults are \Robject{bg.len=250bp} and \Robject{bg.len.size=c(1, 2, 4, 8, 16)}. This means that the P-values are the most accurate for sequences that are in the range of 250bp - 4000bp and the closest in size to 250bp, 500bp, 1000bp, 2000bp and 4000bp. 

\section{Speeding up execution}

\subsection{Parallel execution}

Motif scanning is the most time consuming operation. Because of this, the package has a support for parallel motif scanning using the \R{parallel} core package. Note that parallel execution is currently not supported on Windows. To turn on parallel scanning, simply register a number of cores available to the package:

<<parallel,echo=TRUE>>=
registerCoresPWMEnrich(4)
@

After this command is executed, all further calls to \Biocpkg{PWMEnrich} functions are going to be run in parallel using 4 cores (if possible). To turn off parallel execution call the function with parameter NULL:

<<parallel-stop,echo=TRUE>>=
registerCoresPWMEnrich(NULL)
@

\subsection{Large memory backend}

Motif scanning can be further speeded up by using large amount of memory. If you have an access to a machine with a lot of RAM, you can switch to the "big memory" backend:

<<bigmem,echo=TRUE>>=
useBigMemoryPWMEnrich(TRUE)
@

From this point on, all motif scanning will be done using the optimised big memory backend. The memory requirement depends on the number of sequences scanned, and might require tens of GB of RAM. To turn it off:

<<bigmemoff,echo=TRUE>>=
useBigMemoryPWMEnrich(FALSE)
@

\section{Customisation}

\subsection{Using a custom set of PWMs}\label{sec:custom-pwm}

Background motif distributions for a custom set of PWMs can be easily calculated for all model organisms. We will illustrate this by creating a new lognormal background for two \textit{de-novo} motifs in Drosophila. To load in the motifs the package provides functions to read standard JASPAR and TRANSFAC formats. 

<<readmotifs,echo=TRUE>>=
library(PWMEnrich.Dmelanogaster.background)

motifs.denovo = readMotifs(system.file(package="PWMEnrich", 
  dir="extdata", file="example.transfac"), remove.acc=TRUE)
  
motifs.denovo  

# convert count matrices into PWMs
genomic.acgt = getBackgroundFrequencies("dm3")
pwms.denovo = toPWM(motifs.denovo, prior=genomic.acgt)

bg.denovo = makeBackground(pwms.denovo, organism="dm3", type="logn", quick=TRUE)

# use new motifs for motif enrichment
res.denovo = motifEnrichment(sequences[1:5], bg.denovo)
groupReport(res.denovo)
@

We load in the count matrices and then convert them into PWMs using the genomic distributions of the A, C, G, T nucleotides. Next we use these PWMs to calculate the properties of the affinity distribution on the set of \textit{D. melanogaster} promoters. In this example we used \Robject{quick=TRUE} for illustrative purposes. This fits the parameters quickly on a reduced set of 100 promoters. We strongly discourage the users to use this parameter in their research, and instead only use it to obtain rough estimates and for testing. The resulting object \Robject{bg.denovo} can be used same as before to perform motif enrichment.

The background object \Robject{bg.denovo} contains the two PWMs and their background distribution parameters. All of these can be accessed with the \$ operator. 

<<bg-investigate,echo=TRUE>>=
bg.denovo
bg.denovo$bg.mean
@
%$

\subsection{Using a custom set of background sequences}\label{sec:custom-bg}

Low-level functions are available for constructing custom backgrounds. We start with the two de-novo motifs from previous section and fit the background to first 20 \textit{D. melanogaster} promoters. 

<<custombg,echo=TRUE>>=
library(PWMEnrich.Dmelanogaster.background)
data(dm3.upstream2000)

# make a lognormal background for the two motifs using only first 20 promoters
bg.seq = dm3.upstream2000[1:20]

# the sequences are split into 100bp chunks and fitted
bg.custom = makeBackground(pwms.denovo, bg.seq=bg.seq, type="logn", bg.len=100,
	bg.source="20 promoters split into 100bp chunks")

bg.custom
@

The resulting \Robject{bg.custom} object can be used as before for motif enrichment with the \Robject{motifEnrichment} function (as described before).

\section{Session information}

<<sessionInfo,echo=FALSE,results='asis'>>=
toLatex(sessionInfo())
@

%\bibliographystyle{apalike}
%\bibliography{references}
\bibliography{references}

\end{document}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/similarity.R
\name{motifSimilarity}
\alias{motifSimilarity}
\title{Calculates similarity between two PFMs.}
\usage{
motifSimilarity(m1, m2, trim = 0.4, self.sim = FALSE)
}
\arguments{
\item{m1}{matrix with four rows representing the frequency matrix of first motif}

\item{m2}{matrix with four rows representing the frequency matrix of second motif}

\item{trim}{bases with information content smaller than this value will be trimmed off both motif ends}

\item{self.sim}{if to calculate self similarity (i.e. without including offset=0 in alignment)}
}
\description{
This function calculates the normalized motif correlation as a measure of motif
frequency matrix similarity.
}
\details{
This score is essentially a normalized version of the sum of column correlations
as proposed by Pietrokovski (1996). The sum is normalized by the average motif
length of m1 and m2, i.e. (ncol(m1)+ncol(m2))/2. Thus, for two idential motifs
this score is going to be 1. For unrelated motifs the score is going to be typically 
around 0. 

Motifs need to aligned for this score to be calculated. The current implementation
tries all possible ungapped alignment with a minimal of two basepair matching, and 
the maximal score over all alignments is returned.

Motif 1 is aligned both to Motif 2 and its reverse complement. Thus, the motif
similarities are the same if the reverse complement of any of the two motifs
is given.
}
\examples{

if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")

   # calculate the similarity of tin and vnd motifs (which are almost identical)
   motifSimilarity(MotifDb.Dmel.PFM[["tin"]], MotifDb.Dmel.PFM[["vnd"]])

   # similarity of two unrelated motifs
   motifSimilarity(MotifDb.Dmel.PFM[["tin"]], MotifDb.Dmel.PFM[["ttk"]])
}
}
\references{
Pietrokovski S. Searching databases of conserved sequence regions by aligning protein multiple-alignments. Nucleic Acids Res 1996;24:3836-3845.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/options.R
\name{useBigMemoryPWMEnrich}
\alias{useBigMemoryPWMEnrich}
\title{If to use a faster implementation of motif scanning that requires abount 5 to 10 times more memory}
\usage{
useBigMemoryPWMEnrich(useBigMemory = FALSE)
}
\arguments{
\item{useBigMemory}{a boolean value denoting if to use big memory implementation}
}
\description{
If to use a faster implementation of motif scanning that requires abount 5 to 10 times more memory
}
\examples{
\dontrun{
useBigMemoryPWMEnrich(TRUE) # switch to big memory implementation globally
useBigMemoryPWMEnrich(FALSE) # switch back to default implementation
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllDataClasses.R
\docType{class}
\name{PWM-class}
\alias{PWM-class}
\title{A class that represents a Position Weight Matrix (PWM)}
\description{
A class that represents a Position Weight Matrix (PWM)
}
\section{Slots}{
 
 \describe{
   \item{\code{id}:}{a systematic ID given to this PWM, could include the source, version, etc}
   \item{\code{name}:}{the name of the transcription factor (TF) to which the PWM corresponds to}
   \item{\code{pfm}:}{Position Frequency Matrix (PFM) from which the PWM is derived}
   \item{\code{prior.params}:}{Defines prior frequencies of the four bases (A,C,G,T), a named vector. These will be added to individual values for the PFM and at the same time used as background probabilities}
   \item{\code{pwm}:}{Final Position Weight Matrix (PWM) constructed using prior.params with logarithm base 2}
 }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MotifEnrichmentResults-methods.R
\name{sequenceReport,MotifEnrichmentResults-method}
\alias{sequenceReport,MotifEnrichmentResults-method}
\alias{sequenceReport}
\title{Generate a motif enrichment report for a single sequence}
\usage{
\S4method{sequenceReport}{MotifEnrichmentResults}(obj, seq.id, bg = TRUE, ...)
}
\arguments{
\item{obj}{a MotifEnrichmentResults object}

\item{seq.id}{the sequence index or name}

\item{bg}{if to use background corrected P-values to do the ranking (if available)}

\item{...}{unused}
}
\value{
a MotifEnrichmentReport object containing a table with the following columns: 
\itemize{
   \item 'rank' - The rank of the PWM's enrichment in the sequence
   \item 'target' - The name of the PWM's target gene, transcript or protein complex. 
   \item 'id' - The unique identifier of the PWM (if set during PWM creation).
   \item 'raw.score' - The raw score before P-value calculation
   \item 'p.value' - The P-value of motif enrichment (if available)
}
}
\description{
Generate a motif enrichment report for a single sequence
}
\examples{
if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   ###
   # load the pre-compiled lognormal background
   data(PWMLogn.dm3.MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")

   # scan two sequences for motif enrichment
   sequences = list(DNAString("GAAGTATCAAGTGACCAGTAAGTCCCAGATGA"), 
     DNAString("AGGTAGATAGAACAGTAGGCAATGAAGCCGATG"))

   res = motifEnrichment(sequences, PWMLogn.dm3.MotifDb.Dmel)

   # reports for the two sequences
   r1 = sequenceReport(res, 1)
   r2 = sequenceReport(res, 2)

   # view the results
   r1
   r2

   # plot the top 10 most enriched motifs in the first, and then second sequence
   plot(r1[1:10])
   plot(r2[1:10])

}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/background.R
\name{makePWMGEVBackground}
\alias{makePWMGEVBackground}
\title{Make a GEV background distribution}
\usage{
makePWMGEVBackground(
  bg.seq,
  motifs,
  bg.pseudo.count = 1,
  bg.len = seq(200, 2000, 200),
  bg.source = "",
  verbose = TRUE,
  fit.log = TRUE
)
}
\arguments{
\item{bg.seq}{a set of background sequences, either a list of DNAString object or DNAStringSet object}

\item{motifs}{a set of motifs, either a list of frequency matrices, or a list of PWM objects. If
frequency matrices are given, the background distribution is fitted from bg.seq.}

\item{bg.pseudo.count}{the pseudo count which is shared between nucleotides when frequency matrices are given}

\item{bg.len}{the length range of background chunks}

\item{bg.source}{a free-form textual description of how the background was generated}

\item{verbose}{if to produce verbose output}

\item{fit.log}{if to fit log odds (instead of odds)}
}
\description{
Construct a lognormal background distribution for a set of sequences. 
Sequences concatenated are binned in 'bg.len' chunks and lognormal distribution 
fitted to them.
}
\examples{
\dontrun{
if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")

   # make background for MotifDb motifs using 2kb promoters of all D. melanogaster transcripts 
	  if(requireNamespace("BSgenome.Dmelanogaster.UCSC.dm3")) 
     makePWMGEVBackground(Dmelanogaster$upstream2000, MotifDb.Dmel.PFM)
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clover.R
\name{cloverScore}
\alias{cloverScore}
\title{Calculate the Clover score using the recursive formula from Frith et al}
\usage{
cloverScore(scores, lr3 = FALSE, verbose = FALSE)
}
\arguments{
\item{scores}{a matrix of average odds scores, where columns are motifs, and rows sequences}

\item{lr3}{if to return a matrix of LR3 scores, where columns correpond to motifs, and rows to subset sizes}

\item{verbose}{if to produce verbose output of progress}
}
\value{
the LR4 score, which is the mean of LR3 scores over subset sizes
}
\description{
Calculate the Clover score using the recursive formula from Frith et al
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{empiricalPvalueSequenceSet}
\alias{empiricalPvalueSequenceSet}
\title{Empirical P-value for a set of sequences}
\usage{
empiricalPvalueSequenceSet(
  scores,
  seq.len,
  pwm.len,
  bg.fwd,
  bg.rev,
  cutoff = NULL,
  B = 10000,
  verbose = FALSE
)
}
\arguments{
\item{scores}{a matrix of scores, rows for sequences, columns for PWMs}

\item{seq.len}{the lengths of sequences}

\item{pwm.len}{the lengths of PWMs}

\item{bg.fwd}{raw odds scores for the forward strand of background}

\item{bg.rev}{raw odds scores for the reverse strand of background}

\item{cutoff}{if not NULL, will use hit count above this cutoff. The cutoff should be specified in log2.}

\item{B}{the number of random replicates}

\item{verbose}{if to give verbose progress reports}
}
\description{
Calculate empirical P-value for a set of sequences, using either affinity or cutoff. When cutoff is used, the score
is a number of motif hits above a certain log-odds cutoff.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PWMBackground-methods.R
\name{names,PWMCutoffBackground}
\alias{names,PWMCutoffBackground}
\alias{names,PWMCutoffBackground-method}
\alias{$,PWMCutoffBackground-method}
\title{Names of variables}
\usage{
\S4method{names}{PWMCutoffBackground}(x)

\S4method{$}{PWMCutoffBackground}(x, name)
}
\arguments{
\item{x}{the PWMCutoffBackground object}

\item{name}{the variable name}
}
\value{
the names of the variables
}
\description{
Name of different pieces of information associated with PWMCutoffBackground
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{plotPFM}
\alias{plotPFM}
\title{Plot a PFM (not PWM) using seqLogo}
\usage{
plotPFM(pfm, ...)
}
\arguments{
\item{pfm}{a matrix where rows are the four nucleotides}

\item{...}{additional parameters for plot()}
}
\description{
Plot a PFM (not PWM) using seqLogo
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PWMBackground-methods.R
\name{show,PWMCutoffBackground-method}
\alias{show,PWMCutoffBackground-method}
\title{show method for PWMCutoffBackground}
\usage{
\S4method{show}{PWMCutoffBackground}(object)
}
\arguments{
\item{object}{the PWMCutoffBackground object}
}
\description{
show method for PWMCutoffBackground
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{cutoffZscore}
\alias{cutoffZscore}
\title{Z-score calculation for cutoff hits}
\usage{
cutoffZscore(scores, seq.len, pwm.len, bg.P)
}
\arguments{
\item{scores}{the hit counts for the sequences}

\item{seq.len}{the length distribution of sequences}

\item{pwm.len}{the length distribution of the PWMs}

\item{bg.P}{background probabilities of observing a motif hit at nucleotide resolution 
(scaled to sequence length, not 2 * length)}
}
\value{
Z-score
}
\description{
The Z-score is calculated separately for each sequence
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{plot,PWM,missing-method}
\alias{plot,PWM,missing-method}
\title{Plotting for the PWM class}
\usage{
\S4method{plot}{PWM,missing}(x, y, ...)
}
\arguments{
\item{x}{the PWM object}

\item{y}{unused}

\item{...}{other parameters to pass to seqLogo's \code{plot} function}
}
\description{
This function produces a sequence logo (via package seqLogo).
}
\examples{
if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
  data(MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")

  # plot the tinman motif from MotifDb
  plot(MotifDb.Dmel[["tin"]])
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{seqLogoGrid}
\alias{seqLogoGrid}
\title{Draw a motif logo on an existing viewport}
\usage{
seqLogoGrid(
  pwm,
  ic.scale = TRUE,
  xaxis = TRUE,
  yaxis = TRUE,
  xfontsize = 10,
  yfontsize = 10,
  xmargin.scale = 1,
  ymargin.scale = 1,
  title = "",
  titlefontsize = 15
)
}
\arguments{
\item{pwm}{numeric The 4xW position weight matrix.}

\item{ic.scale}{logical If TRUE, the height of each column is proportional to its information
content. Otherwise, all columns have the same height.}

\item{xaxis}{logical If TRUE, an X-axis will be plotted.}

\item{yaxis}{logical If TRUE, a Y-axis will be plotted.}

\item{xfontsize}{numeric Font size to be used for the X-axis.}

\item{yfontsize}{numeric Font size to be used for the Y-axis.}

\item{xmargin.scale}{the scaling parameter for the X-axis margin. Useful when plotting more than one logo on a page}

\item{ymargin.scale}{the scaling parameter for the Y-axis margin. Useful when plotting more than one logo on a page}

\item{title}{to be shown on the top}

\item{titlefontsize}{the fontsize of the title}
}
\description{
This function comes from the seqLogo package. It has been modified to remove 
some unneccessary code as suggested by W Huber (https://stat.ethz.ch/pipermail/bioconductor/2010-September/035267.html).
}
\details{
Use this function for more advanced plotting where the viewports are directly set up and maintained (see package \code{grid}).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/misc.R
\name{colMedians}
\alias{colMedians}
\title{Calculate medians of columns}
\usage{
colMedians(x)
}
\arguments{
\item{x}{a matrix}
}
\description{
Calculate medians of columns
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MotifEnrichmentReport-methods.R
\name{names,MotifEnrichmentReport}
\alias{names,MotifEnrichmentReport}
\alias{names,MotifEnrichmentReport-method}
\alias{$,MotifEnrichmentReport-method}
\alias{[,MotifEnrichmentReport-method}
\title{Names of variables}
\usage{
\S4method{names}{MotifEnrichmentReport}(x)

\S4method{$}{MotifEnrichmentReport}(x, name)

\S4method{[}{MotifEnrichmentReport}(x, i, j, ..., drop = TRUE)
}
\arguments{
\item{x}{the MotifEnrichmentReport object}

\item{name}{the variable name}

\item{i}{the row selector}

\item{j}{unused}

\item{...}{unused}

\item{drop}{unused (always FALSE)}
}
\value{
the names of the variables
}
\description{
Columns stored in the motif enrichment report
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/background.R
\name{makePWMPvalCutoffBackgroundFromSeq}
\alias{makePWMPvalCutoffBackgroundFromSeq}
\title{Construct a P-value cutoff background from a set of sequences}
\usage{
makePWMPvalCutoffBackgroundFromSeq(
  bg.seq,
  motifs,
  p.value = 0.001,
  bg.pseudo.count = 1,
  bg.source = "",
  verbose = TRUE
)
}
\arguments{
\item{bg.seq}{a set of background sequences, either a list of DNAString object or DNAStringSet object}

\item{motifs}{a set of motifs, either a list of frequency matrices, or a list of PWM objects. If
frequency matrices are given, the background distribution is fitted from bg.seq.}

\item{p.value}{the P-value used to find cuttoffs for each of the motifs}

\item{bg.pseudo.count}{the pseudo count which is shared between nucleotides when frequency matrices are given}

\item{bg.source}{textual description of background source}

\item{verbose}{if to print verbose output}
}
\value{
an object of type PWMCutoffBackground
}
\description{
This function creates a P-value cutoff background for motif enrichment.
}
\examples{
\dontrun{
if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")

   # use the empirical background to pick a threshold and make cutoff background
   makePWMPvalCutoffBackground(Dmelanogaster$upstream2000, 0.001)
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{motifEnrichment}
\alias{motifEnrichment}
\title{Motif enrichment}
\usage{
motifEnrichment(
  sequences,
  pwms,
  score = "autodetect",
  bg = "autodetect",
  cutoff = NULL,
  verbose = TRUE,
  motif.shuffles = 30,
  B = 1000,
  group.only = FALSE
)
}
\arguments{
\item{sequences}{the sequences to be scanned for enrichment. Can be either a single sequence 
(an object of class DNAString), or a list of DNAString objects, or a DNAStringSet object.}

\item{pwms}{this parameter can take multiple values depending on the scoring scheme and background correction used.
     When the \code{method} parameter is set to "autodetect", the following default algorithms
     are going to be used: 
\itemize{
   \item if \code{pwms} is a list containing either frequency matrices or a list of PWM objects then
         the "affinity" algorithm is selected. If frequency matrices are given, they are converted 
         to PWMs using uniform background. For best performance, convert frequency matrices to PWMs
         before calling this function using realistic genomic background. 
   \item Otherwise, appropriate scoring scheme and background correction are selected based on the
         class of the object (see below). 
}}

\item{score}{this parameter determines which scoring scheme to use. Following scheme as available:
\itemize{
   \item "autodetect" - default value. Scoring method is determined based
         on the type of \code{pwms} parameter. 
   \item "affinity" - use threshold-free affinity score. The \code{pwms}
         parameter can either be a list of frequency matrices, \code{PWM} objects, or a 
         \code{PWMLognBackground} object. 
   \item "cutoff" - use number of motif hits above a score cutoff. The \code{pwms}
         parameter can either be a list of frequency matrices, \code{PWM} objects, or a 
         \code{PWMCutoffBackground} object.
   \item "clover" - use the Clover algorithm (Frith et al, 2004). The Clover score of a single 
         sequence is identical to the affinity score, while for a group of sequences is an
         average of products of affinities over all sequence subsets. 
 }}

\item{bg}{this parameter determines how the raw score is compared to the background distribution. 
\itemize{
   \item "autodetect" - default value. Background correction is determined based on the type
          of the \code{pwms} parameter. 
   \item "logn" - use a lognormal distribution background pre-computed for a set of PWMs.
         This requires \code{pwms} to be of class \code{PWMLognBackground}.
   \item "z" - use a z-score for the number of significant motif hits compared to background number of hits.
         This requires \code{pwms} to be of class \code{PWMCutoffBackground}.
   \item "pval" - use empirical P-value based on a set of background sequences. This requires
         \code{pwms} to be of class \code{PWMEmpiricalBackground}. Note that PWMEmpiricalBackground
         objects tend to be very large so that the empirical P-value can be calculated in reasonable time.
   \item "ms" - shuffle columns of motif matrices and use that as basis for P-value calculation. Note that
          since the sequences need to rescanned with all of the new shuffled motifs this can be very slow. 
          Also, this also works only no *individual* sequences, not groups. 
   \item "none" - no background correction
 }}

\item{cutoff}{the score cutoff for a significant motif hit if scoring scheme "cutoff" is selected.}

\item{verbose}{if to print verbose output}

\item{motif.shuffles}{number of times to shuffle motifs if using "ms" background correction}

\item{B}{number of replicates when calculating empirical P-value}

\item{group.only}{if to return statistics only for the group of sequences, not individual sequences. In the case of
empirical background the P-values for individual sequences are not calculated (thus saving time), for other 
backgrounds they are calculated but not returned.}
}
\value{
a MotifEnrichmentResults object containing a subset following elements:
        \itemize{
          \item "score" - scoring scheme used
          \item "bg" - background correction used
          \item "params" - any additional parameters
		 \item "sequences" - the set of sequences used
          \item "pwms" - the set of pwms used
          \item "sequence.nobg" - per-sequence scores without any background correction. 
                  For "affinity" and "clover" a matrix of mean affinity scores; for
                  "cutoff" number of significant hits above a cutoff 
          \item "sequence.bg" - per-sequence scores after background correction. For "logn" and "pval" the P-value (smaller is better);
                                for "z" and "ms" background corrections the z-scores (bigger is better). 
          \item "group.nobg" - aggregate scores for the whole group of sequences without background correction. For "affinity"
                               and "clover" the mean affinity over all sequences in the set; for "cutoff" the total number of hits in all
                               sequences.
          \item "group.bg" - aggregate scores for the whole group of sequences with background correction. For "logn" and "pval",
                             the P-value for the whole group (smaller is better); for "z" and "ms" the z-score for the whole set (bigger is better).
          \item "sequence.norm" - (only for "logn") the length-normalized scores for each of the sequences. Currently only implemented
                                  for "logn", where it returns the values normalized from LogN(0,1) distribution
          \item "group.norm" - (only for "logn") similar to sequence.norm, but for the whole group of sequences
        }
}
\description{
Calculate motif enrichment using one of available scoring algorithms and background corrections.
}
\details{
This function provides and interface to all algorithms available in PWMEnrich
to find motif enrichment in a single or a group of sequences with/without
background correction. 

Since for all algorithms the first step involves calculating raw scores without background correction, the output
always contains the scores without background correction together with (optional) background-corrected
scores. 

Unless otherwise specified the scores are returned both separately for each sequence (without/with background) and
for the whole group of sequences (without/with background). 

To use a background correction you need to supply a set of PWMs with precompiled background distribution parameters
(see function \code{\link{makeBackground}}). When such an object is supplied as the \code{pwm} parameter, the scoring 
scheme and background correction are automatically determined. 

There are additional packages with already pre-computed background (e.g. see package \code{PWMEnrich.Dmelanogaster.background}).

Please refer to (Stojnic & Adryan, 2012) for more details on the algorithms.
}
\examples{

if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   ###
   # load the pre-compiled lognormal background
   data(PWMLogn.dm3.MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")

   # scan two sequences for motif enrichment
   sequences = list(DNAString("GAAGTATCAAGTGACCAGTAGATTGAAGTAGACCAGTC"), 
     DNAString("AGGTAGATAGAACAGTAGGCAATGGGGGAAATTGAGAGTC"))
   res = motifEnrichment(sequences, PWMLogn.dm3.MotifDb.Dmel)

   # most enriched in both sequences (lognormal background P-value)
   head(motifRankingForGroup(res))

   # most enriched in both sequences (raw affinity, no background)
   head(motifRankingForGroup(res, bg=FALSE))

   # most enriched in the first sequence (lognormal background P-value)
   head(motifRankingForSequence(res, 1))

   # most enriched in the first sequence (raw affinity, no background)
   head(motifRankingForSequence(res, 1, bg=FALSE))

   ###
   # Load the pre-compiled background for hit-based motif counts with cutoff of P-value = 0.001 
   data(PWMPvalueCutoff1e3.dm3.MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")

   res.count = motifEnrichment(sequences, PWMPvalueCutoff1e3.dm3.MotifDb.Dmel)

   # Enrichment in the whole group, z-score for the number of motif hits
   head(motifRankingForGroup(res))

   # First sequence, sorted by number of motif hits with P-value < 0.001
   head(motifRankingForSequence(res, 1, bg=FALSE))
   
}
}
\references{
\itemize{ 
 \item R. Stojnic & B. Adryan: Identification of functional DNA motifs using a binding affinity lognormal background distribution, submitted.
	\item MC Frith et al: Detection of functional DNA motifs via statistical over-representation, Nucleid Acid Research (2004).
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PWMBackground-methods.R
\name{show,PWMGEVBackground-method}
\alias{show,PWMGEVBackground-method}
\title{show method for PWMGEVBackground}
\usage{
\S4method{show}{PWMGEVBackground}(object)
}
\arguments{
\item{object}{the PWMGEVBackground object}
}
\description{
show method for PWMGEVBackground
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{plotMultipleMotifs}
\alias{plotMultipleMotifs}
\title{Plot mulitple motifs in a single plot}
\usage{
plotMultipleMotifs(
  pwms,
  titles = names(pwms),
  rows = ceiling(sqrt(length(pwms))),
  cols = ceiling(sqrt(length(pwms))),
  xmargin.scale = 0.4,
  ymargin.scale = 0.4,
  ...
)
}
\arguments{
\item{pwms}{a list of PWM objects or frequency matrices}

\item{titles}{a characater vector of titles for each of the plots}

\item{rows}{number of rows in the grid}

\item{cols}{number or cols in the grid}

\item{xmargin.scale}{the scaling parameter for the X-axis margin. Useful when plotting more than one logo on a page}

\item{ymargin.scale}{the scaling parameter for the Y-axis margin. Useful when plotting more than one logo on a page}

\item{...}{other parameters passed to seqLogoGrid()}
}
\description{
Individual motif logos are plotted on a rows x cols grid. This function is a convenience
interface for the \code{seqLogoGrid} function that deals with viewpoint placement in a 
matrix-like grid layout.
}
\details{
By default will try to make a square grid plot that would fit all the motifs and use
list names as captions.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/background.R
\name{makePWMEmpiricalBackground}
\alias{makePWMEmpiricalBackground}
\title{Make an empirical P-value background}
\usage{
makePWMEmpiricalBackground(
  bg.seq,
  motifs,
  bg.pseudo.count = 1,
  bg.source = "",
  verbose = TRUE,
  ...
)
}
\arguments{
\item{bg.seq}{a set of background sequences, either a list of DNAString object or DNAStringSet object}

\item{motifs}{a set of motifs, either a list of frequency matrices, or a list of PWM objects. If
frequency matrices are given, the background distribution is fitted from bg.seq.}

\item{bg.pseudo.count}{the pseudo count which is shared between nucleotides when frequency matrices are given}

\item{bg.source}{a free-form textual description of how the background was generated}

\item{verbose}{if to produce verbose output}

\item{...}{currently unused (this is for convenience for makeBackground function)}
}
\description{
Make a background appropriate for empirical P-value calculation. The provided set of background
sequences is contcatenated into a single long sequence which is then scanned with the motifs
and raw scores are saved. This object can be very large.
}
\details{
For reliable P-value calculation the size of the background set needs to be at least seq.len / min.P.value.
For instance, to get P-values at a resolution of 0.001 for a single sequence of 500bp, we would need 
a background of at least 500/0.001 = 50kb. This ensures that we can make 1000 independent 500bp samples from
this background to properly estimate the P-value. For a group of sequences, we would take seq.len to be the
total length of all sequences in a group.
}
\examples{
\dontrun{
if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")

   # make empirical background by saving raw scores for each bp in the sequence. This can be 
   # very large in memory!
	  if(requireNamespace("BSgenome.Dmelanogaster.UCSC.dm3")) 
     makePWMEmpiricalBackground(Dmelanogaster$upstream2000[1:100], MotifDb.Dmel.PFM)
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{logNormPval}
\alias{logNormPval}
\title{Calculate the P-value from lognormal distribution with background of equal length}
\usage{
logNormPval(scores, seq.len, pwm.len, bg.mean, bg.sd, bg.len, log = FALSE)
}
\arguments{
\item{scores}{affinity scores for the PWMs, can contain scores for more than one sequence (as rows), P-values are extracted separately}

\item{seq.len}{the length distribution of the sequences}

\item{pwm.len}{the leggths of PWMs}

\item{bg.mean}{the mean values from the background for PWMs}

\item{bg.sd}{the sd values from the background}

\item{bg.len}{the length distribution of the background (we currently support only constant length)}

\item{log}{if to produce log p-values}
}
\description{
Calculate the P-value from lognormal distribution with background of equal length
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{PWMUnscaled}
\alias{PWMUnscaled}
\title{Create a PWM from PFM}
\usage{
PWMUnscaled(
  x,
  id = "",
  name = "",
  type = c("log2probratio", "prob"),
  prior.params = c(A = 0.25, C = 0.25, G = 0.25, T = 0.25),
  pseudo.count = prior.params,
  unit.scale = FALSE,
  seq.count = NULL
)
}
\arguments{
\item{x}{the integer count matrix representing the motif, rows as nucleotides}

\item{id}{a systematic ID given to this PWM, could include the source, version, etc}

\item{name}{the name of the transcription factor (TF) to which the PWM corresponds to}

\item{type}{the type of PWM calculation, either as log2-odds, or posterior probability (frequency matrix)}

\item{prior.params}{the pseudocounts for each of the nucleotides}

\item{pseudo.count}{the pseudo-count values if different from priors}

\item{unit.scale}{if to unit.scale the pwm (default is no unit scaling)}

\item{seq.count}{if x is a normalised PFM (i.e. with probabilities instead of sequence counts), then this sequence count
will be used to convert \code{x} into a count matrix}
}
\value{
a new PWM object representing the PWM
}
\description{
The PWM function from Biostrings without unit scaling
}
\details{
By default the Biostrings package scales the log-odds score so it is within 0 and 1. In this function
we take a more traditional approach with no unit scaling and offer unit scaling as an additional parameter.

See ?PWM from Biostrings for more information on input arguments.
}
\examples{

if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")

   ttk = MotifDb.Dmel.PFM[["ttk"]]
   
   # make a PWM with uniform background
   PWMUnscaled(ttk, id="ttk-JASPAR", name="ttk")
   
   # custom background
   PWMUnscaled(ttk, id="ttk-JASPAR", name="ttk", 
     prior.params=c("A"= 0.2, "C" = 0.3, "G" = 0.3, "T" = 0.2))

   # get background for drosophila (quick mode on a reduced dataset)
   prior = getBackgroundFrequencies("dm3", quick=TRUE)
   
   # convert using genomic background
   PWMUnscaled(ttk, id="ttk-JASPAR", name="ttk", prior.params=prior)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/similarity.R
\name{tryAllMotifAlignments}
\alias{tryAllMotifAlignments}
\title{Try all motif alignments and return max score}
\usage{
tryAllMotifAlignments(m1, m2, min.align = 2, exclude.zero = FALSE)
}
\arguments{
\item{m1}{frequency matrix of motif 1}

\item{m2}{frequency matrix of motif 2}

\item{min.align}{minimal number of basepairs that need to align}

\item{exclude.zero}{if to exclude offset=0, useful for calculating self-similarity}
}
\value{
single maximal score
}
\description{
This function tries all offsets of motif1 compared to motif2 and returns
the maximal (unnormalized) correlation score.
}
\details{
The correlation score is essentially the sum of correlations of individual aligned
columns as described in Pietrokovski (1996).
}
\references{
Pietrokovski S. Searching databases of conserved sequence regions by aligning protein multiple-alignments. Nucleic Acids Res 1996;24:3836-3845.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllDataClasses.R
\docType{class}
\name{MotifEnrichmentReport-class}
\alias{MotifEnrichmentReport-class}
\title{A report class with formatted results of motif enrichment}
\description{
The columns stored in this object will depend on the type of the report (either for group of sequences, or individual sequences).
}
\section{Slots}{
 
 \describe{
   \item{\code{d}:}{a DataFrame object that contains the main tabular report data}
   \item{\code{pwms}:}{a list of \code{PWM} objects corresponding to rows of \code{d}}
 }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{motifIC}
\alias{motifIC}
\title{Information content for a PWM or PFM}
\usage{
motifIC(
  motif,
  prior.params = c(A = 0.25, C = 0.25, G = 0.25, T = 0.25),
  bycol = FALSE
)
}
\arguments{
\item{motif}{a matrix of frequencies, or a PWM object}

\item{prior.params}{the prior parameters to use when a matrix is given (ignored if motif is already a PWM)}

\item{bycol}{if to return values separately for each column}
}
\value{
information content in bits (i.e. log2)
}
\description{
Information content for a PWM or PFM
}
\examples{

if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   data(MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")
   data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")

   # the nucleotide distribution is taken from the PWM (in this case genomic background)
   motifIC(MotifDb.Dmel[["ttk"]]) 
   # information content with default uniform background because the input is a matrix, 
   # not PWM object
   motifIC(MotifDb.Dmel.PFM[["ttk"]]) 
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PWMBackground-methods.R
\name{names,PWMLognBackground}
\alias{names,PWMLognBackground}
\alias{names,PWMLognBackground-method}
\alias{$,PWMLognBackground-method}
\title{Names of variables}
\usage{
\S4method{names}{PWMLognBackground}(x)

\S4method{$}{PWMLognBackground}(x, name)
}
\arguments{
\item{x}{the PWMLognBackground object}

\item{name}{the variable name}
}
\value{
the names of the variables
}
\description{
Name of different pieces of information associated with PWMLognBackground
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MotifEnrichmentReport-methods.R
\name{show,MotifEnrichmentReport-method}
\alias{show,MotifEnrichmentReport-method}
\title{show method for MotifEnrichmentReport}
\usage{
\S4method{show}{MotifEnrichmentReport}(object)
}
\arguments{
\item{object}{the MotifEnrichmentReport object}
}
\description{
show method for MotifEnrichmentReport
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PWMEnrich-package.R
\docType{package}
\name{PWMEnrich-package}
\alias{PWMEnrich}
\alias{PWMEnrich-package}
\title{PWMEnrich: PWM enrichment analysis}
\description{
A toolkit of high-level functions for DNA motif scanning
        and enrichment analysis built upon Biostrings. The main
        functionality is PWM enrichment analysis of already known PWMs
        (e.g. from databases such as MotifDb), but the package also
        implements high-level functions for PWM scanning and
        visualisation. The package does not perform "de novo" motif
        discovery, but is instead focused on using motifs that are
        either experimentally derived or computationally constructed by
        other tools.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/background.R
\name{makePWMPvalCutoffBackground}
\alias{makePWMPvalCutoffBackground}
\title{Construct a cutoff background from empirical background}
\usage{
makePWMPvalCutoffBackground(bg.p, p.value = 0.001, bg.source = "")
}
\arguments{
\item{bg.p}{an object of class PWMEmpiricalBackground}

\item{p.value}{the P-value used to find cuttoffs for each of the motifs}

\item{bg.source}{textual description of background source}
}
\value{
an object of type PWMCutoffBackground
}
\description{
This function takes already calculated empirical background distribution and chooses
cutoff for each motif based on P-value cutoff for individual sites.
}
\examples{
\dontrun{
if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")

   # make empirical background - here we use only 100 sequences for illustrative purposes
	  if(requireNamespace("BSgenome.Dmelanogaster.UCSC.dm3")) 
     bg.p = makePWMEmpiricalBackground(Dmelanogaster$upstream2000[1:100], MotifDb.Dmel.PFM)

   # use the empirical background to pick a threshold and make cutoff background
   makePWMPvalCutoffBackground(bg.p, 0.001)
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/background.R
\name{.normalize.bg.seq}
\alias{.normalize.bg.seq}
\title{check consistency of bg.seq input parameter}
\usage{
.normalize.bg.seq(bg.seq)
}
\arguments{
\item{bg.seq}{a set of background sequences, either a list of DNAString object or DNAStringSet object}
}
\description{
check consistency of bg.seq input parameter
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clover.R
\name{cloverPvalue1seq}
\alias{cloverPvalue1seq}
\title{Calculate the Clover P-value as described in the Clover paper}
\usage{
cloverPvalue1seq(
  scores,
  seq.len,
  pwm.len,
  bg.fwd,
  bg.rev,
  B = 1000,
  verbose = TRUE,
  clover = NULL
)
}
\arguments{
\item{scores}{the affinity scores for individual sequences}

\item{seq.len}{lengths of sequences}

\item{pwm.len}{lengths of PWMs}

\item{bg.fwd}{the raw score of forward strand}

\item{bg.rev}{the raw scores of reverse strand}

\item{B}{the number of random replicates}

\item{verbose}{if to give verbose progress reports}

\item{clover}{the clover scores if already calculated}
}
\value{
P-value
}
\description{
This function only take one background sequence as input, it also just calculates the P-value
so it is more efficient.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/background.R
\name{makeBackground}
\alias{makeBackground}
\title{Make a background for a set of position frequency matrices}
\usage{
makeBackground(
  motifs,
  organism = "dm3",
  type = "logn",
  quick = FALSE,
  bg.seq = NULL,
  ...
)
}
\arguments{
\item{motifs}{a list of position frequency matrices (4xL matrices)}

\item{organism}{either a name of the organisms for which the background should be compiled 
(currently supported names are "dm3", "mm9" and "hg19"), or a \code{BSgenome} object (see \code{BSgenome} package).}

\item{type}{the type of background to be compiled. Possible types are: 
\itemize{
    \item "logn" - estimate a lognormal background
    \item "cutoff" - estimate a Z-score background with fixed log-odds cutoff (in log2)
    \item "pval" - estimate a Z-score background with a fixed P-value cutoff. Note that this may require a lot of memory
                   since the P-value of motif hits is first estimated from the empirical distribution. 
    \item "empirical" - create an empirical P-value background. Note that this may require a lot of memory (up to 10GB in
                        default "slow" mode (quick=FALSE) for 126 JASPAR motifs and 1000 D. melanogaster promoters).
    \item "GEV" - estimate a generalized extreme value (GEV) distribution background by fitting linear regression to distribution 
                  parameters in log space
}}

\item{quick}{if to preform fitting on a reduced set of 100 promoters. This will not give as good results but is much quicker than fitting to all the promoters (~10k). 
Usage of this parameter is recommended only for testing and rough estimates.}

\item{bg.seq}{a set of background sequences to use. This parameter overrides the "organism" and "quick" parameters.}

\item{...}{other named parameters that backend function makePWM***Background functions take.}
}
\description{
This is a convenience front-end function to compile new backgrounds for a set of PFMs. 
Currently only supports D. melanogaster, but in the future should support other common organisms as well.
}
\examples{

# load in the two example de-novo motifs
motifs = readMotifs(system.file(package = "PWMEnrich", dir = "extdata", file = "example.transfac"), 
  remove.acc = TRUE)

\dontrun{
  # construct lognormal background
  bg.logn = makeBackground(motifs, organism="dm3", type="logn")

  # alternatively, any BSgenome object can also be used
  if(requireNamespace("BSgenome.Dmelanogaster.UCSC.dm3"))
    bg.logn = makeBackground(motifs, organism=Dmelanogaster, type="logn")

  # construct a Z-score of hits with P-value background
  bg.pval = makeBackground(motifs, organism="dm3", type="pval", p.value=1e-3)

  # now we can use them to scan for enrichment in sequences (in this case there is a consensus 
  # Tin binding site).
  motifEnrichment(DNAString("TGCATCAAGTGTGTAGTG"), bg.logn)
  motifEnrichment(DNAString("TGCATCAAGTGTGTAGTG"), bg.pval)
}

}
\author{
Robert Stojnic, Diego Diez
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllDataClasses.R
\docType{class}
\name{PWMCutoffBackground-class}
\alias{PWMCutoffBackground-class}
\title{Hit count background distribution for a set of PWMs}
\description{
Hit count background distribution for a set of PWMs
}
\section{Slots}{
 
 \describe{
   \item{\code{bg.source}:}{textual description of where the background distribution is derived from}
   \item{\code{bg.cutoff}:}{the cutoff score used to find significant motif hits (in log2 odds), either a single value or a vector of values}
   \item{\code{bg.P}:}{the density of significant motif hits per nucleotide in background}
   \item{\code{pwms}:}{the pwms for which the background has been compiled}
 }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/misc.R
\name{DNAStringSetToList}
\alias{DNAStringSetToList}
\title{Convert DNAStringSet to list of DNAString objects}
\usage{
DNAStringSetToList(x)
}
\arguments{
\item{x}{an object of class DNAStringSet}
}
\description{
as.list doesn't seem to always work for DNAStringSets, so
implementing this ourselves.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/options.R
\name{registerCoresPWMEnrich}
\alias{registerCoresPWMEnrich}
\title{Register than PWMEnrich can use parallel CPU cores}
\usage{
registerCoresPWMEnrich(numCores = NA)
}
\arguments{
\item{numCores}{number of cores to use (default to take all cores), or NULL if no parallel execution is to be used}
}
\description{
Certain functions (like motif scanning) can be parallelized in PWMEnrich. This function
registers a number of parallel cores (via core package parallel) to be used in
code that can be parallelized. After this function is called, all further PWMEnrich
function calls will run in parallel if possible.
}
\details{
By default parallel execution is turned off. To turn it off after using it, call this
function by passing NULL.
}
\examples{
\dontrun{
registerCoresPWMEnrich(4) # use 4 CPU cores in PWMEnrich
registerCoresPWMEnrich() # use maximal number of CPUs
registerCoresPWMEnrich(NULL) # do not use parallel execution
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PWMBackground-methods.R
\name{names,PWMGEVBackground}
\alias{names,PWMGEVBackground}
\alias{names,PWMGEVBackground-method}
\alias{$,PWMGEVBackground-method}
\title{Names of variables}
\usage{
\S4method{names}{PWMGEVBackground}(x)

\S4method{$}{PWMGEVBackground}(x, name)
}
\arguments{
\item{x}{the PWMGEVBackground object}

\item{name}{the variable name}
}
\value{
the names of the variables
}
\description{
Name of different pieces of information associated with PWMGEVBackground
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{cutoffZscoreSequenceSet}
\alias{cutoffZscoreSequenceSet}
\title{Z-score calculation for cutoff hits for group of sequences}
\usage{
cutoffZscoreSequenceSet(scores, seq.len, pwm.len, bg.P)
}
\arguments{
\item{scores}{the hit counts for the sequences}

\item{seq.len}{the length distribution of sequences}

\item{pwm.len}{the length distribution of the PWMs}

\item{bg.P}{background probabilities of observing a motif hit at nucleotide resolution}
}
\value{
Z-score
}
\description{
The Z-score is calculated as if the sequence came for one very long sequence
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PWMBackground-methods.R
\name{[,PWMCutoffBackground-method}
\alias{[,PWMCutoffBackground-method}
\title{Get the background for a subset of PWMs}
\usage{
\S4method{[}{PWMCutoffBackground}(x, i, j, ..., drop = TRUE)
}
\arguments{
\item{x}{the PWMCutoffBackground object}

\item{i}{the indicies of PWMs}

\item{j}{unused}

\item{...}{unused}

\item{drop}{unused}
}
\description{
Get the background for a subset of PWMs
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/background.R
\name{makeStartEndPos}
\alias{makeStartEndPos}
\title{Divide total.len into fragments of length len by providing start,end positions}
\usage{
makeStartEndPos(total.len, len)
}
\arguments{
\item{total.len}{total available length to be subdivided}

\item{len}{size of the individual chunk}
}
\value{
a data.frame containing paired up start,end positions
}
\description{
Divide total.len into fragments of length len by providing start,end positions
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/similarity.R
\name{maxAligned}
\alias{maxAligned}
\title{Returned the aligned motif parts}
\usage{
maxAligned(m1, m2, offset)
}
\arguments{
\item{m1}{frequency matrix of first motif}

\item{m2}{frequency matrix of second motif}

\item{offset}{a number of nucleotides by which the first motif is offsetted compared to the second}
}
\value{
a list of column-trimmed motifs m1, m2
}
\description{
This function takes the offset of first motif relative to second and 
chops off the end of both motifs that are not aligned. It returns a list
containing only the columns that align.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MotifEnrichmentResults-methods.R
\name{motifRankingForSequence,MotifEnrichmentResults-method}
\alias{motifRankingForSequence,MotifEnrichmentResults-method}
\alias{motifRankingForSequence}
\title{Get a ranking of motifs by their enrichment in one specific sequence}
\usage{
\S4method{motifRankingForSequence}{MotifEnrichmentResults}(
  obj,
  seq.id,
  bg = TRUE,
  id = FALSE,
  order = FALSE,
  rank = FALSE,
  unique = FALSE,
  ...
)
}
\arguments{
\item{obj}{a MotifEnrichmentResults object}

\item{seq.id}{either the sequence number or sequence name}

\item{bg}{if to use background corrected P-values to do the ranking (if available)}

\item{id}{if to show PWM IDs instead of target TF names}

\item{order}{if to output the ordering of PWMs instead of actual P-values or raw values}

\item{rank}{if the output should be rank of a PWM instead of actual P-values or raw values}

\item{unique}{if TRUE, only the best rank is taken for each TF (only when id = FALSE, order = FALSE)}

\item{...}{currently unused}
}
\value{
a vector of P-values or raw enrichments sorted such that the first motif is most enriched
}
\description{
Get a ranking of motifs by their enrichment in one specific sequence
}
\examples{
if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   ###
   # load the pre-compiled lognormal background
   data(PWMLogn.dm3.MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")

   # scan two sequences for motif enrichment
   sequences = list(DNAString("GAAGTATCAAGTGACCAGTAAGTCCCAGATGA"), 
     DNAString("AGGTAGATAGAACAGTAGGCAATGAAGCCGATG"))
   res = motifEnrichment(sequences, PWMLogn.dm3.MotifDb.Dmel)

   # most enriched in the second sequences (sorted by lognormal background P-value)
   head(motifRankingForSequence(res, 2))

   # return unique TFs enriched in sequence 2
   head(motifRankingForSequence(res, 2, unique=TRUE))

   # sorted by raw affinity instead of P-value
   head(motifRankingForSequence(res, 2, bg=FALSE))

   # show IDs instead of target TF names
   head(motifRankingForSequence(res, 2, id=TRUE))

   # output the rank instead of P-value
   head(motifRankingForSequence(res, 2, rank=TRUE))
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{toPWM}
\alias{toPWM}
\title{Convert motifs into PWMs}
\usage{
toPWM(
  motifs,
  ids = names(motifs),
  targets = names(motifs),
  seq.count = 50,
  prior = c(A = 0.25, C = 0.25, G = 0.25, T = 0.25),
  ...
)
}
\arguments{
\item{motifs}{a list of motifs either as position probability matrices (PPM) or frequency matirces (PFMs)}

\item{ids}{the set of IDs for the motifs (defaults to names of the 'motifs' list)}

\item{targets}{the set of target TF names for the motifs (defaults to names of the 'motifs' list)}

\item{seq.count}{provides a vector of sequence counts for probability matrices (PPMs). Default it 50.}

\item{prior}{frequencies of the four letters in the genome. Default is uniform background.}

\item{...}{other parameters to PWMUnscaled}
}
\description{
Convert motifs into PWMs
}
\examples{
\dontrun{
if (requireNamespace("PWMEnrich.Dmelanogaster.background")) {
   data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")

   toPWM(MotifDb.Dmel.PFM) # convert to PWM with uniform background

   # get background for drosophila (quick mode on a reduced dataset)
   prior = getBackgroundFrequencies("dm3", quick=TRUE)
   toPWM(MotifDb.Dmel.PFM, prior=prior) # convert with genomic background 
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/background.R
\name{getBackgroundFrequencies}
\alias{getBackgroundFrequencies}
\title{Get the four nucleotides background frequencies}
\usage{
getBackgroundFrequencies(organism = "dm3", pseudo.count = 1, quick = FALSE)
}
\arguments{
\item{organism}{either a name of the organisms for which the background should be compiled 
(supported names are "dm3", "mm9" and "hg19"), a \code{BSgenome} object,
 \code{DNAStringSet}, or list of \code{DNAString} objects}

\item{pseudo.count}{the number to which the frequencies sum up to, by default 1}

\item{quick}{if to preform fitting on a reduced set of 100 promoters. This will not give as good results but is much quicker than fitting to all the promoters (~10k). 
Usage of this parameter is recommended only for testing and rough estimates.}
}
\description{
Estimate the background frequencies of A,C,G,T on a set of promoters from an organism
}
\examples{
\dontrun{
  getBackgroundFrequencies("dm3")
}
}
\author{
Robert Stojnic, Diego Diez
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{.normargPfm}
\alias{.normargPfm}
\title{Input parameter normalization for PWMUnscaled}
\usage{
.normargPfm(x)
}
\arguments{
\item{x}{a frequency matrix}
}
\description{
This function is from Biostrings package.
A Position Frequency Matrix (PFM) is also represented as an ordinary
matrix. Unlike a PWM, it must be of type integer (it will typically be
the result of consensusMatrix()).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/background.R
\name{makePWMCutoffBackground}
\alias{makePWMCutoffBackground}
\title{Make a cutoff background}
\usage{
makePWMCutoffBackground(
  bg.seq,
  motifs,
  cutoff = log2(exp(4)),
  bg.pseudo.count = 1,
  bg.source = "",
  verbose = TRUE
)
}
\arguments{
\item{bg.seq}{a set of background sequences, either a list of DNAString object or DNAStringSet object}

\item{motifs}{a set of motifs, either a list of frequency matrices, or a list of PWM objects. If
frequency matrices are given, the background distribution is fitted from bg.seq.}

\item{cutoff}{the cutoff at which the background should be made, i.e. at which a motif hit is called significant}

\item{bg.pseudo.count}{the pseudo count which is shared between nucleotides when frequency matrices are given}

\item{bg.source}{a free-form textual description of how the background was generated}

\item{verbose}{if to produce verbose output}
}
\description{
Make a background based on number of motifs hits above a certain threshold.
}
\examples{
\dontrun{
if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")

   # make background for MotifDb motifs using 2Kb promoters of all D. melanogaster transcripts 
   # using a cutoff of 5
	  if(requireNamespace("BSgenome.Dmelanogaster.UCSC.dm3")) 
     makePWMCutoffBackground(Dmelanogaster$upstream2000, MotifDb.Dmel.PFM, cutoff=log2(exp(5)))
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{keepFinite}
\alias{keepFinite}
\title{Replace all infinite values by 0}
\usage{
keepFinite(x)
}
\arguments{
\item{x}{a vector of values}
}
\description{
Replace all infinite values by 0
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{plotMotifScores}
\alias{plotMotifScores}
\title{Plot the raw motifs scores as returned by motifScores()}
\usage{
plotMotifScores(
  scores,
  sel.motifs = NULL,
  seq.names = NULL,
  cols = NULL,
  cutoff = NULL,
  log.fun = log2,
  main = "",
  legend.space = 0.3,
  max.score = NULL,
  trans = 0.5,
  text.cex = 0.9,
  legend.cex = 0.9,
  motif.names = NULL,
  seq.len.spacing = 8,
  shape = "rectangle"
)
}
\arguments{
\item{scores}{the list of motifs scores. Each element of the list is a matrix of scores for one sequences. The columns in the matrix
correspond to different motifs. Each column contains the odds (not log-odds!) scores over both strands. For example, 
for a sequence of length 5, scores for a 3 bp motifs could be: \code{c(0.1, 1, 4, NA, NA, 1, 0.3, 2, NA, NA)}. The first
3 numbers are odds scores starting at first three bases, and the second lot of 3 numbers is the scores starting at the
same positions but with the reverse complement of the motif. The last two values are NA on both strands because we do not
support partial motif hits.}

\item{sel.motifs}{a vector of motif names. Use this parameter to show the motif hits to only a subset of motifs for which the scores are available.}

\item{seq.names}{a vector of sequence names to show in the graph. If none specified, the sequences will be named Sequence 1, Sequence 2, ...}

\item{cols}{a vector of colours to use to colour code motif hits. If none are specified, the current palette will be used.}

\item{cutoff}{either a single value, or a vector of values. The values are PWM cutoffs after \code{log.fun} (see below). Only motif scores above these cutoffs will be shown. 
If a single values is specified, it will be used for all PWMs, otherwise the vector needs to specify one cutoff per PWM.}

\item{log.fun}{the logarithm function to use to calculate log-odds. By default log2 is used for consistency with Biostrings.}

\item{main}{the main title}

\item{legend.space}{the proportion of horizontal space to reserve for the legend. The default is 30\%.}

\item{max.score}{the maximal log-odds score used to scale all other scores. By default this values is automatically determined, but it can
also be set manually to make multiple plots comparable.}

\item{trans}{the level of transparency. By default 50\% transparency to be able to see overlapping binding sites}

\item{text.cex}{the scaling factor for sequence names}

\item{legend.cex}{the scaling factor for the legend}

\item{motif.names}{optional vector of motif names to show instead of those present as column names in \code{scores}}

\item{seq.len.spacing}{the spacing (in bp units) between the end of the sequence line and the text showing the length in bp}

\item{shape}{the shape to use to draw motif occurances, valid values are "rectangle" (default), "line" and "triangle"}
}
\description{
This function visualises the motif scores for one or more sequences. Sequences are drawn as lines, and scores are plotted
as triangles at both sides of the line (corresponding to the two strands). The width of the base of the triangle corresponds to motif width and 
the height to the motif \code{log(score)} that is positive and greater than the \code{cutoff} parameter (if specified). All scores
have the same y-axis, so the heights of bars are comparable between sequences and motifs.
}
\examples{
if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   ###
   # Load Drosophila PWMs
   data(MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")

   # two sequences of interest
   sequences = list(DNAString("GAAGTATCAAGTGACCAGGTGAAGTCCCAGATGA"), 
     DNAString("AGGTAGATAGAACAGTAGGCAATGAAGCCGATG"))

   # select the tinman and snail motifs
   pwms = MotifDb.Dmel[c("tin", "sna")]

   # get the raw score that will be plotted
   scores = motifScores(sequences, pwms, raw.scores=TRUE)

   # plot the scores in both sequences, green for tin and blue for sna
   plotMotifScores(scores, cols=c("green", "blue"))
    
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{.inputParamSequences}
\alias{.inputParamSequences}
\title{Normalize the sequences input argument}
\usage{
.inputParamSequences(sequences)
}
\arguments{
\item{sequences}{a set of sequences to be scanned, a list of DNAString or other scannable objects}
}
\description{
Normalize the sequences input argument
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PWM-methods.R
\name{show,PWM-method}
\alias{show,PWM-method}
\title{show method for PWM}
\usage{
\S4method{show}{PWM}(object)
}
\arguments{
\item{object}{the PWM object}
}
\description{
show method for PWM
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{empiricalPvalue}
\alias{empiricalPvalue}
\title{Calculate the empirical P-value by affinity of cutoff.}
\usage{
empiricalPvalue(
  scores,
  seq.len,
  pwm.len,
  bg.fwd,
  bg.rev,
  cutoff = NULL,
  B = 10000,
  verbose = FALSE,
  exact.length = FALSE
)
}
\arguments{
\item{scores}{the scores obtained for the sequence}

\item{seq.len}{the length of the sequence, if a single value will take a single sequence
of given length. If a vector of values, will take sequences of given lengths
and joint them together}

\item{pwm.len}{the lengths of PWMs}

\item{bg.fwd}{raw odds scores for the forward strand of background}

\item{bg.rev}{raw odds scores for the reverse strand of background}

\item{cutoff}{if not NULL, will use hit count above this cutoff. The cutoff should be specified in log2.}

\item{B}{the number of random replicates}

\item{verbose}{if to give verbose progress reports}

\item{exact.length}{if to take into consideration that the actual sequence lengths differ for different PWMs.
For very long sequences (i.e. seq.len >> pwm.len) this make very little difference, however
the run time with exact.length is much longer.}
}
\description{
This is the new backend function for empirical P-values for either affinity or cutoff. 
The function only works on single sequences.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/misc.R
\name{divideRows}
\alias{divideRows}
\title{Divide each row of a matrix with a vector}
\usage{
divideRows(m, v)
}
\arguments{
\item{m}{matrix to be divided}

\item{v}{the vector to use for division}
}
\description{
Divide each row of a matrix with a vector
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllDataClasses.R
\docType{class}
\name{PWMEmpiricalBackground-class}
\alias{PWMEmpiricalBackground-class}
\title{Background for calculating empirical P-values}
\description{
This object contains raw scores for one very long sequence, thus it can be very large.
}
\section{Slots}{
 
 \describe{
   \item{\code{bg.source}:}{textual description of where the background distribution is derived from}
   \item{\code{bg.fwd}:}{affinity scores (odds) for the forward strand. PWMs as columns}
   \item{\code{bg.rev}:}{affinity scores (odds) for the reverse strand. PWMs as columns}
   \item{\code{pwms}:}{the pwms for which the background has been compiled}
 }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{scanWithPWM}
\alias{scanWithPWM}
\title{Scan the whole sequence on both strands}
\usage{
scanWithPWM(
  pwm,
  dna,
  pwm.rev = NULL,
  odds.score = FALSE,
  both.strands = FALSE,
  strand.fun = "mean"
)
}
\arguments{
\item{pwm}{PWM object}

\item{dna}{a DNAString or other sequence from Biostrings}

\item{pwm.rev}{the reverse complement for a pwm (if it is already pre-computed)}

\item{odds.score}{if to return raw scores in odds (not logodds) space}

\item{both.strands}{if to return results on both strands}

\item{strand.fun}{which function to use to summarise values over two strands (default is "mean")}
}
\value{
a vector representing scores starting at each position, or a matrix with score in the two strands
}
\description{
The whole sequence is scanned with a PWM and scores returned beginning at each position. Partial motif
matches are not done, thus the last #[length of motif]-1 scores are NA.
}
\details{
The function returns either an odds average (*not* log-odds average), maximal score on each strand,
or scores on both strands. 

The function by default returns the score in log2 following the package \code{Biostrings}.
}
\examples{

if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   data(MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")

   ttk = MotifDb.Dmel[["ttk"]]

   # odds average over the two strands expressed as log2-odds
   scanWithPWM(ttk, DNAString("CGTAGGATAAAGTAACT"))
   
   # log2-odds scores on both strands
   scanWithPWM(ttk, DNAString("CGTAGGATAAAGTAACT"), both.strands=TRUE)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/background.R
\name{motifEcdf}
\alias{motifEcdf}
\title{Calculate the empirical distribution score distribution for a set of motifs}
\usage{
motifEcdf(
  motifs,
  organism = NULL,
  bg.seq = NULL,
  quick = FALSE,
  pseudo.count = 1
)
}
\arguments{
\item{motifs}{a set of motifs, either a list of frequency matrices, or a list of PWM objects. If
frequency matrices are given, the background distribution is fitted from bg.seq.}

\item{organism}{either a name of the organisms for which the background should be compiled 
(supported names are "dm3", "mm9" and "hg19"), or a \code{BSgenome} object (see \code{BSgenome} package).}

\item{bg.seq}{a set of background sequence (either this or organism needs to be specified!). Can be a DNAString or DNAStringSet object.}

\item{quick}{if to do the fitting only on a small subset of the data (only in combination with \code{organism}). Useful only for code testing!}

\item{pseudo.count}{the pseudo count which is shared between nucleotides when frequency matrices are given}
}
\value{
a list of \code{ecdf} objects (see help page for \code{ecdf} for usage).
}
\description{
Calculate the empirical distribution score distribution for a set of motifs
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllDataClasses.R
\docType{class}
\name{PWMGEVBackground-class}
\alias{PWMGEVBackground-class}
\title{Generalized Extreme Values (GEV) background for P-values}
\description{
The three parameters of the GEV distribution are fitted by doing linear regression
on log of sequence length.
}
\section{Slots}{
 
 \describe{
   \item{\code{bg.source}:}{textual description of where the background distribution is derived from}
   \item{\code{bg.loc}:}{linear regression model for estimating the location parameter based on log(L), list of lm objects of PWMs}
   \item{\code{bg.scale}:}{linear regression model for estimating the scale parameter based on log(L), list of lm objects of PWMs}
   \item{\code{bg.shape}:}{linear regression model for estimating the shape parameter based on log(L), list of lm objects of PWMs}
   \item{\code{pwms}:}{the pwms for which the background has been compiled}
 }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{motifPrAUC}
\alias{motifPrAUC}
\title{Calculate PR-AUC for motifs ranked according to some scoring scheme}
\usage{
motifPrAUC(seq.res)
}
\arguments{
\item{seq.res}{a matrix where each column represents a PWM and each row a result for a different sequence.}
}
\description{
Note that this function asssumes that smaller values are better!
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MotifEnrichmentReport-methods.R
\name{as.data.frame,MotifEnrichmentReport-method}
\alias{as.data.frame,MotifEnrichmentReport-method}
\alias{as.data.frame}
\title{Convert a MotifEnrichmentReport into a data.frame object}
\usage{
\S4method{as.data.frame}{MotifEnrichmentReport}(x, row.names = NULL, optional = FALSE, ...)
}
\arguments{
\item{x}{the MotifEnrichmentReport object}

\item{row.names}{unused}

\item{optional}{unused}

\item{...}{unused}
}
\description{
Convert a MotifEnrichmentReport into a data.frame object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/similarity.R
\name{.inputPFMfromMatrixOrPWM}
\alias{.inputPFMfromMatrixOrPWM}
\title{Check the frequency matrix input parameter for motifSimilarity}
\usage{
.inputPFMfromMatrixOrPWM(m)
}
\arguments{
\item{m}{either a PWM object or a matrix}
}
\value{
corresponding PFM
}
\description{
Check the frequency matrix input parameter for motifSimilarity
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/background.R
\name{getPromoters}
\alias{getPromoters}
\title{Get the promoter sequences either for a named organism such as "dm3" or a BSgenome object}
\usage{
getPromoters(organismOrGenome)
}
\arguments{
\item{organismOrGenome}{either organism name, e.g. "dm3", or BSgenome object}
}
\value{
a list of: promoters - DNAStringSet of (unique) promoters; organism - name of species; version - genome version
}
\description{
Get the promoter sequences either for a named organism such as "dm3" or a BSgenome object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readData.R
\name{readMotifs}
\alias{readMotifs}
\title{Read in motifs in JASPAR or TRANSFAC format}
\usage{
readMotifs(file, remove.acc = FALSE)
}
\arguments{
\item{file}{the filename}

\item{remove.acc}{if to remove accession numbers. If TRUE, the AC entry in TRANSFAC files is ignored,
and the accession is stripped from JASPAR, e.g. motif with name "MA0211.1 bap" would 
become just "bap". If FALSE, botht he AC and ID are used to generate the TRANSFAC name
and the original motif names are preserved in JASPAR files.}
}
\value{
a list of 4xL matrices representing motifs (four nucleotides as rows)
}
\description{
The format is autodetected based on file format. If the autodetection fail
then the file cannot be read.
}
\examples{

# read in example TRANSFAC motifs without accession codes (just IDs)
readMotifs(system.file(package = "PWMEnrich", dir = "extdata", file = "example.transfac"), 
  remove.acc = TRUE)

# read in the JASPAR insects motifs provided as example
readMotifs(system.file(package = "PWMEnrich", dir = "extdata", file = "jaspar-insecta.jaspar"), 
  remove.acc = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readData.R
\name{readTRANSFAC}
\alias{readTRANSFAC}
\title{Read in motifs in TRANSFAC format}
\usage{
readTRANSFAC(file, remove.acc = TRUE)
}
\arguments{
\item{file}{the filename}

\item{remove.acc}{if to ignore transfac accession numbers}
}
\value{
a list of matrices representing motifs (with four nucleotides as rows)
}
\description{
Read in motifs in TRANSFAC format
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PWMBackground-methods.R
\name{names,PWMEmpiricalBackground}
\alias{names,PWMEmpiricalBackground}
\alias{names,PWMEmpiricalBackground-method}
\alias{$,PWMEmpiricalBackground-method}
\title{Names of variables}
\usage{
\S4method{names}{PWMEmpiricalBackground}(x)

\S4method{$}{PWMEmpiricalBackground}(x, name)
}
\arguments{
\item{x}{the PWMEmpiricalBackground object}

\item{name}{the variable name}
}
\value{
the names of the variables
}
\description{
Name of different pieces of information associated with PWMEmpiricalBackground
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{.normargPriorParams}
\alias{.normargPriorParams}
\title{Input parameter normalization function for PWMUnscaled}
\usage{
.normargPriorParams(prior.params)
}
\arguments{
\item{prior.params}{Typical 'prior.params' vector: c(A=0.25, C=0.25, G=0.25, T=0.25)}
}
\description{
This function is from Biostrings package
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PWMBackground-methods.R
\name{show,PWMEmpiricalBackground-method}
\alias{show,PWMEmpiricalBackground-method}
\title{show method for PWMEmpiricalBackground}
\usage{
\S4method{show}{PWMEmpiricalBackground}(object)
}
\arguments{
\item{object}{the PWMEmpiricalBackground object}
}
\description{
show method for PWMEmpiricalBackground
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PWM-methods.R
\name{reverseComplement,PWM-method}
\alias{reverseComplement,PWM-method}
\title{Reverse complement for the PWM object}
\usage{
\S4method{reverseComplement}{PWM}(x, ...)
}
\arguments{
\item{x}{an object of type PWM}

\item{...}{unused}
}
\value{
an object of type PWM that is reverse complement of x
}
\description{
Finds the reverse complement of the PWM
}
\examples{

if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")

   reverseComplement(MotifDb.Dmel.PFM[["ttk"]]) # reverse complement of the ttk PWM
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{motifRecoveryAUC}
\alias{motifRecoveryAUC}
\title{Calculate Recovery-AUC for motifs ranked according to some scoring scheme}
\usage{
motifRecoveryAUC(seq.res)
}
\arguments{
\item{seq.res}{a matrix where each column represents a PWM and each row a result for a different sequence.}
}
\description{
Note that this function asssumes that smaller values are better!
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{.inputParamMotifs}
\alias{.inputParamMotifs}
\title{Normalizes the motifs input argument for multiple functions}
\usage{
.inputParamMotifs(motifs)
}
\arguments{
\item{motifs}{a list of motifs either as frequency matrices (PFM) or as PWM objects. If PFMs are specified
they are converted to PWMs using uniform background.}
}
\description{
Normalizes the motifs input argument for multiple functions
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{PFMtoPWM}
\alias{PFMtoPWM}
\title{Convert frequencies into motifs using PWMUnscaled}
\usage{
PFMtoPWM(
  motifs,
  id = names(motifs),
  name = names(motifs),
  seq.count = NULL,
  ...
)
}
\arguments{
\item{motifs}{a list of motifs represented as matrices of frequencies (PFM)}

\item{id}{the set of IDs for the motifs (defaults to names of the 'motifs' list)}

\item{name}{the set of names for the motifs (defaults to names of the 'motifs' list)}

\item{seq.count}{if frequencies in the motifs are normalized to 1, provides a vector of sequence counts (e.g. for MotifDb motifs)}

\item{...}{other parameters to PWMUnscaled}
}
\description{
Note that this function is deprecated and replaced by \code{toPWM()}.
}
\examples{
\dontrun{
if (requireNamespace("PWMEnrich.Dmelanogaster.background")) {
  data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")

  # convert to PWM with uniform background
  PFMtoPWM(MotifDb.Dmel.PFM)

  # get background for drosophila (quick mode on a reduced dataset)
  prior = getBackgroundFrequencies("dm3", quick=TRUE)
   
  # convert with genomic background 
  PFMtoPWM(MotifDb.Dmel.PFM, prior.params=prior)
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{plot,MotifEnrichmentReport,missing-method}
\alias{plot,MotifEnrichmentReport,missing-method}
\title{Plot the motif enrichment report}
\usage{
\S4method{plot}{MotifEnrichmentReport,missing}(
  x,
  y,
  fontsize = 14,
  id.fontsize = fontsize,
  header.fontsize = fontsize,
  widths = NULL,
  ...
)
}
\arguments{
\item{x}{a MotifEnrichmentReport object}

\item{y}{unused}

\item{fontsize}{font size to use in the plot}

\item{id.fontsize}{font size to use for the motif IDs}

\item{header.fontsize}{font size of the header}

\item{widths}{the relative widths of columns}

\item{...}{unused
if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   ###
   # load the pre-compiled lognormal background
   data(PWMLogn.dm3.MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")

   # scan two sequences for motif enrichment
   sequences = list(DNAString("GAAGTATCAAGTGACCAGTAAGTCCCAGATGA"), DNAString("AGGTAGATAGAACAGTAGGCAATGAAGCCGATG"))

   res = motifEnrichment(sequences, PWMLogn.dm3.MotifDb.Dmel)

   # produce a report for all sequences taken together
   r = groupReport(res)

   # plot the top 10 most enriched motifs
   plot(r[1:10])

}}
}
\description{
Plots a graphical version of the motif enrichment report. Note that all values are plotted, if you want to plot only a subset of
a report, first select this subset (see examples).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{gevPerSequence}
\alias{gevPerSequence}
\title{Apply GEV background normalization per every sequence}
\usage{
gevPerSequence(scores, seq.len, pwm.len, bg.loc, bg.scale, bg.shape)
}
\arguments{
\item{scores}{affinity scores for the PWMs, can contain scores for more than one sequence (as rows), P-values are extracted separately}

\item{seq.len}{the length distribution of the sequences}

\item{pwm.len}{the lengths of PWMs}

\item{bg.loc}{list of linear regression for location parameter}

\item{bg.scale}{list of linear regression for scale parameter}

\item{bg.shape}{list of linear regression for shape parameter}
}
\description{
Apply GEV background normalization per every sequence
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{logNormPvalSequenceSet}
\alias{logNormPvalSequenceSet}
\title{Lognormal P-value for a set of sequences}
\usage{
logNormPvalSequenceSet(scores, seq.len, pwm.len, bg.mean, bg.sd, bg.len)
}
\arguments{
\item{scores}{a matrix of per-sequence affinity scores}

\item{seq.len}{lengths of sequences}

\item{pwm.len}{lengths of pwms}

\item{bg.mean}{mean background at length of bg.len}

\item{bg.sd}{standard deviation of background at length of bg.len}

\item{bg.len}{the length for which mean and sd are calculated}
}
\value{
P-value
}
\description{
Lognormal P-value for a set of sequences
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/background.R
\name{makePWMLognBackground}
\alias{makePWMLognBackground}
\title{Make a lognormal background distribution}
\usage{
makePWMLognBackground(
  bg.seq,
  motifs,
  bg.pseudo.count = 1,
  bg.len = 250,
  bg.len.sizes = 2^(0:4),
  bg.source = "",
  verbose = TRUE,
  algorithm = "default"
)
}
\arguments{
\item{bg.seq}{a set of background sequences, either a list of DNAString object or DNAStringSet object}

\item{motifs}{a set of motifs, either a list of frequency matrices, or a list of PWM objects. If
frequency matrices are given, the background distribution is fitted from bg.seq.}

\item{bg.pseudo.count}{the pseudo count which is shared between nucleotides when frequency matrices are given}

\item{bg.len}{background sequences will be split into tiles of this length (default: 250bp)}

\item{bg.len.sizes}{background tiles will be joined into bigger tiles containing this much smaller tiles. 
The default is \code{2^(0:4)}, which with \code{bg.len} translates into 
250bp, 500bp, 1000bp, 1500bp, 2000bp, 4000bp. Note this is only used in the "human" algorithm.}

\item{bg.source}{a free-form textual description of how the background was generated}

\item{verbose}{if to produce verbose output}

\item{algorithm}{type of algorithm to use, valid values are: "default" and "human".}
}
\description{
Construct a lognormal background distribution for a set of sequences. 
Sequences concatenated are binned in 'bg.len' chunks and lognormal distribution 
fitted to them.
}
\examples{
\dontrun{
if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   data(MotifDb.Dmel.PFM, package = "PWMEnrich.Dmelanogaster.background")

   # make background for MotifDb motifs using 2kb promoters of all D. melanogaster transcripts 
	  if(requireNamespace("BSgenome.Dmelanogaster.UCSC.dm3")) 
     makePWMLognBackground(Dmelanogaster$upstream2000, MotifDb.Dmel.PFM)
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PWMBackground-methods.R
\name{[,PWMEmpiricalBackground-method}
\alias{[,PWMEmpiricalBackground-method}
\title{Get the background for a subset of PWMs}
\usage{
\S4method{[}{PWMEmpiricalBackground}(x, i, j, ..., drop = TRUE)
}
\arguments{
\item{x}{the PWMEmpiricalBackground object}

\item{i}{the indicies of PWMs}

\item{j}{unused}

\item{...}{unused}

\item{drop}{unused}
}
\description{
Get the background for a subset of PWMs
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{motifScores}
\alias{motifScores}
\title{Motif affinity or number of hits over a threshold}
\usage{
motifScores(
  sequences,
  motifs,
  raw.scores = FALSE,
  verbose = TRUE,
  cutoff = NULL
)
}
\arguments{
\item{sequences}{a set of sequences to be scanned, a list of DNAString or other scannable objects}

\item{motifs}{a list of motifs either as frequency matrices (PFM) or as PWM objects. If PFMs are specified
they are converted to PWMs using uniform background.}

\item{raw.scores}{if to return raw scores (odds) for each position in the sequence. Note that scores for forward and reverse 
strand are concatenated into a single long vector of scores (twice the length of the sequence)}

\item{verbose}{if to print verbose output}

\item{cutoff}{if not NULL, will count number of matches with score above value specified (instead of returning the average affinity). 
Can either be one value, or a vector of values for each of the motifs.}
}
\value{
if raw.scores=FALSE, returns a matrix of mean scores (after cutoff if any), where columns are motifs. 
        The returned values are either mean odd scores (not log-odd), or number of hits above a threshold;
        otherwise if raw.scores=TRUE, returns a list of raw score values (before cutoff)
}
\description{
Scan a number of sequences either to find overall affinity, or a number of hits over a score threshold.
}
\examples{

if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   data(MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")

   # affinity scores
   affinity = motifScores(DNAString("CGTAGGATAAAGTAACTAGTTGATGATGAAAG"), MotifDb.Dmel)
   
   # motif hit count with Patser score of 4
   counts = motifScores(DNAString("CGTAGGATAAAGTAACTAGTTGATGATGAAAG"), MotifDb.Dmel, 
     cutoff=log2(exp(4)))
   
   print(affinity)
   print(counts)

   # scanning multiple sequences
   sequences = list(DNAString("CGTAGGATAAAGTAACTAGTTGATGATGAAAG"), 
     DNAString("TGAGACGAAGGGGATGAGATGCGGAAGAGTGAAA"))
   affinity2 = motifScores(sequences, MotifDb.Dmel)
   print(affinity2)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MotifEnrichmentResults-methods.R
\name{rankingProcessAndReturn}
\alias{rankingProcessAndReturn}
\title{A helper function for motifRankingForGroup and motifRankingForSequence with the common code}
\usage{
rankingProcessAndReturn(res, r, id, order, rank, unique, decreasing)
}
\arguments{
\item{res}{the list of results from MotifEnrichmentResults object}

\item{r}{the vector of raw results that needs to be processed}

\item{id}{if to return IDs instead of names}

\item{order}{if to return the ordering of motifs}

\item{rank}{if to return the rank of motifs}

\item{unique}{if to remove duplicates}

\item{decreasing}{specifies the sorting order}
}
\description{
A helper function for motifRankingForGroup and motifRankingForSequence with the common code
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllDataClasses.R
\docType{class}
\name{MotifEnrichmentResults-class}
\alias{MotifEnrichmentResults-class}
\title{A wrapper class for results of motifEnrichment() that should make it easier to access the results.}
\description{
Note that this is only a wrapper around a list which is the return value in PWMEnrich 1.3 and as such it
provides the same interface as a list (for backward compatibility), with some additional methods.
}
\section{Slots}{
 
 \describe{
   \item{\code{res}:}{a list of old results with elements such as: sequence.bg, sequence.nobg, group.bg, group.nobg}
 }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{matrixShuffleZscorePerSequence}
\alias{matrixShuffleZscorePerSequence}
\title{Obtain z-score for motif column shuffling}
\usage{
matrixShuffleZscorePerSequence(scores, sequences, pwms, cutoff = NULL, B = 30)
}
\arguments{
\item{scores}{a set of already calculated scores}

\item{sequences}{either one sequence or a list/set of sequences (objects of type DNAString or DNAStringSet)}

\item{pwms}{a list of PWMs}

\item{cutoff}{if NULL, will use affinity, otherwise will use number of hits over this log2 odds cutoff}

\item{B}{number of replicates, i.e. PWM column shuffles}
}
\description{
All PWMs are shuffled at the same time. This function would be too slow to produce
empirical P-values, thus we return a z-score from a small number of shuffles.
}
\details{
The z-scores are calculated for each sequence individually.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MotifEnrichmentResults-methods.R
\name{show,MotifEnrichmentResults-method}
\alias{show,MotifEnrichmentResults-method}
\title{show method for MotifEnrichmentResults}
\usage{
\S4method{show}{MotifEnrichmentResults}(object)
}
\arguments{
\item{object}{the MotifEnrichmentResults object}
}
\description{
show method for MotifEnrichmentResults
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{affinitySequenceSet}
\alias{affinitySequenceSet}
\title{Calculate total affinity over a set of sequences}
\usage{
affinitySequenceSet(scores, seq.len, pwm.len)
}
\arguments{
\item{scores}{affinity scores for individual sequences}

\item{seq.len}{lengths of sequences}

\item{pwm.len}{lengths of PWMs}
}
\description{
Calculate total affinity over a set of sequences
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{motifScoresBigMemory}
\alias{motifScoresBigMemory}
\title{This is a memory intensive version of motifScore() which is about 2 times faster}
\usage{
motifScoresBigMemory(
  sequences,
  motifs,
  raw.scores = FALSE,
  verbose = TRUE,
  cutoff = NULL,
  seq.all = NULL
)
}
\arguments{
\item{sequences}{set of input sequences}

\item{motifs}{set of input PWMs or PFMs}

\item{raw.scores}{if to return scores for each base-pair}

\item{verbose}{if to produce verbose output}

\item{cutoff}{the cutoff for calling binding sites (in base 2 log).}

\item{seq.all}{already concatenated sequences if already available (used to internally speed up things)}
}
\description{
The parameters and functionality are the same as \code{\link{motifScores}}. Please refer to documentation of this function
for detailed explanation of functionality.
}
\details{
This function is not meant to be called directly, but is indirectly called by motifScores() once a global parameters useBigMemory is set.
}
\seealso{
\code{\link{motifScores}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readData.R
\name{readJASPAR}
\alias{readJASPAR}
\title{Read motifs in JASPAR format}
\usage{
readJASPAR(file, remove.ids = FALSE)
}
\arguments{
\item{file}{the filename}

\item{remove.ids}{if to strip JASPAR ID's from motif names, e.g. "MA0211.1 bap" would become just "bap"}
}
\value{
a list of matrices representing motifs (with four nucleotides as rows)
}
\description{
Read motifs in JASPAR format
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MotifEnrichmentResults-methods.R
\name{plotTopMotifsGroup,MotifEnrichmentResults-method}
\alias{plotTopMotifsGroup,MotifEnrichmentResults-method}
\alias{plotTopMotifsGroup}
\title{Plot the top N enrichment motifs in a group of sequences}
\usage{
\S4method{plotTopMotifsGroup}{MotifEnrichmentResults}(obj, n, bg = TRUE, id = FALSE, ...)
}
\arguments{
\item{obj}{a MotifEnrichmentResults object}

\item{n}{the number of top ranked motifs to plot}

\item{bg}{if to use background corrected P-values to do the ranking (if available)}

\item{id}{if to show PWM IDs instead of target TF names}

\item{...}{other parameters passed to \code{plotMultipleMotifs()}}
}
\description{
Plot the top N enrichment motifs in a group of sequences
}
\examples{
if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   ###
   # load the pre-compiled lognormal background
   data(PWMLogn.dm3.MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")

   # scan two sequences for motif enrichment
   sequences = list(DNAString("GAAGTATCAAGTGACCAGTAAGTCCCAGATGA"), 
     DNAString("AGGTAGATAGAACAGTAGGCAATGAAGCCGATG"))

   res = motifEnrichment(sequences, PWMLogn.dm3.MotifDb.Dmel)

   # plot the top 4 motifs in a 2x2 grid
   plotTopMotifsGroup(res, 4)

   # plot top 3 motifs in a single row
   plotTopMotifsGroup(res, 3, row=1, cols=3)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllDataClasses.R
\docType{class}
\name{PWMLognBackground-class}
\alias{PWMLognBackground-class}
\title{Lognormal background distribution for a set of PWMs}
\description{
Lognormal background distribution for a set of PWMs
}
\section{Slots}{
 
 \describe{
   \item{\code{bg.source}:}{textual description of where the background distribution is derived from}
   \item{\code{bg.len}:}{the length to which the background is normalized to. This is a vector of values, can have a different value for each motif.}
   \item{\code{bg.mean}:}{the mean value of the lognormal distribution at bg.len}
   \item{\code{bg.sd}:}{the standard deviation of the lognormal distribution at bg.len}
   \item{\code{pwms}:}{the pwms for which the background has been compiled}
 }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/misc.R
\name{concatenateSequences}
\alias{concatenateSequences}
\title{Concatenata DNA sequences into a single character object}
\usage{
concatenateSequences(sequences)
}
\arguments{
\item{sequences}{either a list of DNAString objects, or a DNAStringSet}
}
\value{
a single character string
}
\description{
Concatenata DNA sequences into a single character object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MotifEnrichmentResults-methods.R
\name{groupReport,MotifEnrichmentResults-method}
\alias{groupReport,MotifEnrichmentResults-method}
\alias{groupReport}
\title{Generate a motif enrichment report for the whole group of sequences together}
\usage{
\S4method{groupReport}{MotifEnrichmentResults}(obj, top = 0.05, bg = TRUE, by.top.motifs = FALSE, ...)
}
\arguments{
\item{obj}{a MotifEnrichmentResults object}

\item{top}{what proportion of top motifs should be examined in each individual sequence (by default 0.05, i.e. 5\%)}

\item{bg}{if to use background corrected P-values to do the ranking (if available)}

\item{by.top.motifs}{if to rank by the proportion of sequences where the motif is within 'top' percentage of motifs}

\item{...}{unused}
}
\value{
a MotifEnrichmentReport object containing a table with the following columns: 
\itemize{
   \item 'rank' - The rank of the PWM's enrichment in the whole group of sequences together
   \item 'target' - The name of the PWM's target gene, transcript or protein complex. 
   \item 'id' - The unique identifier of the PWM (if set during PWM creation).
   \item 'raw.score' - The raw score before P-value calculation
   \item 'p.value' - The P-value of motif enrichment (if available)
   \item 'top.motif.prop' - The proportion (between 0 and 1) of sequences where the motif is within \code{top} proportion of enrichment motifs. 
}
}
\description{
Generate a motif enrichment report for the whole group of sequences together
}
\examples{
if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
   ###
   # load the pre-compiled lognormal background
   data(PWMLogn.dm3.MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")

   # scan two sequences for motif enrichment
   sequences = list(DNAString("GAAGTATCAAGTGACCAGTAAGTCCCAGATGA"), 
     DNAString("AGGTAGATAGAACAGTAGGCAATGAAGCCGATG"))

   res = motifEnrichment(sequences, PWMLogn.dm3.MotifDb.Dmel)

   # produce a report for all sequences taken together
   r.default = groupReport(res)

   # produce a report where the last column takes top 1\% motifs
   r = groupReport(res, top=0.01)

   # view the results
   r

   # plot the top 10 most enriched motifs
   plot(r[1:10])

}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diff.R
\name{motifDiffEnrichment}
\alias{motifDiffEnrichment}
\title{Differential motif enrichment}
\usage{
motifDiffEnrichment(
  sequences1,
  sequences2,
  pwms,
  score = "autodetect",
  bg = "autodetect",
  cutoff = log2(exp(4)),
  verbose = TRUE,
  res1 = NULL,
  res2 = NULL
)
}
\arguments{
\item{sequences1}{First set of sequences. Can be either a single sequence 
(an object of class DNAString), or a list of DNAString objects, or a DNAStringSet object.}

\item{sequences2}{Second set of sequences. Can be either a single sequence 
(an object of class DNAString), or a list of DNAString objects, or a DNAStringSet object.}

\item{pwms}{this parameter can take multiple values depending on the scoring scheme and background correction used.
     When the \code{method} parameter is set to "autodetect", the following default algorithms
     are going to be used: 
\itemize{
   \item if \code{pwms} is a list containing either frequency matrices or a list of PWM objects then
         the "affinity" algorithm is selected. If frequency matrices are given, they are converted 
         to PWMs using uniform background. For best performance, convert frequency matrices to PWMs
         before calling this function using realistic genomic background. 
   \item Otherwise, appropriate scoring scheme and background correction are selected based on the
         class of the object (see below). 
}}

\item{score}{this parameter determines which scoring scheme to use. Following scheme as available:
\itemize{
   \item "autodetect" - default value. Scoring method is determined based
         on the type of \code{pwms} parameter. 
   \item "affinity" - use threshold-free affinity scores without a background. The \code{pwms}
         parameter can either be a list of frequency matrices, \code{PWM} objects, or a 
         \code{PWMLognBackground} object. 
   \item "cutoff" - use number of motif hits above a score cutoff as a measure of enrichment. 
         No background correction is performed. The \code{pwms}
         parameter can either be a list of frequency matrices, \code{PWM} objects, or a 
         \code{PWMCutoffBackground} object.
 }}

\item{bg}{this parameter determines which background correction to use, if any. 
\itemize{
   \item "autodetect" - default value. Background correction is determined based on the type
          of the \code{pwms} parameter. 
   \item "logn" - use a lognormal distribution background pre-computed for a set of PWMs.
         This requires \code{pwms} to be of class \code{PWMLognBackground}.
   \item "z" - use a z-score for the number of significant motif hits compared to background number of hits.
         This requires \code{pwms} to be of class \code{PWMCutoffBackground}.
   \item "none" - no background correction
 }}

\item{cutoff}{the score cutoff for a significant motif hit if scoring scheme "cutoff" is selected.}

\item{verbose}{if to produce verbose output}

\item{res1}{the output of \code{motifEnrichment} if already calculated for \code{sequences1}}

\item{res2}{the output of \code{motifEnrichment} if already calculated for \code{sequences2}}
}
\description{
Test for differential enrichment between two groups of sequences
}
\details{
This function calls \code{motifEnrichment} on two groups of sequences and calculates
the difference statistics when possible.
}
\examples{

if(requireNamespace("PWMEnrich.Dmelanogaster.background")){
  # load the background file for drosophila and lognormal correction
  data(PWMLogn.dm3.MotifDb.Dmel, package = "PWMEnrich.Dmelanogaster.background")

  # get the differential enrichment
  diff = motifDiffEnrichment(DNAString("TGCATCAAGTGTGTAGTGTGAGATTAGT"), 
    DNAString("TGAACGAGTAGGACGATGAGAGATTGATG"), PWMLogn.dm3.MotifDb.Dmel, verbose=FALSE)

  # motifs differentially enriched in the first sequence (with lognormal background correction)
  head(sort(diff$group.bg, decreasing=TRUE))

  # motifs differentially enriched in the second sequence (with lognormal background correction)
  head(sort(diff$group.bg))
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PWM-methods.R
\name{names,PWM}
\alias{names,PWM}
\alias{names,PWM-method}
\alias{$,PWM-method}
\alias{length,PWM-method}
\title{Names of variables}
\usage{
\S4method{names}{PWM}(x)

\S4method{$}{PWM}(x, name)

\S4method{length}{PWM}(x)
}
\arguments{
\item{x}{the PWM object}

\item{name}{the variable name}
}
\value{
the names of the variables
}
\description{
Name of different pieces of information associated with PWM

Returns the motif length, i.e. the number of columns in the PWM.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/background.R
\name{makePriors}
\alias{makePriors}
\title{Make priors from background sequences}
\usage{
makePriors(bg.seq, bg.pseudo.count)
}
\arguments{
\item{bg.seq}{a set of background sequences}

\item{bg.pseudo.count}{the total pseudocount shared between nucleotides}
}
\description{
These priors serve both as background nucleotide frequencies and pseudo-counts
for PWMs.
}
\examples{
# some example sequences
sequences = list(DNAString("AAAGAGAGTGACCGATGAC"), DNAString("ACGATGAGGATGAC"))
# make priors with pseudo-count of 1 shared between them
makePriors(sequences, 1)
}
